;// Generated by CoffeeScript 1.7.1
(function() {
    var MODULE_NAME, SLIDER_TAG, angularize, halfWidth, inputEvents, module, offset, offsetLeft, pixelize, qualifiedDirectiveDefinition, roundStep, sliderDirective, width;

    MODULE_NAME = 'ui.slider';

    SLIDER_TAG = 'slider';

    angularize = function(element) {
        return angular.element(element);
    };

    offset = function(element, position) {
        var translate = 'translate(' + position + 'px)';
        element.css({
            //left: '' + position + 'px'
            //transform: translate,
            '-webkit-transform': translate,
        });
    };

    halfWidth = function(element) {
        return element[0].offsetWidth / 2;
    };

    width = function(element) {
        return element[0].offsetWidth;
    };

    roundStep2 = function(value, precision, step, minValue, maxValue) {
        var integerPart = Math.round(value / step) * step;
        return Math.max(minValue, Math.min(maxValue, integerPart));
    };

    roundStep = function(value, precision, step, floor) {
        var decimals, remainder, roundedValue, steppedValue;

        remainder = (value - floor) % step;
        steppedValue = remainder > (step / 2) ? value + step - remainder : value - remainder;
        decimals = Math.pow(10, precision);
        roundedValue = steppedValue * decimals / decimals;
        return roundedValue.toFixed(precision);
    };

    inputEvents = {
        mouse: {
            start: 'mousedown',
            move: 'mousemove',
            end: 'mouseup'
        },
        touch: {
            start: 'touchstart',
            move: 'touchmove',
            end: 'touchend'
        }
    };

    sliderDirective = function($timeout) {
        return {
            restrict: 'E',
            scope: {
                floor: '@',
                ceiling: '@',
                values: '=',
                step: '@',
                precision: '@',
                buffer: '@',
                ngModelLow: '=',
                ngModelHigh: '='
            },

            // Template that uses hierarchy to speedup updates
            //template: '<div class="slider-bar"><div class="selection"></div></div>\n<div class="handle low"><div class="bubble value low">{{ values.length ? ( values[local.ngModelLow || local.ngModel] || local.ngModelLow || local.ngModel ) : local.ngModelLow || local.ngModel || 0}}</div>\n</div><div class="handle high">\n<div class="bubble value high">{{ values.length ? ( values[local.ngModelHigh] || local.ngModelHigh ) : local.ngModelHigh }}</div></div>\n<div class="bubble limit low">{{ values.length ? ( values[floor || 0] || floor ) : floor }}</div>\n<div class="bubble limit high">{{ values.length ? ( values[ceiling || values.length - 1] || ceiling ) : ceiling }}</div>',

            template: '<div class="slider-bar"><div class="selection"></div></div>\n<div class="handle low"></div><div class="handle high"></div>\n<div class="bubble limit low">{{ values.length ? ( values[floor || 0] || floor ) : floor }}</div>\n<div class="bubble limit high">{{ values.length ? ( values[ceiling || values.length - 1] || ceiling ) : ceiling }}</div>\n<div class="bubble value low">{{ values.length ? ( values[local.ngModelLow || local.ngModel] || local.ngModelLow || local.ngModel ) : local.ngModelLow || local.ngModel || 0}}</div>\n<div class="bubble value high">{{ values.length ? ( values[local.ngModelHigh] || local.ngModelHigh ) : local.ngModelHigh }}</div>',

            compile: function(element, attributes) {
                var bar, e, flrBub, high, highBub, low, lowBub, maxPtr, minPtr, selection, _i, _len, _ref, _ref1;
                _ref = (function() {
                    var _i, _len, _ref, _results;
                    _ref = element.children();
                    _results = [];
                    for (_i = 0, _len = _ref.length; _i < _len; _i++) {
                        e = _ref[_i];
                        _results.push(angularize(e));
                    }
                    return _results;
                })(), bar = _ref[0], minPtr = _ref[1], maxPtr = _ref[2], flrBub = _ref[3], lowBub = _ref[5], highBub = _ref[6];
                selection = angularize(bar.children()[0]);
                
                return {
                    post: function(scope, element, attributes) {

                        var barWidth, boundToInputs, dimensions, handleHalfWidth, maxOffset, 
                            maxValue, minOffset, minValue, ngDocument, offsetRange, 
                            updateDOM, valueRange, w, _j, _len1;
                        
                        scope.local = {
                            ngModelLow: parseInt(scope.ngModelLow),
                            ngModelHigh: parseInt(scope.ngModelHigh)
                        };
                        
                        boundToInputs = false;
                        ngDocument = angularize(document);
                        handleHalfWidth = barWidth = minOffset = maxOffset = minValue = maxValue = valueRange = offsetRange = void 0;
                        
                        dimensions = function() {
                            var value, _j, _len1, _ref2;

                            scope.step = (!scope.step)? 1 : scope.step;
                            scope.floor = (!scope.floor)? 0 : scope.floor;
                            scope.precision = (!scope.precision)? 0 : scope.precision;
                            scope.ceiling = (!scope.ceiling)? 10000 : scope.ceiling;

                            scope.local.ngModelLow = scope.ngModelLow;
                            scope.local.ngModelHigh = scope.ngModelHigh;

                            handleHalfWidth = halfWidth(minPtr);
                            barWidth = width(bar);
                            minOffset = 0;
                            maxOffset = barWidth - width(minPtr);
                            minValue = parseFloat(scope.floor);
                            maxValue = parseFloat(scope.ceiling);
                            valueRange = maxValue - minValue;

                            offsetRange = maxOffset - minOffset;
                        };

                        updateDOM = function() {
                            var bindToInputEvents, percentOffset, percentToOffset, percentValue, setBindings, setPointers;
                            
                            var pointerUpdateCount = 0;
                            dimensions();
                            
                            percentOffset = function(offset) {
                                return ((offset - minOffset) / offsetRange) * 100;
                            };
                            percentValue = function(value) {
                                return ((value - minValue) / valueRange) * 100;
                            };
                            percentToOffset = function(percent) {
                                return percent * offsetRange * 0.01;
                            };
                            setPointers = function(selectedItem) {
                                var newLowValue = percentValue(scope.local.ngModelLow);
                                var newHighValue = percentValue(scope.local.ngModelHigh);

                                // First update
                                if (selectedItem !== null) {
                                    if (selectedItem === 'ngModelLow') {
                                        var minPtrValue = percentToOffset(newLowValue);
                                        offset(minPtr, minPtrValue);
                                        // This can beremoved by placing this div inside of minPtr
                                        offset(lowBub, minPtrValue - halfWidth(lowBub) + 0.5*handleHalfWidth);
                                    }
                                    else if (selectedItem === 'ngModelHigh') {
                                        var maxPtrValue = percentToOffset(newHighValue);
                                        offset(maxPtr, maxPtrValue);
                                        // This can beremoved by placing this div inside of maxPtr
                                        offset(highBub, maxPtrValue - halfWidth(highBub) + 1.5*handleHalfWidth);
                                    }

                                    // Update frameskip for performance
                                    pointerUpdateCount++;
                                    if (pointerUpdateCount >= 2) {
                                        pointerUpdateCount = 0;

                                        var translate = 'translate(' + (percentToOffset(newLowValue) + 10) + 'px)';
                                        selection.css({
                                            //transform: translate,
                                            '-webkit-transform': translate,
                                            //left: offsetLeft(minPtr) + handleHalfWidth + 'px',
                                            width: (percentToOffset(newHighValue - newLowValue + 5)) + 'px'
                                        });
                                    }
                                }
                                else {
                                    var minPtrValue = percentToOffset(newLowValue);
                                    offset(minPtr, minPtrValue);
                                    offset(lowBub, minPtrValue - halfWidth(lowBub) + 0.5*handleHalfWidth);

                                    var maxPtrValue = percentToOffset(newHighValue);
                                    offset(maxPtr, maxPtrValue);
                                    offset(highBub, maxPtrValue - halfWidth(highBub) + 1.5*handleHalfWidth);

                                    var translate = 'translate(' + (percentToOffset(newLowValue) + 10) + 'px)';
                                    selection.css({
                                        //transform: translate,
                                        '-webkit-transform': translate,
                                        //left: offsetLeft(minPtr) + handleHalfWidth + 'px',
                                        width: (percentToOffset(newHighValue - newLowValue + 5)) + 'px'
                                    });
                                }
                            };
                            bindToInputEvents = function(handle, bubble, ref, events) {
                                var currentRef = ref;

                                var onEnd = function() {
                                    handle.unbind(events.move, onMove);
                                    scope.ngModelLow = scope.local.ngModelLow;
                                    scope.ngModelHigh = scope.local.ngModelHigh;
                                };

                                var onMove = function(event) {
                                    var eventX, newOffset, newPercent, newValue;
                                    eventX = event.clientX || event.touches[0].clientX;
                                    newOffset = eventX - element[0].getBoundingClientRect().left - handleHalfWidth;
                                    newOffset = Math.max(Math.min(newOffset, maxOffset), minOffset);
                                    newPercent = percentOffset(newOffset);
                                    newValue = minValue + (valueRange * newPercent * 0.01);

                                    var stepValue = parseFloat(scope.step);
                                    var precisionValue = parseInt(scope.precision);
                                    var bufferValue = parseInt(scope.buffer);
                                    var needToUpdateBoth = false;

                                    if (currentRef === 'ngModelLow') {
                                        if (newValue > scope.local.ngModelHigh - bufferValue) {
                                            //newValue = scope.local.ngModelHigh - bufferValue;
                                            if (scope.local.ngModelHigh >= maxValue)
                                                return;
                                            needToUpdateBoth = true;
                                        }
                                    } else {
                                        if (newValue < scope.local.ngModelLow + bufferValue) {
                                            //newValue = scope.local.ngModelLow + bufferValue;

                                            if (scope.local.ngModelLow <= minValue)
                                                return;
                                            needToUpdateBoth = true;
                                        }
                                    }

                                    newValue = roundStep2(newValue, precisionValue, stepValue, minValue, maxValue);
                                    scope.local[currentRef] = newValue;
                                    
                                    // Update both knobs
                                    if (needToUpdateBoth) {
                                        if (currentRef === 'ngModelLow') {
                                            scope.local.ngModelHigh = roundStep2(newValue+bufferValue+0.5*stepValue, precisionValue, stepValue, minValue, maxValue);
                                        }
                                        else {
                                            scope.local.ngModelLow = roundStep2(newValue-bufferValue-0.5*stepValue, precisionValue, stepValue, minValue, maxValue);
                                        }
                                        setPointers(null);
                                    } else {
                                        setPointers(currentRef);
                                    }
                                    
                                    scope.$apply();
                                };

                                var onStart = function(event) {
                                    event.stopPropagation();
                                    event.preventDefault();
                                    handle.bind(events.move, onMove);
                                };

                                handle.bind(events.start, onStart);
                                ngDocument.bind(events.end, onEnd);
                            };

                            if (!boundToInputs) {
                                boundToInputs = true;                                
                                
                                // Only needed on PC
                                bindToInputEvents(minPtr, lowBub, 'ngModelLow', inputEvents['mouse']);
                                bindToInputEvents(maxPtr, highBub, 'ngModelHigh', inputEvents['mouse']);
                                bindToInputEvents(minPtr, lowBub, 'ngModelLow', inputEvents['touch']);
                                bindToInputEvents(maxPtr, highBub, 'ngModelHigh', inputEvents['touch']);
                            }

                            setPointers(null);
                        };

                        $timeout(updateDOM);
                        window.addEventListener("resize", updateDOM);
                    }
                };
            }
        };
    };

    qualifiedDirectiveDefinition = ['$timeout', sliderDirective];

    module = function(window, angular) {
        return angular.module(MODULE_NAME, []).directive(SLIDER_TAG, qualifiedDirectiveDefinition);
    };

    module(window, window.angular);

}).call(this);
