require('./stateProvider.js');
require('./controllers.js');
require('./directives.js');
require('./filters.js');
require('./services.js');
require('./calendar.js');


angular.module('app', [
  'ionic',
  'ngCordova',
  'app.controllers',
  'app.components',
  'app.filters',
  'app.directives',
  'app.services',
  'app.statesProvider',
  'angularCharts',
  'templates',
  'ui.utils.masks',
  'ngIOS9UIWebViewPatch',
  'angucomplete-alt',
  'pascalprecht.translate',
  'tmh.dynamicLocale',
  'LocalForageModule'
])

// DEBUG
//.constant('APP_URL', "http://wsdemo.azurewebsites.net/api/")
// RELEASE
// .constant('APP_URL', "http://onebetaservice.azurewebsites.net/api/")
// TRADUCAO
.constant('APP_URL', "https://onebetaservice-traducao.azurewebsites.net/api/")
// .constant('APP_URL', "https://onehomologacao.azurewebsites.net/api/")
.constant('APP_URL_NEW', "https://oneapimobilidade.azurewebsites.net/api/")
// .constant('APP_URL_NEW', "https://oneapimobilidade-preprod.azurewebsites.net/api/")


// .constant('APP_URL_NEW', "http://localhost:9875/api/")

.constant('IMG', "https://onebelezamobile.azurewebsites.net/img")
// .constant('IMG', "img")



.run(function($ionicPlatform, $window, $rootScope , $cordovaToast , $cordovaCalendar , UserApi , $ionicPopup, $window, AvaliaServico, IMG, DEALER, BannerApi, $sce) {
  $ionicPlatform.ready(function () {
    //if (cordova.platformId != 'ios') DEALER.anonimous = null;

    //$window.localStorage.clear();
    if (window.cordova && window.cordova.plugins && window.cordova.plugins.Keyboard) {
      cordova.plugins.Keyboard.hideKeyboardAccessoryBar(false);

      /*navigator.appInfo.getAppInfo(function(appInfo) {
        if (appInfo.identifier == 'com.mmtools.oneBeleza') {
          $ionicPopup.show({
            title: 'Atualizar aplicativo',
            subTitle: 'Seu aplicativo está desatualizado, clique no botão abaixo para atualizar. Caso não atualize, algumas funcionalidades podem apresentar um comportamento inesperado.',
            buttons: [{
              text: 'Atualizar',
              type: 'button-positive',
              onTap: function(e) {
                cordova.plugins.market.open('com.mmtools.oneBeleza')
              }
            }] 
          });
        }
      }, function(error) {
        alert(error);
      });*/

     
  
    }



    if(window.StatusBar) {
      // org.apache.cordova.statusbar required
      StatusBar.styleLightContent();
    }

    if ( typeof PushNotification !== 'undefined' ) {

      // Channel creation only required for Android 7+ (Nougat and Oreo currently)
      try {
        if (cordova.platformId == 'android') {
          PushNotification.createChannel(
            {
              id: 'accesscontrolmessage',
              description: 'push notifications channel description here',
              importance: 5,
              sound: 'default'
            }
          , function (res) {
            console.log('PushServiceProvider::configuration - Channel created: ', res);
            // Return a list of currently configured channels (should be one due to init() use
            PushNotification.listChannels(function (channels) {
              console.log('List of channels: ', channels)
            });
          })
        } else {
          // console.warn('Home::pushSetup - Not identified as an android device, skipping channel creation');
        }
      } catch (e) {}

      var push = PushNotification.init({
        "android": {"senderID": "918229014460",
                     "forceShow": true 
                    
                    },
        "ios": {
          "alert": "true",
          "badge": "true",
          "sound": "true",
          "categories": {
            "invite": {
              "yes": {
                "callback": "AvaliaServico", "title": "Avaliar agora", "foreground": true, "destructive": false
              },
              "no": {
                "callback": "window.accept", "title": "Avaliar depois", "foreground": false, "destructive": false
              },
              // "maybe": {
              //   "callback": "window.maybe", "title": "Maybe", "foreground": true, "destructive": false
              // }
            },
            "delete": {
              "yes": {
                "callback": "DeleteAgenda", "title": "Delete", "foreground": false, "destructive": false
              },
            },
            "insert": {
              "yes": {
                "callback": "InsereAgenda", "title": "Marcar na agenda", "foreground": false, "destructive": false
              },
              "no": {
                "callback": "cancel", "title": "Ignorar", "foreground": false, "destructive": false
              },
              // "maybe": {
              //   "callback": "window.maybe", "title": "Maybe", "foreground": true, "destructive": false
              // }
            },
          }
        },
        "windows": {},
        'browser': {
          'applicationServerKey': ''
        }
      });

      window.accept = function(data) {
        console.log(123);
        console.log(JSON.stringify(data.additionalData.parameters));
        //{"salao":"MMtools - Ambiente de Demonstração","id":1,"servicos":[{"id":1,"label":"Colaborador 1"},{"id":2,"label":"Colaborador 3"},{"id":3,"label":"Higiene"}]}
        AvaliaServico(data.additionalData.parameters);
      };

      push.on('registration', function(data) {
        // console.log( ionic.Platform.isIOS());
        console.log( JSON.stringify(data) );
        Chave = data.registrationId;
        //pode ser "Google", "Apple", ou "Windows"
        Dispositivo = ionic.Platform.isIOS() ? 'Apple' :
                      ionic.Platform.isAndroid() ? 'Google' :
                      ionic.Platform.isWindowsPhone() ? 'Windows' : '';
      });

      window.InsereAgenda = function (data) {
        var agendamento = data;

        //alert(JSON.stringify(data));
        //debugger;

        var startDate = Date.ddmmyyyy( agendamento.dataAgenda.replace(' 00:00:00', '') );
        startDate.sethhmm( agendamento.horarioInicio );

        var endDate = Date.ddmmyyyy( agendamento.dataAgenda.replace(' 00:00:00', '') );
        endDate.sethhmm( agendamento.horarioFim );

        $cordovaCalendar.createCalendar({
          calendarName: DEALER.description,
          calendarColor: DEALER.colorRGB
        }).then(function (result) {
          // console.log('result: ' + result);
          $cordovaCalendar.createEventInteractively({
            title: agendamento.servicos,
            location: agendamento.salao,
            notes: agendamento.colaborador,
            startDate: startDate,
            endDate: endDate,
            firstReminderMinutes: 30,
            secondReminderMinutes: 120,
            calendarName: DEALER.description,
          }).then(function (result) { //alert(JSON.stringify(result));
            // console.log(JSON.stringify(result));
            // success
            popup.alert("Evento criado com sucesso");
          }, function (err) { //alert('error:'+ err );
            // console.log(JSON.stringify(err));
            // error
          });
        }, function (err) {
          // alert('erro: ' + err);
          // error
        });
      };



      window.DeleteAgenda = function (data) {
        var agendamento = data;

        //alert(JSON.stringify(data));
        //debugger;

        var startDate = Date.ddmmyyyy( agendamento.dataAgenda.replace(' 00:00:00', '') );
        startDate.sethhmm( agendamento.horarioInicio );

        var endDate = Date.ddmmyyyy( agendamento.dataAgenda.replace(' 00:00:00', '') );
        endDate.sethhmm( agendamento.horarioFim );

        $cordovaCalendar.deleteCalendar({
          calendarName: DEALER.description,
          calendarColor: DEALER.colorRGB
        }).then(function (result) {
          // console.log('result: ' + result);
          $cordovaCalendar.deleteEvent({
            title: agendamento.servicos,
            location: agendamento.salao,
            notes: agendamento.colaborador,
            startDate: startDate,
            endDate: endDate,
            calendarName: DEALER.description,
          }).then(function (result) { //alert(JSON.stringify(result));
            // console.log(JSON.stringify(result));
            // 
            popup.alert("Evento excluido com sucesso");
          }, function (err) { //alert('error:'+ err );
            // console.log(JSON.stringify(err));
            // error
          });
        }, function (err) {
          // alert('erro: ' + err);
          // error
        });
      };

      push.on('notification', function(event) {
          // data.message,
          // data.title,
          // data.count,
          // data.sound,
          // data.image,
          // data.additionalData

          // console.log('--notification--');
          // console.log(JSON.stringify(event));

          //alert(JSON.stringify(event));

          try {
           
            var action = event.additionalData.actions.filter(function(action) {
              return action.callback === 'AvaliaServico'
            })[0];
          } catch (e) {
            action = event.additionalData;
          }

          // console.log('action:');
          // console.log(JSON.stringify(action));

          if (action && action.category == 'insert') {
            window.InsereAgenda(action.parameters);
          } else if (action ) {
            AvaliaServico(action.parameters);
          } else {
              window.plugins.toast.showWithOptions(
                {
                  message: event.message,
                  duration: 1500000, // ms
                  position: 'top',
                  // addPixelsY: -40,  // (optional) added a negative value to move it up a bit (default 0)
                  // data: {'foo':'bar'} // (optional) pass in a JSON object here (it will be sent back in the success callback below)
                },
                // implement the success callback
                function(result) {
                  if (result && result.event) {
                    window.plugins.toast.hide();
                    // console.log("The toast was tapped or got hidden, see the value of result.event");
                    // console.log("Event: " + result.event); // "touch" when the toast was touched by the user or "hide" when the toast geot hidden
                    // console.log("Message: " + result.message); // will be equal to the message you passed in
                    // console.log("data.foo: " + result.data.foo); // .. retrieve passed in data here

                    // if (result.event === 'hide') {
                    //   console.log("The toast has been shown");
                    // }
                  }
                }
              );
          }

          // if ( event.message ) {
          //   $cordovaToast.show( event.message , 'long' , 'top' );
          // }
      });

      push.on('error', function(e) {
          console.log( 'error: ' + e.message );
      });

      push.setApplicationIconBadgeNumber(function() {
          // console.log('success');
      }, function() {
          // console.log('error');
      }, 0);

      push.on('archive', function(e) {
          console.log( 'archive: ' + JSON.stringify(e) );
      });

      push.on('AvaliaServico', function(event) {
          // console.log( JSON.stringify(e) );

          try {
            var action = event.additionalData.actions.filter(function(action) {
              return action.callback === event.additionalData.actionCallback
            })[0];
          } catch (e) {}

          action && AvaliaServico(action.parameters);
      });

      push.on('InsereAgenda', function(event) {
          // console.log( JSON.stringify(e) );
          // alert(JSON.stringify(event));
           try {
            var action = event.additionalData.actions.filter(function(action) {
              return action.callback === event.additionalData.actionCallback
            })[0];
          } catch (e) {}

          action && window.InsereAgenda(action.parameters);
      
    });

    push.on('DeleteAgenda', function(event) {
      // console.log( JSON.stringify(e) );
      // alert(JSON.stringify(event));
       try {
        var action = event.additionalData.actions.filter(function(action) {
          return action.callback === event.additionalData.actionCallback
        })[0];
      } catch (e) {}

      action && window.DeleteAgenda(action.parameters);
  
});
      push.on('window.InsereAgenda', function(event) {
          // console.log( JSON.stringify(e) );
          // alert(JSON.stringify(event));

          try {
            var action = event.additionalData.actions.filter(function(action) {
              return action.callback === event.additionalData.actionCallback
            })[0];
          } catch (e) {}

          action && window.InsereAgenda(action.parameters);
      });

      push.on('insert', function(event) {
          // console.log( JSON.stringify(e) );
          //alert(JSON.stringify(event));

          window.InsereAgenda(event.additionalData.parameters);
      });

    }

    var runOnDeviceReadyPush = function(callback) {
      if (typeof cordova !== 'undefined') {
        document.addEventListener("deviceready", callback, false);
      } else {
        callback();
      }
    };

    runOnDeviceReadyPush( function(){
      setTimeout(function() {
       navigator.splashscreen && navigator.splashscreen.hide();
     }, 3000);
    } );

    // window.callback = function() {
    //   console.log(arguments);
    //   var requestData = arguments[0].additionalData.actions[0].parameters;
    //   requestData.Status = true;
    //   UserApi.PushInterativoResposta( window.confirmar , function(r) {
    //     // console.log(JSON.stringify(r));
    //      $ionicPopup.alert({title: r.Message});
    //   });
    // };
   
    // BannerApi.openBanner('once', 1000, 'natalmobile', {
    //   cssClass: 'natalmobile',
    //   // timer: 7,
    //   template: '\
    //     <div class="full-image">\
    //       <img src="http://onemobilidade.azurewebsites.net/mobilidade/img/natalmobile.jpg" ng-click="myPopup.close()">\
    //     </div>\
    //   ',
    //   buttons: [
    //     {
    //       type: 'ion-close',
    //     },
    //   ]
    // });

  });

  $rootScope.emulador = !!~$window.location.search.indexOf('emulador') || DEALER.emulador;
  $rootScope.IMG = IMG;

  $sce.trustAsResourceUrl('onebelezamobile.azurewebsites.net');

  $rootScope.isAnonimous = function () {
    return $rootScope.user.NomeUsuario == 'Cliente Anônimo';
  }
})

.config(function($stateProvider, $urlRouterProvider, $ionicConfigProvider , $compileProvider , $anchorScrollProvider) {

  $compileProvider.aHrefSanitizationWhitelist(/^\s*(https?|ftp|mailto|file|ghttps?|ms-appx|x-wmapp0):/);

  $ionicConfigProvider.views.swipeBackEnabled(false);

  $anchorScrollProvider.disableAutoScrolling();

  // $scope.DEALER = 'dfsdf';

  //faz o cache funcionar da forma esperada
  $ionicConfigProvider.views.forwardCache(true);

  $stateProvider

  .state('blank', {
    url: '',
    resolve: {
      session: function (deviceStorage) {
        return deviceStorage.init();
      }
    },

    controller: function ($rootScope, $state, deviceStorage, BannerApi, AuthApi, DEALER, SaloesApi) {

      /*if (true) {
        SaloesApi.getAdressPoints(function () {});
        deviceStorage.put('user', DEALER.anonimous.user);
        deviceStorage.put('login', DEALER.anonimous.login);
        $state.go('saloes');
      } else*/ if ( deviceStorage.get('firstTime') !== null || deviceStorage.get('salao') ){

        var r = deviceStorage.get('user'),
            loginType = deviceStorage.get('loginType');

        // auto-login
        if (r && loginType) {
          // BannerApi.openBanner('once', 1, 'popup_auto_login', {
          //   template: '<img src="http://onemobilidade.azurewebsites.net/mobilidade/img/popup-auto-login.jpg" ng-click="myPopup.close()" width="100%" style="vertical-align: middle;">'
          // });
          $rootScope.user = r.Retorno;

          try {
            AuthApi.RegistrarDispositivo({
              Chave: Chave, //registrationId do aparelho
              Dispositivo: Dispositivo //pode ser "Google", "Apple", ou "Windows"
            }, function () {});
          } catch (e) {/*console.log(e);*/}

          AuthApi.validarEmpresaAtiva(function (result) {
            if (result.Successeded) {
              $state.go(loginType);
            } else {
              deviceStorage.remove('user');
              deviceStorage.remove('loginType');
              deviceStorage.remove('saloesUsuario');
              
              $state.go('entrar', {entrar: 0});
            }
          });

        } else {
          $state.go('entrar', {entrar: 0});
        }

        // $state.go('contributor.agenda');

      } else if ($rootScope.emulador) {
        $state.go('entrar', {entrar: 0});
      } else {
        // $urlRouterProvider.otherwise('/mapa');
        // $state.go('mapa');
        $state.go('entrar');
      }
    }
  })

  .state('mapa', {
    url: "/mapa",
    templateUrl: "templates/map.html",
    cache: false,
    resolve: {
      translations: function ($translate) {
        return $translate(['APP_MAP_INVITE_TITLE', 'APP_MAP_INVITE_DESCRIPTION', 'APP_MAP_INVITE_ACTION', 'APP_MAP_SCHEDULE', 'APP_MAP_FIND_ON', 'APP_CLOSE'])
          .then(function (translations) {
            return translations;
          })
      },
      places: function($q) {

        try {
          return google.maps.places;
        } catch(e) {}

        var deferred = $q.defer();


        window.initMap = function() {
          deferred.resolve('Hello, ' + name + '!');
        };

        var s = document.createElement('script'); // use global document since Angular's $document is weak
        s.src = 'https://maps.googleapis.com/maps/api/js?key=AIzaSyDk4G4aT7XOwDt5fOhHIERk5Ji5RKBQwj0&libraries=places&callback=initMap';
        document.body.appendChild(s);

        /*setTimeout(function() {
          deferred.notify('About to greet ' + name + '.');

          // if (okToGreet(name)) {
            deferred.resolve('Hello, ' + name + '!');
          // } else {
          //   deferred.reject('Greeting ' + name + ' is not allowed.');
          // }
        }, 1000);*/

        return deferred.promise;
      }
    },
    controller: 'MapCtrl'
  })

  .state('esqueci-minha-senha', {
    url: "/esqueci-minha-senha/:empresasID/:email",
    templateUrl: "templates/esqueci-minha-senha.html",
    controller: 'AuthCtrl',
    cache: false
  })



  .state('entrar-codigo-recuperacao', {
    url: "/entrar-codigo-recuperacao",
    templateUrl: "templates/entrar-codigo-recuperacao.html",
    controller: 'AuthCtrl',
    cache: false
  })

  .state('entrar-codigo-recuperacao-email', {
    url: "/entrar-codigo-recuperacao-email",
    templateUrl: "templates/entrar-codigo-recuperacao-email.html",
    controller: 'AuthCtrl',
    cache: false
  })


  .state('entrar-nova-senha', {
    url: "/entrar-nova-senha",
    templateUrl: "templates/entrar-nova-senha.html",
    controller: 'AuthCtrl',
    cache: false
  })

  .state('entrar', {
    url: "/:entrar/:empresasID",
    params: {
      entrar: { squash: true, value: null }
    },
    templateUrl: "templates/entrar.html",
    controller: 'AuthCtrl',
    cache: false
  })

  .state('convidar', {
    url: "/convidar/:empresasID",
    templateUrl: "templates/convidar.html",
    controller: 'ConvidarCtrl',
    cache: false
  })

  .state('logintype', {
    url: "/tipo-login",
    templateUrl: "templates/loginType.html",
    controller: 'LoginTypeCtrl',
    cache: false
  })

  .state('pesquisar-saloes', {
    url: "/pesquisar-saloes",
    templateUrl: "templates/pesquisar-saloes.html",
    controller: 'PesquisaSaloesCtrl',
    cache: false
  })

  .state('saloes', {
    url: "/saloes",
    templateUrl: "templates/saloes.html",
    controller: 'SaloesCtrl',
    cache: false
  })

  .state('cadastre-se', {
    url: "/cadastre-se/:empresasID",
    templateUrl: "templates/cadastre-se.html",
    controller: 'AuthCtrl',
    cache: false
  })

  .state('sobre', {
    url: "/sobre",
    templateUrl: "templates/client/sobre.html",
    // controller: 'AuthCtrl',
    cache: false
  });

  // if ( window.localStorage.getItem('firstTime') !== null || window.localStorage.getItem('salao') ){
  //   $urlRouterProvider.otherwise('/entrar/0');
  // }else{
  //   $urlRouterProvider.otherwise('/mapa');
  // }

})

.config(function($translateProvider) {

  // $translateProvider.translations('en', {
  //    APP_CLIENT_HISTORY_CLIENT_NAME_PLACEHOLDER: 'ddd'
  //  });
  //  $translateProvider.translations('pt', {
  //    APP_UNTIL: 'até'
  //  });

  $translateProvider.useStaticFilesLoader({
    prefix: window.debug ? 'lang/' : 'https://onebelezamobile.azurewebsites.net/lang/',
    // prefix: 'lang/',
    suffix: '.js'
  });

  $translateProvider.registerAvailableLanguageKeys(['en', 'es-es', 'pt'], {
      'en*': 'en',
      'pt*': 'pt'
      // 'es*': 'es-py',
      // 'es*': 'es',
    });//.fallbackLanguage(['en']);

  // $translateProvider.preferredLanguage(window.navigator.language || window.navigator.userLanguage);
  $translateProvider.preferredLanguage('pt-BR');
  $translateProvider.useSanitizeValueStrategy('escape');

})

.config(function(tmhDynamicLocaleProvider) {
  tmhDynamicLocaleProvider.localeLocationPattern('lib/angular-i18n/angular-locale_{{locale}}.js');
})

.config(function($ionicConfigProvider) {
    $ionicConfigProvider.navBar.alignTitle('center')
})

.factory('Interceptor', function ($q, $injector) {

  var lastAlert = 0;

  return {
    request: function (config) {
      // config.headers['X-TOKEN'] = "exemplo";
      if (~config.url.search('oneapimobilidade.azurewebsites.net')) {
        config.timeout = 30000;
        // debugger;
      }
      return config;
    },
    // requestError: function (error) {
    //   return error;
    // },
    // response: function (config) {
    //   // debugger;
    //   // config.headers['X-TOKEN'] = "exemplo";
    //   return config;
    // },
    responseError: function (error) {
      var Popup = $injector.get('Popup');
      // $ionicLoading.hide();

      if (~error.config.url.search('oneapimobilidade.azurewebsites.net')) {
        switch (error.status) {
          case 0:
            // Garante intevalo mínimo de 500 ms entre alertas de falha
            if (new Date - lastAlert > 500) {
              Popup.alert('Falha ao acessar servidor. Verifique sua conexão e tente novamente.');
              lastAlert = new Date;
            }
            return $q.defer(error);
            break;
        }

      }
      // if (error.status === 401 || error.status === 403) {
      //   //faz alguma coisa.
      // }
      return $q.reject(error);
    }
  }
})

.config(function ($httpProvider) {
    $httpProvider.interceptors.push('Interceptor');
});

;

(function () {
    "use strict";

    angular.element(document).ready(function () {
        if (window.cordova) {
            console.log("Running in Cordova, will bootstrap AngularJS once 'deviceready' event fires.");
            document.addEventListener('deviceready', function () {
                console.log("Deviceready event has fired, bootstrapping AngularJS.");
                angular.bootstrap(document.body, ['app']);
            }, false);
        } else {
            console.log("Running in browser, bootstrapping AngularJS now.");
            angular.bootstrap(document.body, ['app']);
        }
    });
} )();

var language = {

    ms0: 'Janeiro',
    ms1: 'Fevereiro',
    ms2: 'Março',
    ms3: 'Abril',
    ms4: 'Maio',
    ms5: 'Junho',
    ms6: 'Julho',
    ms7: 'Agosto',
    ms8: 'Setembro',
    ms9: 'Outubro',
    ms10: 'Novembro',
    ms11: 'Dezembro',

    d0: 'dom',
    d1: 'seg',
    d2: 'ter',
    d3: 'qua',
    d4: 'qui',
    d5: 'sex',
    d6: 'sab',

    thisMonth: "This month",
    prevMonth: "Prev",
    nextMonth: "Next",

};


Date.prototype.getMonthFormatted = function() {
    return language['ms'+this.getMonth()];
    /*var month = this.getMonth() + 1;
    return month < 10 ? '0' + month : month;*/
};

Date.prototype.ddmmyyyy = function() {
   var yyyy = this.getFullYear().toString();
   var mm = (this.getMonth()+1).toString(); // getMonth() is zero-based
   var dd  = this.getDate().toString();
   return (dd[1]?dd:"0"+dd[0]) + '/' + (mm[1]?mm:"0"+mm[0]) + '/' + yyyy; // padding
};

Date.prototype.hhmm = function() {
   var hh = this.getHours().toString();
   var mm = (this.getMinutes()).toString(); // getMonth() is zero-based
   // var ss  = this.getSeconds().toString();
   return (hh[1]?hh:"0"+hh[0]) + ':' + (mm[1]?mm:"0"+mm[0]) ; // padding
};

Date.ddmmyyyy = function( dateStr ) {
  var date = dateStr.split('/');
  var dd = date[0];
  var mm = date[1];
  var yyyy = date[2];

  return new Date(yyyy,mm-1,dd);
};

Date.hhmm = function( dateStr ) {
  return (new Date).sethhmm(dateStr);
};

Date.prototype.sethhmm = function( timeStr ) {
  var hh = parseInt(timeStr.substr(0,2));
  var mm = parseInt(timeStr.substr(3,2));

  this.setHours(hh);
  this.setMinutes(mm);

  return this;

};

WebFontConfig = {
  google: { families: [ 'Lato:300,400,600,700:latin' ] }
};
(function() {
    var wf = document.createElement('script');
    wf.src = 'https://ajax.googleapis.com/ajax/libs/webfont/1/webfont.js';
    wf.type = 'text/javascript';
    wf.async = 'true';
    var s = document.getElementsByTagName('script')[0];
    s.parentNode.insertBefore(wf, s);
})();

require('./components.js');
