require('./serv.js');

angular.module('app.components')

  .service('AvaliaServico', ['$ionicModal', '$rootScope', '$timeout', 'AvaliarServico', '$cordovaToast',
    function ($ionicModal, $rootScope, $timeout, AvaliarServico, $cordovaToast) {
      return function (servicos) {
        $scope = $rootScope.$new();

        $scope.salao = servicos.salao;
        $scope.servicos = servicos.servicos;

        $scope.open = function (servico, event) {
          servico.opened = !servico.opened;

          if ( servico.opened ) {
            var textarea = angular.element(event.currentTarget.parentElement).find('textarea')[0];
            $timeout(function () {
              textarea.focus();
            }, 400);
          }
        };

        // if (modal) {
        //   modal.hide()
        //     .then(function () {
        //       modal.remove();
        //     });
        // }

        var modal = $ionicModal.fromTemplate(
          require('./template.html'),
          {
            scope: $scope,
            animation: 'slide-in-up'
          }
        );
        modal.show();

        $scope.close = function (save) {
          save && AvaliarServico.answer({
            id: servicos.id,
            filialid: servicos.filialid,
            empresaid: servicos.empresaid,
            clienteid: servicos.clienteid,
            answers: servicos.servicos.map(function (answer) {
              return {
                id: answer.id,
                label: answer.label,
                rating: answer.rating,
                comment: answer.comment,
              }
            })
          })
            .then(function () {
              // alert(123); //Obrigado pela sua avaliação
              $cordovaToast.show( 'Obrigado pela sua avaliação' , 'long' , 'top' );
            });

          modal.hide()
            .then(function () {
              modal.remove();
            });
        };
      };
    }
  ])

  // .run(['AvaliaServico', '$timeout', function (AvaliaServico, $timeout) {
  //   $timeout(function () {
  //     AvaliaServico({
  //       id: 1,
  //       salao: 'MMtools - Ambiente de Demonstração',
  //       filialid: 1042,
  //       empresaid: 1044,
  //       clienteid: 1,
  //       servicos: [
  //         {
  //           id: 1,
  //           label: 'Colaborador 1'
  //         },
  //         {
  //           id: 2,
  //           label: 'Colaborador 2'
  //         },
  //         {
  //           id: 3,
  //           label: 'Atendimento geral'
  //         }
  //       ]
  //     });
  //   }, 0)
  //   // AvaliaServico(666);
  // }]);
