require('./serv.js');

angular.module('app.components')

  .config(function($stateProvider ) {
    $stateProvider
      .state('facebook-login', {
        url: '/facebook-login/:empresasID',
        template: require('./facebook-login.html'),
        controller: function ($rootScope, $scope, $state, deviceStorage, AuthApi, FacebookLoginService, $ionicLoading, Popup, $ionicPopup) {

          $scope.userData = deviceStorage.get('facebookData');
          $scope.salao = deviceStorage.get('salao');

          $scope.signIn = function (user) {
            $ionicLoading.show();

            var requestData = {
                email: user.username,
                senha: user.password,
                // senha: CryptoJS.SHA256(user.password).toString(),
                FacebookToken: $scope.userData.authResponse.accessToken,
            };

            FacebookLoginService.associarNovoUsuario(requestData)
              .then(function (result) {
                // debugger;
                if (result.Successeded) {
                  return FacebookLoginService.loginFacebook({
                    // email: user.username,
                    token: $scope.userData.authResponse.accessToken
                  }).then(doLogin);
                } else {
                  $ionicLoading.hide();
                  Popup.alert(result.Message);
                }
              })
              .finally(function () {
                // $ionicLoading.hide();
              })
          };

          var doLogin = function(results) {
            $rootScope.saloes = results.Retorno;
            $rootScope.logged = true;
            $rootScope.UsuarioId = results.UsuarioId;

            deviceStorage.put('UsuarioId', results.UsuarioId);
            deviceStorage.put('firstTime', false);
            deviceStorage.put('user',results);
            deviceStorage.put('salao', $scope.salao);

            if ($scope.salao) {
              var requestData = {
                UsuarioId : results.UsuarioId,
                EmpresaId : $scope.salao.EmpresasID
              };

              AuthApi.registrarusuarioempresa(requestData, function (result) {
                authenticate($scope.salao);
              });
            } else {
              deviceStorage.put('saloesUsuario', results.Retorno);
              $state.go('saloes');
            }
          };

          $scope.doCreateUser = function(user) {

            $scope.user = user;

            // $scope.buttonRegisterText = '<i class="ion-load-c"></i>';
            // $scope.disableButton = true;

            $ionicPopup.show({
              title: 'Cadastrar celular',
              subTitle: 'Por favor informe o número do seu celular',
              cssClass: 'cellphone-popup',
              // templateUrl: require('./'),
              template: '<label class="item item-input">\
                           <i class="icon ion-ios-telephone placeholder-icon" style="padding-right: 20px;"></i>\
                           <input type="text" ng-model="userData.celular" placeholder="{{\'APP_REGISTER_CELLPHONE\' | translate }}*" ui-br-phone-number minlength="15" required>\
                         </label>\
                         <h5 style="color: red" ng-if="!userData.celular">{{erro}}</h5>',
              scope: $scope,
              buttons: [
                { text: 'Cancelar' },
                {
                  text: '<b>Cadastrar</b>',
                  type: 'button-calm',
                  onTap: function(e) {
                    if ( !$scope.userData.celular ) {
                      $scope.erro = 'Preencha o campo corretamente';
                    } else {
                      $scope.erro = '';
                      return $scope.data;
                    }

                    e.preventDefault();
                  }
                }
              ]
            })
              .then(function () {
                // debugger;
                $ionicLoading.show();

                var requestData = {
                    // Nome            : user.name,
                    // Email           : user.email,
                    Celular         : user.celular,
                    // Telefone        : user.telefone,
                    // DataAniversario : new Date(user.birthday),
                    // Senha           : user.password,
                    // ConfirmarSenha  : user.confPassword,
                    FacebookToken   : user.authResponse.accessToken,
                    // FacebookId   : user.userID,
                };

                AuthApi.postCreateUser(requestData, doCreateUserCallback);

                // requestData = {
                //     "email"       : user.email,
                //     "defaultPass" : user.password,
                //     // "empresa"     : salao
                // };
                // deviceStorage.put('login', requestData);
              });

          };

          function doCreateUserCallback (results) {
            if (results.Successeded) {
              FacebookLoginService.loginFacebook({
                token: $scope.userData.authResponse.accessToken
              }).then(doLogin);
            } else {
              Popup.alert(results.Message);
              $ionicLoading.hide();
              $scope.buttonRegisterText = '';
              $scope.disableButton = false;
            }
          }

          function authenticate (salao) {
            // var requestData = deviceStorage.get('login');
            // requestData.empresa = salao.EmpresasID;

            $ionicLoading.show();

            AuthApi.authenticate({
              token   : $scope.userData.authResponse.accessToken,
              empresa : salao.EmpresasID
            }, function(r) {
              $ionicLoading.hide();

              if ( !r.Successeded ) {
                Popup.alert(r.Message);
                return;
              }

              deviceStorage.put('user',r);
              deviceStorage.put('salao',salao);

              $rootScope.salao = salao;

              $rootScope.user = r.Retorno;

              try {
                // Chave = 'teste';
                // Dispositivo = 'Google';

                var requestData = {
                  Chave: Chave, //registrationId do aparelho
                  Dispositivo: Dispositivo //pode ser "Google", "Apple", ou "Windows"
                };

                // alert(JSON.stringify(requestData) );
                // version_data = JSON.stringify(requestData);

                AuthApi.RegistrarDispositivo(requestData, function (argument) {
                  // alert(JSON.stringify(argument) );
                  // version_data += JSON.stringify(argument);
                });

              } catch(e) {console.log(e);}

              if ( $rootScope.user.Cliente + $rootScope.user.Colaborador + $rootScope.user.Gerente > 1 ) {
                $state.go('logintype');
              } else if ( $rootScope.user.Colaborador ) {
                $state.go('contributor.dashboard');
              } else if ( $rootScope.user.Gerente ) {
                $state.go('manager.dashboard');
              } else {
                $state.go('client.dashboard');
              }
            });
          }
        },
        cache: false
      });
  })

  .service('FacebookLogin', [
    function () {
      return function (onSuccess, onError) {
        var vm = this;

        if (window.facebookConnectPlugin) {
          window.facebookConnectPlugin.login([
            'public_profile',
            // 'user_birthday',
            'email'
          // ], fbLoginSuccess, onError);
          ], onSuccess, onError);
        } else {
          // fbLoginSuccess({
          onSuccess({
            "authResponse": {
              // "accessToken": "EAAZAFQ2Y5ZCZBwBAJBQNuyZCYZBGob71obZBbekysQDKrGHnPjryBHZBJmIkZBo7ITUEB7Y57UMMZBi4qBmNxkXl2Dqkl4fF6ss002PWsj6ZCZC7YjYnoRoyTk9USISqf1qO1nMSiiOiBZAsllkNrajXYAjCIc8w0swkeDbABGzVOS3GXoXZCCMcEi6ApWKqyC9ET5jcDebqT82a7xr3x2x0oJWnasiY8R8NVHoUZD",
              // "accessToken": "EAAZAFQ2Y5ZCZBwBAL8qJV3i2i0qaZASaWGiDDmXQY5KYf9QBoJScNLMGQIWY00DGIlLS5ZApCpXcEx0AVodYpW7h51elaBToZAVDO4IrbN8sYrGZBP1M1NlErKCCpumQIQnhuH3CGiQVOIZAzParo0Lj4tWYLthpZAeUZAZB4ZAZACkXiqoWV9YN5VSHgo72ncg6rbyZConUch1cQL4ZByyUZBQ4HnsUmFFIam060vhsFL4AHZA1ZBnQZDZD",
              // "accessToken": "token_falso",
             // "accessToken": prompt("accessToken", 1),
              "expiresIn": "5183902",
              "session_key": true,
              "sig": "...",
              "userID": "1891428737551411"
            },
            "status": "connected"
          });
        }

        // function fbLoginSuccess (userData) {
        //   // {"status":"connected","authResponse":{"accessToken":"EAAZAFQ2Y5ZCZBwBAN04VNYCWVeQqWYBiWl3EOCaPJbEbeS9ACztzkoNwWKraU2HkMoSj2KmTvgh7piAf1myzR0ZAUWsBDgji5DMPfikgwTiDbjJVBalxnLu7haD41dRHWsdoWxz6P0guSnTzG1L2cviRTcGnQdZASsBJ6zeQZCUQ0L4tbpcGPkRA0c0bD0g8VleOld2FkDKLvW4k1c6jZB16I3VKN01ZCr8ZD","expiresIn":"5183902","session_key":true,"sig":"...","userID":"1891428737551411"}}
        //   // console.log('UserInfo: ', JSON.stringify(userData));
        //   vm.userData = userData;

        //   if (window.facebookConnectPlugin) {
        //     // {"id":"1891428737551411","email":"erictonussi@gmail.com"}
        //     // {"errorCode":"4201","errorMessage":"User cancelled dialog"}
        //     window.facebookConnectPlugin.api(
        //       userData.authResponse.userID + '/?fields=id,name,email,birthday,gender',
        //       ['public_profile', 'email', 'birthday'], fbEmailSuccess, onError);
        //     // window.facebookConnectPlugin.api('me', fbEmailSuccess, onError);
        //   } else {
        //     fbEmailSuccess({
        //       'id':    '1891428737551411',
        //       'name':  'Eric Tonussi',
        //       'email': 'eric@tonussi.com',
        //       // 'email': prompt('email', '1@mailinator.com'),
        //       'birthday': '02/06/1987'
        //     });
        //   }
        // }

        function fbEmailSuccess (userData) {
          onSuccess(angular.extend(vm.userData.authResponse, userData));
        }
      };
    }
  ])

  // .run(['FacebookLogin', '$timeout', 'FacebookLoginService', '$state', 'deviceStorage',
  //   function (FacebookLogin, $timeout, FacebookLoginService, $state, deviceStorage) {
  //   // $timeout(function () {
  //   //   FacebookLogin(function (userData) {
  //   //     FacebookLoginService.loginFacebook(userData)
  //   //   }, console.log);
  //   // }, 0)
  //   window.FacebookLogin = function (onSuccess, onError) {
  //     // $timeout(function () {
  //       FacebookLogin(function (userData) {
  //         console.log(JSON.stringify(userData));

  //         FacebookLoginService.loginFacebook({
  //           email: userData.email,
  //           token: userData.accessToken
  //         })
  //           .then(function (result) {
  //             switch (result.data.Message) {
  //               case 'FACEBOOK_LOGIN_SUCCESS_TOKEN':
  //               case 'FACEBOOK_LOGIN_SUCCESS_EMAIL':
  //                 console.log(result.data);
  //                 if (deviceStorage.get('salao')) {

  //                 }
  //                 break;
  //               case 'FACEBOOK_LOGIN_FAIL_TOKEN_EMAIL':
  //                 deviceStorage.put('facebookData', userData);
  //                 $state.go('facebook-login');
  //             }
  //           })
  //       }, function (result) {
  //         console.log(JSON.stringify(result));
  //       })
  //     // }, 0)
  //   }
  // }]);
