var controllers = angular.module('app.controllers', []);

controllers.controller('AppCtrl', ['$scope', '$rootScope', '$state', 'deviceStorage', '$ionicPopup', 'UserApi', 'DEALER', '$translate', 'tmhDynamicLocale', 'Popup', '$compile',
	function($scope, $rootScope, $state, deviceStorage , $ionicPopup , UserApi , DEALER , $translate, tmhDynamicLocale, Popup, $compile) {

  var me = this;

  me.translations = {};

  $rootScope.$on('$translateChangeSuccess', function () {
    $translate(['APP_INVITE_TITLE', 'APP_INVITE_ACTION', 'APP_CANCEL'])
      .then(function (translations) {
        me.translations = translations;
      });
  });

	$rootScope.version = version;
  $rootScope.version_data = version_data;

	$rootScope.DEALER = DEALER;

  $rootScope.$state = $state;

	$scope.goBack = function() {
		window.history.back();
	};

	$scope.logout = function(){
    deviceStorage.remove('user');
    deviceStorage.remove('loginType');
		deviceStorage.remove('saloesUsuario');
		// deviceStorage.remove('saloes');
		$rootScope.logged = false;
		// $state.go('map');
	};

    $scope.utils = {};
    $scope.utils.nomeHistoricoPaciente = "APP_MENU_CONTRIBUTOR_CLIENT_HISTORY";
    if($scope.selectedEmpresa === 4303){
        $scope.utils.nomeHistoricoPaciente = "Histórico clínico";
    }


  var pontosConvidaramigo = 40;
  // UserApi.pontosConvidaramigo(null, function(r){
  //   $scope.pontosConvidaramigo = r;
  // });

	$scope.convidar = function() {
   
    $scope.data = {};

    var myPopup = $ionicPopup.show({
        // template: '<label class="item item-input"><i class="icon ion-locked placeholder-icon" style="padding-right: 20px;"></i><input type="password" ng-model="data.password" placeholder="Senha" required></label><label class="item item-input"><i class="icon ion-locked placeholder-icon" style="padding-right: 20px;"></i><input type="password" ng-model="data.confirm" placeholder="Confirme a senha" required></label>',
        templateUrl: "templates/client/convidar-amigo.html",
        title: me.translations.APP_INVITE_TITLE,
       // subTitle: 'Ei! Convide um amigo para baixar o ONE e acumule ' + pontosConvidaramigo + ' pontos! Estes pontos, furamente, serão convertidos em prêmios.',
        scope: $scope,
        buttons: [
          {
            text: me.translations.APP_CANCEL,
            type: 'button-energized button-outline',
          },
          {
            text: me.translations.APP_INVITE_ACTION,
            type: 'button-positive',
            onTap: function(e) {

              var requestData = {
                 ClienteID : deviceStorage.get('UsuarioId'),
                 Email: $scope.data.Email
              };

              UserApi.ConvidarAmigo(requestData, function(r){
                // $ionicPopup.alert({title: r.Message});
                Popup.alert(r.Message);
              });

              // e.preventDefault();

            }
          }
        ]
      });
	};

	$rootScope.user = deviceStorage.get('user') && deviceStorage.get('user').Retorno;
	$rootScope.salao = deviceStorage.get('salao');

  function parseKeyFlag(key) {
    if ( ['pt-br', 'es-es', 'en-us'].indexOf(key) !== -1 ) {
      return key;
    } else if ( ['pt'/*, 'es'*/, 'en'].indexOf(key.substr(0,2)) !== -1 ) {
      return {
        'pt': 'pt-br',
        // 'es': 'es-py',
        'en': 'en-us'
      }[key.substr(0,2)];
    } else {
      return 'pt-br';
    }
  }

  $scope.changeLanguage = function (key) {

    $scope.currentLanguage = parseKeyFlag(key.toLocaleLowerCase());

    $translate.use(key);
    tmhDynamicLocale.set(key);

    deviceStorage.put('currentLanguage', key);

  };

  deviceStorage.init()
    .then(function () {
      $scope.changeLanguage(deviceStorage.get('currentLanguage') || window.navigator.language || window.navigator.userLanguage);
      // $scope.changeLanguage('pt-PT');
    });

  var languageBox = angular.element(document.createElement('language-box'));
  var el = $compile( languageBox )( $scope );

  //where do you want to place the new element?
  angular.element(document.body).append(languageBox);

  $scope.insertHere = el;

}]);

controllers.controller('SideMenuCtrl', function($scope, $ionicSideMenuDelegate) {

    $scope.rightMenuTemplate = {url: 'templates/menu_right.html'};

    $scope.toggleRight = function() {
        $ionicSideMenuDelegate.toggleRight();
    };

    // $scope.logout = function(){
    //   // window.localStorage.clear();
    //   deviceStorage.remove('user');
    // };

});

require('./controllers/mapCtrl.js');
require('./controllers/authCtrl.js');
require('./controllers/loginTypeCtrl.js');
require('./controllers/saloesCtrl.js');
require('./controllers/convidarCtrl.js');
require('./controllers/pesquisaSaloesCtrl.js');

require('./controllers/clienteCtrl.js');

require('./controllers/contributorCtrl.js');

require('./controllers/managerCtrl.js');
