var controllers = angular.module('app.controllers');

controllers.controller('AgendarCtrl', ['$rootScope', '$scope', '$state', '$ionicPopup', '$ionicModal', 'deviceStorage', 'AgendaApi', '$cordovaCalendar', '$ionicLoading', '$ionicScrollDelegate', '$timeout', '$location', 'DEALER', 'Popup',
  function ($rootScope, $scope, $state, $ionicPopup, $ionicModal, deviceStorage, AgendaApi, $cordovaCalendar, $ionicLoading, $ionicScrollDelegate, $timeout, $location, DEALER, Popup) {

    var me = this;
  
    var solicitarAvaliacao = function () {
  
      if (deviceStorage.get('avaliouapp') == true) {
        return false;
      }

      if (deviceStorage.get('avaliouapp') == null) {
        return true;
      }
      else {
        var horaAvaliarDepois = (deviceStorage.get('avaliouapp'));
        var agora = Date.now();

        if (agora - horaAvaliarDepois > 86400000) {
          return true;
        }
     
      
      }
    }
    
    var avaliarApp = function () {
     console.log(solicitarAvaliacao());
      if (solicitarAvaliacao() && (ionic.Platform.isIOS ||ionic.Platform.isAndroid() )  ) {

      if (ionic.Platform.isIOS()){
        $ionicPopup.show({
          templateUrl: 'templates/avalieaoppApple.html',
          title: 'Você está gostando do One Beleza?',

          buttons: [{ // Array[Object] (optional). Buttons to place in the popup footer.
            text: "Avaliar agora",
            type: 'button-oneRosa',
            onTap: function (e) {
             deviceStorage.put('avaliouapp', true);
                window.location.href = 'itms-apps://itunes.apple.com/app/viewContentsUserReviews/id951191083?action=write-review';
             }
          },

          { // Array[Object] (optional). Buttons to place in the popup footer.
            text: "Avaliar depois",
            type: 'button-oneAzul ',
            onTap: function (e) {
              deviceStorage.put('avaliouapp', Date.now());

            }
          }
          ]
        });
         
      }

      else   {
        $ionicPopup.show({
          templateUrl: 'templates/avalieaoppAppAndroid.html',
          title: 'Você está gostando do One Beleza?',

          buttons: [{ // Array[Object] (optional). Buttons to place in the popup footer.
            text: "Avaliar agora",
            type: 'button-royal',
            onTap: function (e) {
              deviceStorage.put('avaliouapp', true);
                window.location.href = 'market://details?id=com.mmtools.oneBeleza';
             }
          },

          { // Array[Object] (optional). Buttons to place in the popup footer.
            text: "Avaliar depois",
            type: 'button-positive',
            onTap: function (e) {
            deviceStorage.put('avaliouapp', Date.now());

            }
          }
          ]
        });
        
       
   
      }
      return true;
    }
}
  

    try {
      $cordovaCalendar.createCalendar({
        calendarName: DEALER.description,
        calendarColor: DEALER.colorRGB
      }).then(function (result) {
        // console.log('result: ' + result);
      }, function (err) {
        // alert('erro: ' + err);
        // error
      });
    } catch (e) {
      // alert('catch: ' + e);
    }

    $scope.ag = {
      firstReminder: 1440,
      secondReminder: 60,
      alarme: true
    };

    $scope.filtros = [];
    $scope.currentFiltro = null;
    $scope.status = 0;

    $scope.filtrar = function (tipo) {
      $scope[tipo] = $scope.currentFiltro = {
        tipo: tipo
      };
      $scope.filtros.push($scope.currentFiltro);
      $scope.status = 1;

      $location.hash('filtro' + tipo);
      // $timeout(function(argument) {
      //    $ionicScrollDelegate.$getByHandle('mainScroll').resize();
      //   // $ionicScrollDelegate.$getByHandle('mainScroll').anchorScroll(true);
      //   // $ionicScrollDelegate.$getByHandle('mainScroll').anchorScroll(true);
      // }, 500);
    };



    $scope.resetCurrent = function () {

      var i = $scope.filtros.indexOf($scope.currentFiltro);
      if (i == -1) i = 0;
      var tipo = $scope.filtros[i].tipo;
      $scope[tipo] = null;
      $scope.filtros.splice(i, 1);

      $scope.currentFiltro = null;
      $scope.status = 0;
      $location.hash('filtrarPor');
      $timeout(function (argument) {
        $ionicScrollDelegate.$getByHandle('mainScroll').resize();
        // $ionicScrollDelegate.$getByHandle('mainScroll').anchorScroll(true);
        // $ionicScrollDelegate.$getByHandle('mainScroll').anchorScroll(true);
      }, 100);
    }

    $scope.reset = function () {

      $scope.filtros = [];
      $scope.currentFiltro = null;
      $scope.status = 0;

      $scope.servicos = null;
      $scope.colaborador = null;
      $scope.data = null;

      $scope.ag = {
        firstReminder: 1440,
        secondReminder: 60,
        alarme: true
      };

      $location.hash('filtrarPor');

      $timeout(function (argument) {
        $ionicScrollDelegate.$getByHandle('mainScroll').resize();
        // $ionicScrollDelegate.$getByHandle('mainScroll').anchorScroll(true);
        // $ionicScrollDelegate.$getByHandle('mainScroll').anchorScroll(true);
      }, 100);
    };

    $scope.alterar = function (filtro, hash) {

      filtro.status = 1;

      for (var i = $scope.filtros.indexOf(filtro) + 1; i < $scope.filtros.length;) {
        var tipo = $scope.filtros[i].tipo;
        // console.log(tipo,$scope[tipo]);
        $scope[tipo] = null;
        $scope.filtros.splice(i, 1);

      }

      $location.hash(hash);

      $ionicScrollDelegate.$getByHandle('mainScroll').anchorScroll(true);

      $timeout(function (argument) {
        $ionicScrollDelegate.$getByHandle('mainScroll').anchorScroll(true);
      }, 500);

      $scope.status = 1;

      $scope.ag.selHora = null;
    };

    $scope.finalizar = function (filtro) {
      $scope.alterar(filtro, 'filtrarPor');

      filtro.status = 2;

      $scope.currentHora = null;

      if ($scope.filtros.length == 3) {
        $scope.status = 2;
        updateSelHora();
      } else if ($scope.filtros.length == 2) {
        $scope.filtrar(
          !$scope['servicos'] ? 'servicos'
            : !$scope['colaborador'] ? 'colaborador' : 'data'
        );
      } else {
        $scope.status = 0;
      }
    };

    $scope.concluir = function () {
      $scope.status = 2;
      $location.hash('finalizar');
      $ionicScrollDelegate.$getByHandle('mainScroll').anchorScroll(true);
      $ionicScrollDelegate.$getByHandle('mainScroll').scrollTop();
    };

    var appendHoras = function (results) { //console.log(results.Retorno);
      $scope.horas = results.Retorno;
      $ionicScrollDelegate.$getByHandle('mainScroll').anchorScroll(true);
      $ionicLoading.hide();
    };

    var updateSelHora = function () {

      $scope.horas = null;

      $ionicLoading.show();
      AgendaApi.getHorasNovo($scope.getFiltros(), appendHoras);
    };

    $scope.currentHora = null;

    $scope.selectProfissionaltHora = function (profissional, hora) {
      $scope.horas = profissional.horas;

      $scope.currentHora = hora;

      $scope.ag.selHora = hora;

      $scope.concluir();
    };

    $scope.selectHora = function (hora) {
      if (!$scope.currentHora) {

        $scope.currentHora = hora;
        $scope.ag.selHora = hora;

        $scope.concluir();

      }
    };

    $scope.resetHora = function () {
      $scope.currentHora = null;
      $scope.ag.selHora = null;

      $location.hash('filtrarPor');
      $ionicScrollDelegate.$getByHandle('mainScroll').anchorScroll(true);
    };

    $scope.getFiltros = function () {
      var filtro = {};

      if (s = $scope.servicos) { //console.log(s);
        filtro.GrupoId = s.selGrupoServico && s.selGrupoServico.GservsID;
        filtro.ServicoId = s.selServico && s.selServico.ID;
      }

      if (c = $scope.colaborador) { //console.log(c);
        filtro.ColaboradorId = c.selProfissional && c.selProfissional.id;
      }

      if (d = $scope.data) { //console.log(d);
        filtro.Data = d.selData && d.selData.DataNumero;
        filtro.Periodo = d.periodo && d.periodo[0];

        if (typeof filtro.Periodo == "undefined") {
          if (typeof $scope.currentPerido != "undefined") {
            filtro.Periodo = $scope.currentPerido;
          }
        }
      }

      return filtro;
    };

    var validate = function (data) {
      return true;
    };

    var postAgendar = function (data) {

      $ionicLoading.hide();

      if (data.Successeded) {

        var startDate = Date.ddmmyyyy($scope.data.selData.DataNumero);
        startDate.sethhmm($scope.ag.selHora.HorarioInicio);

        var endDate = Date.ddmmyyyy($scope.data.selData.DataNumero);
        endDate.sethhmm($scope.ag.selHora.HorarioFinal);

        if ($scope.ag.alarme) {

          try {
            $cordovaCalendar.createEventInteractively({
              title: $scope.servicos.selServico.Descricao,
              location: $scope.user.RazaoSocialFilial,
              notes: $scope.colaborador.selProfissional.nome,
              startDate: startDate,
              endDate: endDate,
              firstReminderMinutes: $scope.ag.firstReminder,
              secondReminderMinutes: $scope.ag.secondReminder,
              calendarName: DEALER.description,
            }).then(function (result) { //alert(JSON.stringify(result));
              // console.log(JSON.stringify(result));
              // success
            }, function (err) { //alert('error:'+ err );
              // console.log(JSON.stringify(err));
              // error
            });

          } catch (e) {
            // console.log(JSON.stringify(e));
          }

        }

        if(DEALER.id===0 ) {
          if (avaliarApp()) {
          
          $state.go('client.dashboard');
        }
          else{
            Popup.alert('APP_NEW_SCHEDULE_SUCCESS', {
            cssClass: 'popupAgendamentoRealizadoComSucesso',
          });
          
          $state.go('client.dashboard');
        }

      }
        else{
            Popup.alert('APP_NEW_SCHEDULE_SUCCESS', {
            cssClass: 'popupAgendamentoRealizadoComSucesso',
          });
          
          $state.go('client.dashboard');
        }
        //navigator.notification.alert(data.Message);
       
        

      } else {

        //navigator.notification.alert(data.Message);
        Popup.alert(data.Message);

      }

    };

    $scope.gravarAgendamento = function (result) {
      if ($rootScope.isAnonimous()) {
        $ionicPopup.show({
          template: '<form name="user_anonimo_form">\
          <label class="item item-input">\
            <input type="text" ng-model="user_anonimo.name" placeholder="Nome*" required>\
          </label>\
          <label class="item item-input">\
            <input type="text" name="user_anonimo_celular" ng-model="user_anonimo.celular" placeholder="Telefone*" required ui-br-phone-number autocomplete="off" autocorrect="off" autocapitalize="off" spellcheck="false" ng-change="user_anonimo.celular2 = user_anonimo_form.user_anonimo_celular.$viewValue" >\
          </label>\
        </form>',
          // templateUrl: "templates/client/convidar-amigo.html",
          title: 'Dados de contato',
          subTitle: 'Insira seus dados de contato para que possamos confirmar seu agendamento',
          scope: $scope,
          buttons: [
            {
              text: 'Cancelar',
              type: 'button-energized button-outline',
            },
            {
              text: 'Confirmar',
              type: 'button-positive',
              onTap: function (e) {
                if (!$scope.user_anonimo.name || !$scope.user_anonimo.celular2) {
                  return e.preventDefault();
                }

                doAgendar(result, 'Telefone: ' + $scope.user_anonimo.celular2 + '\nNome: ' + $scope.user_anonimo.name);
              }
            }
          ]
        });
      } else if (validate(result)) {
        doAgendar(result);
      }
    };

    $scope.user_anonimo = {};

    function doAgendar(result, observacao) {
      $ionicLoading.show();

      var hora = result.selHora;//.split(" - ");
      var requestData = {
        data: $scope.data.selData.DataNumero,
        horainicio: hora.HorarioInicio,
        horafim: hora.HorarioFinal,
        profissionalid: $scope.colaborador.selProfissional.id,
        servicoid: $scope.servicos.selServico.ID,
        Observacao: observacao
      };
      AgendaApi.postAgendar(requestData, postAgendar);
    }

    $scope.curriculo = function (prof) {
      $scope.curriculoAtual = prof;
      var myPopup = $ionicPopup.show({
        cssClass: 'curriculo',
        // template: '<label class="item item-input"><i class="icon ion-locked placeholder-icon" style="padding-right: 20px;"></i><input type="password" ng-model="data.password" placeholder="Senha" required></label><label class="item item-input"><i class="icon ion-locked placeholder-icon" style="padding-right: 20px;"></i><input type="password" ng-model="data.confirm" placeholder="Confirme a senha" required></label>',
        templateUrl: 'curriculo.html',
        // title: prof.nome,
        // subTitle: 'Ei! Convide um amigo para baixar o ONE e acumul pontos! Estes pontos, furamente, serão convertidos em prêmios.',
        scope: $scope,
        buttons: [
          {
            type: 'button-positive',
            text: 'OK'
          }
        ]
      });
    };

    $scope.detalheServico = function (serv) {

      var template = '';

      if (serv.FotoAntes && serv.FotoDepois) {
        template = '<div>' +
          '<div class="img" style="background-image:url(' + serv.FotoAntes + ')"></div>' +
          '<div class="img" style="background-image:url(' + serv.FotoDepois + ')"></div>' +
          '<h2>Antes</h2><h2>Depois</h2>' +
          '</div>';
      }
      var myPopup = $ionicPopup.show({
        cssClass: 'servico',
        // template: '<label class="item item-input"><i class="icon ion-locked placeholder-icon" style="padding-right: 20px;"></i><input type="password" ng-model="data.password" placeholder="Senha" required></label><label class="item item-input"><i class="icon ion-locked placeholder-icon" style="padding-right: 20px;"></i><input type="password" ng-model="data.confirm" placeholder="Confirme a senha" required></label>',
        template: '<p>' + serv.Help + '</p>' + template,
        title: serv.Descricao,
        // subTitle: 'Ei! Convide um amigo para baixar o ONE e acumule ' + pontosConvidaramigo + ' pontos! Estes pontos, furamente, serão convertidos em prêmios.',
        buttons: [
          {
            text: 'Cancelar',
            type: 'button-energized button-outline',
          }
        ]
      });
    };

    // $scope.curriculo({nome:'Eric Tonussi',profissao:'Desenvolvedor', curriculo: 'Desenvolvedor frontend',foto:'http://onemidias.azurewebsites.net/Colaboradores/empresa1044/524de73a-e15f-4184-85fe-f1d571c1d4a3homens-vaidososjoao-bosco-1416844133539_615x470.jpg'});



    $scope.$on('atualizarPeriodo', function (event, periodo) {
      $scope.currentPerido = periodo;
    });

  }]);

controllers.controller('FiltroServicosCtrl', ['$scope', '$state', '$ionicPopup', 'deviceStorage', 'AgendaApi', '$cordovaCalendar', '$ionicModal', '$ionicLoading', '$ionicScrollDelegate', 'Popup',
  function ($scope, $state, $ionicPopup, deviceStorage, AgendaApi, $cordovaCalendar, $ionicModal, $ionicLoading, $ionicScrollDelegate, Popup) {

    $scope.servicos = null;
    $scope.endereco = {};

    var user = deviceStorage.get('user').Retorno;
    AgendaApi.getInfoBasicaEndereco({ ID: user.ClienteID }, guardaEndereco);

    function guardaEndereco(results) {
      $scope.endereco.endereco = results.Retorno.Endereco;
      $scope.endereco.bairro = results.Retorno.Bairro;
      $scope.endereco.complementoEndereco = results.Retorno.ComplementoEndereco;
      $scope.endereco.celular = results.Retorno.Celular;
      $scope.endereco.numeroEndereco = results.Retorno.NumeroEndereco;

    }


    $ionicLoading.show();
    AgendaApi.getGrupoServicos($scope.getFiltros(), appendGrupoServicos);

    $scope.updateSelServico = function () {

      $scope.servicos = null;

      AgendaApi.getServicos($scope.getFiltros(), appendServicos);
      $ionicLoading.show();
    };
    var atualizaEnderecoCallback = function (results) {
      $ionicLoading.hide({});
      Popup.alert(results.Message || "Endereço atualizado com sucesso!");
    }

    $scope.atualizaEnderecoBasico = function (endereco) {
      $ionicLoading.show({});
      var requestData = {
        'Endereco': endereco.endereco,
        'NumeroEndereco': endereco.numeroEndereco,
        'ComplementoEndereco': endereco.complementoEndereco,
        'Bairro': endereco.bairro,
        'Celular': endereco.celular,
        'CliForColsId': user.ClienteID
      };

      AgendaApi.alterarBasicaEndereco(requestData, atualizaEnderecoCallback);


    }
    function appendGrupoServicos(results) {

      $ionicLoading.hide();

      $scope.grupoServicos = results.Retorno;
      $ionicScrollDelegate.$getByHandle('mainScroll').anchorScroll(true);

      results.Retorno.forEach(function (grupo) {
        var filtro = $scope.getFiltros();
        filtro.GrupoId = grupo.GservsID;
        AgendaApi.getServicos(filtro, function (r) {
          grupo.servicos = r.Retorno;
        });
      });

      // $ionicLoading.hide();

    }

    $scope.current = null;
    $scope.currentGrupo = null;

    $scope.select = function (servico, grupo) {
      //console.log(servico);

      if (!$scope.current) {

        $scope.current = servico;
        $scope.currentGrupo = grupo;
        $scope.filtro.selServico = servico;
        $scope.finalizar($scope.filtro);
        if (servico.Delivery === true) {
          AgendaApi.getInfoBasicaEndereco
          $ionicModal.fromTemplateUrl('templates/client/modal_delivery.html', {
            scope: $scope,
            animation: 'slide-in-up'
          }).then(function (modal) {
            $scope.modal = modal;
            $scope.modal.show();
          });
        }


      } /*else {

        $scope.current = null;

        $scope.alterar($scope.filtro,'selProfissional');

      }*/

    };

    $scope.closeModal = function () {
      $scope.modal.hide();
    };

    $scope.reset = function () {

      $scope.current = null;

      $scope.alterar($scope.filtro, 'selServico');

    };

    function appendServicos(results) {
      $scope.servicos = results.Retorno;
      $ionicScrollDelegate.$getByHandle('mainScroll').anchorScroll(true);
      $ionicLoading.hide();
    }

  }
]);

controllers.controller('FiltroColaboradorCtrl', ['$scope', '$rootScope', '$state', '$ionicPopup', 'deviceStorage', 'AgendaApi', '$cordovaCalendar', '$ionicLoading', '$ionicScrollDelegate',
  function ($scope, $rootScope, $state, $ionicPopup, deviceStorage, AgendaApi, $cordovaCalendar, $ionicLoading, $ionicScrollDelegate) {

    $scope.profissionais = null;

    $ionicLoading.show();
    AgendaApi.getProfissionais($scope.getFiltros(), appendProfissionais);

    function appendProfissionais(results) { //console.log(results);

      $ionicLoading.hide();

      $scope.profissionais = results.Retorno;
      $ionicScrollDelegate.$getByHandle('mainScroll').anchorScroll(true);

      var filtro = $scope.getFiltros();

      if (filtro.ServicoId && filtro.Data) {

        results.Retorno.forEach(function (colaborador) {

          var filtro = $scope.getFiltros();
          filtro.ColaboradorId = colaborador.id;

          AgendaApi.getHorasNovo(filtro, function (r) {
            colaborador.horas = r.Retorno;
          });

        });

      }

    }

    $scope.current = null;

    $scope.select = function (item) {

      if (!$scope.current) {

        $scope.current = item;
        $scope.filtro.selProfissional = item;

        $scope.finalizar($scope.filtro);

      } /*else {

        $scope.current = null;

        $scope.alterar($scope.filtro,'selProfissional');

      }*/

    };

    $scope.selectHora = function (profissional, hora) {
      // if ( !$scope.currentHora ) {

      $scope.current = profissional;
      $scope.filtro.selProfissional = profissional;

      $scope.filtro.status = 2;
      // $scope.finalizar($scope.filtro);

      // $scope.status = 2;

      $scope.selectProfissionaltHora(profissional, hora);


      // }

    };

    $scope.reset = function () {

      $scope.current = null;

      $scope.alterar($scope.filtro, 'selProfissional');

    };

  }
]);

controllers.controller('FiltroDataCtrl', ['$scope', '$state', '$ionicPopup', 'deviceStorage', 'AgendaApi', '$cordovaCalendar', '$ionicLoading', '$ionicScrollDelegate', '$ionicPopover', '$cordovaAppRate',
  function ($scope, $state, $ionicPopup, deviceStorage, AgendaApi, $cordovaCalendar, $ionicLoading, $ionicScrollDelegate, $ionicPopover, $cordovaAppRate) {

    $scope.datas = null;

    $scope.calendarContent = [];

    $ionicLoading.show();
    AgendaApi.getDatas($scope.getFiltros(), appendDatas);

    function appendDatas(results) {
      $ionicLoading.hide();

      if (!results) return;

      $scope.datas = results.Retorno;

      $scope.calendarContent = [];

      for (var a = 0; a < results.Retorno.length; a++) {
        var agenda = results.Retorno[a];

        if (!$scope.calendarContent[agenda.DataNumero])
          $scope.calendarContent[agenda.DataNumero] = [];

        $scope.calendarContent[agenda.DataNumero].push(agenda);

      }

      $scope.$broadcast("updateCalendarContent", { calendarContent: $scope.calendarContent });


      $ionicScrollDelegate.$getByHandle('mainScroll').anchorScroll(true);
    }

    $scope.current = null;
    $scope.currentPerido = null;

    // $ionicPopover.fromTemplateUrl('periodo-popover.html', {
    //   scope: $scope
    // }).then(function(popover) {
    //   $scope.popover = popover;
    // });

    $scope.selectData = function ($event, day) {

      var item = day.content && day.content[0] || {
        DataNumero: day.date + '/' + day.month + '/' + day.year
      };

      // if ( !$scope.current ) {
      $scope.current = item;
      $scope.filtro.selData = item;
      // $scope.popover.show($event);
      // $ionicScrollDelegate.$getByHandle('mainScroll').anchorScroll(true);
      $scope.alterar($scope.filtro, 'selPeriodo');
      $scope.periodosDisponiveisMostrar = false;

      if ($scope.calendarContent[item.DataNumero]) {
        AgendaApi.periodosDisponiveis($scope.getFiltros(), onPeriodosDisponiveis);
      } else {
        onPeriodosDisponiveis({
          Retorno: []
        })
      }
      // $scope.finalizar($scope.filtro);
      // }
    };

    $scope.selectPeriodo = function (periodo) {

      if (!$scope.currentPerido) {

        // $scope.popover.hide();

        $scope.currentPerido = periodo;
        $scope.filtro.periodo = periodo;

        $scope.$emit('atualizarPeriodo', periodo.Periodo);

        $scope.finalizar($scope.filtro);

      }

    };

    $scope.reset = function () {

      $scope.current = null;
      $scope.currentPerido = null;

      $scope.alterar($scope.filtro, 'selData');

    };

    $scope.periodosDisponiveis = [];
    $scope.periodosDisponiveisMostrar = false;

    var onPeriodosDisponiveis = function (result) {
      $scope.periodosDisponiveis = result.Retorno;
      $scope.periodosDisponiveisMostrar = true;
    };
  }
])

  ;
