var controllers = angular.module('app.controllers');

controllers.controller('EditarAgendaCtrl', [ '$scope', '$state', 'Popup', 'deviceStorage', 'AgendaApi', '$stateParams',
  function($scope, $state, Popup, deviceStorage, AgendaApi, $stateParams) {

  //console.info(deviceStorage.get('agendamento'));

  //var USER = deviceStorage.get('user');
  //$scope.instituicao = USER.Retorno.RazaoSocialFilial;

  var agendamento = deviceStorage.get('agendamento');
  $scope.agendamento = agendamento;

  $scope.ag = {
    profissional: agendamento.idProfissional,
    data: agendamento.data,
    // hora: [ agendamento.horaInicio , agendamento.horaFim ]
    hora: {
      HorarioInicio: agendamento.horaInicio,
      HorarioFinal: agendamento.horaFim
    }
  };
  //console.log($scope.ag);

  $scope.mostrarProfissional = true;
  $scope.mostrarData = true;
  $scope.mostrarHora = true;
  $scope.mostrarAgendar = false;

  var appendProfissionais = function(results){

    $scope.mostrarData = true;

    $scope.profissionais = results.Retorno;
  };

  var updateSelProfissional = function(selectedItem){
    var requestProfissional = { 'servicoid' : selectedItem };
    AgendaApi.getProfissionais(requestProfissional, appendProfissionais);
  };

  var appendDatas = function(results){
    $scope.mostrarHora = true;
    $scope.datas = results.Retorno;
  };

  var updateSelData = function(selectedServico, selectedProfissional){
    var requestData = {
        profissionalid: selectedProfissional,
        servicoid: selectedServico
    };
    AgendaApi.getDatas(requestData, appendDatas);
  };

  var appendHoras = function(results){ //alert(JSON.stringify($scope.ag));
    results.Retorno.unshift( $scope.ag.hora );
    $scope.horas = results.Retorno;
    //console.log($scope.horas);
    //$scope.ag.hora = $scope.horas[0];
  };

  var updateSelHora = function(selectedData, selectedServico, selectedProfissional){
    var requestData = {
        profissionalid: selectedProfissional,
        servicoid: selectedServico,
        data: selectedData,
        Periodo: 0
    };
    AgendaApi.getHoras(requestData, appendHoras);
  };

  var appendUpdateData = function(results){
    $scope.datas = results.Retorno;
  };

  $scope.changeProfissional = function(selectedItem){

    delete $scope.datas;
    delete $scope.horas;

    $scope.mostrarHora = false;

    $scope.mostrarAgendar = false;

    $scope.ag = {
      profissional: selectedItem,
      data: null,
      hora: null
    };
    var requestData = {
        profissionalid: selectedItem,
        servicoid: agendamento.idServico
    };
    AgendaApi.getDatas(requestData, appendUpdateData);
  };

  var appendUpdateHora = function(results){
    $scope.horas = results.Retorno;
  };

  $scope.changeData = function(profissionalId, data){

    $scope.mostrarHora = true;

    $scope.mostrarAgendar = false;

    var requestData = {
        ColaboradorId: profissionalId,
        servicoid: agendamento.idServico,
        data: data
    };
    AgendaApi.getHoras(requestData, appendUpdateHora);
  };

  $scope.changeHora = function() {
    $scope.mostrarAgendar = true;
  };

  var postAgendar = function(data){
    if(data.Successeded){
      //navigator.notification.alert(data.Message);
      Popup.alert(data.Message);
      $state.go('client.dashboard');
    }else{
      //navigator.notification.alert(data.Message);
      Popup.alert(data.Message);
    }
  };

  $scope.editarAgendamento = function(ag){
    $scope.mostrarAgendar = false;
    var hora = ag.hora;
    var requestData = {
      agendaid: agendamento.idAgenda,
      data: ag.data,
      horainicio: hora.HorarioInicio,
      horafim: hora.HorarioFinal,
      profissionalid: ag.profissional,
      servicoid: agendamento.idServico
    }; //console.log(requestData);
    AgendaApi.editarAgenda(requestData, postAgendar);
  };

  var init = function(){
    updateSelProfissional(agendamento.idServico);
    updateSelData(agendamento.idServico, agendamento.idProfissional);
    updateSelHora(agendamento.data, agendamento.idServico, agendamento.idProfissional);
  };
  init();

}]);
