var controllers = angular.module('app.controllers');

controllers.controller('HistoricoCtrl', [ '$scope', '$state', 'deviceStorage', 'AgendaApi',
  function($scope, $state, deviceStorage, AgendaApi){

  $scope.status = {
    'P' : {'icon': 'ion-location', 'class' : 'icon-lightGreen'},
    'E' : {'icon': 'ion-checkmark', 'class' : 'icon-blue'},
    'C' : {'icon': 'ion-clock', 'class' : 'icon-lightBlue'},
    'R' : {'icon': 'ion-card', 'class' : 'icon-gray'},
    'M' : {'icon': 'ion-stats-bars', 'class' : 'icon-orange'},
    'A' : {'icon': 'ion-pin', 'class' : 'icon-gold'},
    'N' : {'icon': 'ion-card', 'class':'icon-brown' },
  };

  var jump = 10;

  var start = -jump;
  var end   = 0;

  var user = deviceStorage.get('user');

  //$scope.instituicao = user.Retorno.RazaoSocialFilial;
  $scope.events;
  $scope.noMoreItemsAvailable = false;

  var appendLoadMorePreviousEvents = function(results){
    // $scope.$broadcast('scroll.infiniteScrollComplete');
    $scope.loadMoreNextEvents = function(){

      if ( end > $scope.events ) return;
  
      start += jump;
      end   += jump;
  
      var requestData = {
        start: start.toString(),
        size: end.toString(),
        count: jump.toString()
      };
      AgendaApi.previousEvents(requestData, appendLoadMorePreviousEvents);
    };
    
    $scope.noMoreItemsAvailable = true;

    if (!results) return;

    //console.info(results);
    if ( results.Successeded && results.Retorno.length > 0 ){
      $scope.noMoreItemsAvailable = false;
      if ( !$scope.events ) $scope.events = [];
      $scope.events = $scope.events.concat(results.Retorno);
    }else{
      $scope.noMoreItemsAvailable = true;
    }
  };


  var appendRefreshPreviousEvents = function(results){
    $scope.events = results.Retorno;
    $scope.$broadcast('scroll.refreshComplete');
    start = 0;
    end   = jump;

    $scope.noMoreItemsAvailable = false;
  };

  $scope.refreshNextEvents = function(){
    var requestData = {
      start: '0',
      size: jump.toString(),
      count: jump.toString()
    };
    AgendaApi.previousEvents(requestData, appendRefreshPreviousEvents);
  };
  $scope.refreshNextEvents();
  $scope.goAgendar = function(){
    $state.go('client.agendar-servico');
  };

}]);

controllers.controller('HistoricoServicosCtrl', [ '$scope', '$rootScope', '$state', 'deviceStorage', 'AgendaApi',
  function($scope, $rootScope, $state, deviceStorage, AgendaApi){

    var last3Years = new Date();
    last3Years.setYear( last3Years.getFullYear() - 3 );

    var appendRefreshPreviousEvents = function(results){

      if (!results) {
        $scope.events = [];
        return;
      }

      $scope.events = results.Retorno;
      $scope.$broadcast('scroll.refreshComplete');
      $scope.noMoreItemsAvailable = false;
    };

    $scope.refreshNextEvents = function(){
      var requestData = {
          ClienteID : $rootScope.user.ClienteID,
          Data : last3Years.ddmmyyyy()
      };
      AgendaApi.HistoricoServicos(requestData, appendRefreshPreviousEvents);

    };

    $scope.refreshNextEvents();

}]);

controllers.controller('HistoricoProdutosCtrl', [ '$scope', '$rootScope', '$state', 'deviceStorage', 'AgendaApi',
  function($scope, $rootScope, $state, deviceStorage, AgendaApi){

    // $scope.events;

    var last3Years = new Date();
    last3Years.setYear( last3Years.getFullYear() - 3 );

    var appendRefreshPreviousEvents = function(results){
      $scope.events = results ? results.Retorno : [];
    };

    $scope.loadMoreNextEvents = function(){
      var requestData = {
        ClienteID : $rootScope.user.ClienteID,
        Data : last3Years.ddmmyyyy()
      };
      AgendaApi.HistoricoProdutos(requestData, appendRefreshPreviousEvents);

    };

    $scope.loadMoreNextEvents();

}]);
