var controllers = angular.module('app.controllers');

controllers.controller('PontosFidelidadeNewCtrl', 
  function($scope, $rootScope, PontosFidelidadeApi, $ionicLoading) {
  
  var appendPontosFidelidade = function (results) {

    if ( results.Retorno ) {
      $scope.PontosFidelidade = results.Retorno;
    }

    $rootScope.$broadcast('scroll.infiniteScrollComplete');
    $ionicLoading.hide();
  };

  $scope.refreshPontosFidelidade = function () {
    var requestData = {
      ClienteID : $rootScope.user.ClienteID
    };

    $ionicLoading.show();

    PontosFidelidadeApi.ConsultaPontosFidelidade(requestData, appendPontosFidelidade);
  };

  $scope.refreshPontosFidelidade();
  
});

angular.module('app.statesProvider')
  .config(function ($stateProvider, $urlRouterProvider) {
    $stateProvider
      .state('client.pontos-fidelidade-new', {
        url: "/pontos-fidelidade-new",
        views: {
          'menuContent' :{
            template: require('./template.html'),
            controller: 'PontosFidelidadeNewCtrl'
          }
        },
        cache: false
      })
});
