var controllers = angular.module('app.controllers');

controllers.controller('contributor.AgendaCtrl', [ '$scope', '$rootScope', '$state', 'deviceStorage', 'AgendaColaboradorApi', 'AgendaApi', '$ionicScrollDelegate', 'ColaboradorApi', '$ionicLoading','Popup', 'BannerApi', '$ionicPopup', '$ionicModal', '$filter','$window',
  function($scope, $rootScope, $state, deviceStorage, AgendaColaboradorApi, AgendaApi, $ionicScrollDelegate , ColaboradorApi , $ionicLoading, Popup, BannerApi, $ionicPopup, $ionicModal, $filter,$window){
    
    $scope.endereco = {};
    var user = deviceStorage.get('user').Retorno;

   

    $scope.util = {
      permissoes: deviceStorage.get('permissoes')
    };

    $scope.isManager = $state.is('manager.agenda')

    if ($scope.isManager) {
      var requestData = {
        "empresa": deviceStorage.get('salao').EmpresasID
      };

      $scope.manager = {
        currentColaborador: deviceStorage.get('user').Retorno
      };

      AgendaColaboradorApi.getListaColaboradores(requestData, function (result) {
        $scope.colaboradores = $filter('orderBy')(result.Colaboradores, 'NomeUsuario');
      });

   
    }

    $scope.status = {
      'P' : {'icon': 'ion-location', 'class' : 'icon-lightGreen'},
      'E' : {'icon': 'ion-checkmark', 'class' : 'icon-blue'},
      'C' : {'icon': 'ion-clock', 'class' : 'icon-lightBlue'},
      'R' : {'icon': 'ion-card', 'class' : 'icon-gray'},
      'M' : {'icon': 'ion-stats-bars', 'class' : 'icon-orange'},
      'A' : {'icon': 'ion-pin', 'class' : 'icon-gold'},
      ' ' : {'icon': 'ion-pin', 'class' : 'icon-gold'},
      'B' : {'icon': 'ion-ios-locked', 'class' : 'icon-red'},
      'L' : {'icon': 'ion-coffee', 'class' : 'icon-lightGray'},
      'N' : {'icon': 'ion-card', 'class':'icon-brown' },
      'X' : {'icon': 'ion-scissors', 'class':'icon-dark-green', 'descricao': 'APP_SCHEDULE_IN_ATTENDANCE' },
    };

    // var promoPopup = deviceStorage.get('promoPopup.salao_parceiro');
    // var utc = new Date().toJSON().slice(0,10).replace(/-/g,'/');

    // if (!promoPopup || promoPopup && promoPopup.utc !== utc) {
    //   promoPopup = {
    //     utc: utc,
    //     count: 1
    //   }
    // } else {
    //   promoPopup.count++;
    // }

    // deviceStorage.put('promoPopup.salao_parceiro', promoPopup );

    // if ( !$rootScope.promoPopup && promoPopup.count <= 2 ) {
    //   $rootScope.promoPopup = true;

    //   $ionicPopup.show({
    //     // templateUrl: 'templates/sobre.html',
    //     template: '<a href="http://mkt.onebeleza.com.br/palestra-salao-parceiro/">\
    //                  <img src="http://onemobilidade.azurewebsites.net/mobilidade/img/pop-up-salao-parceiro.png">\
    //                </a>',
    //     // title : 'Sobre',
    //     cssClass: 'promo-popup',
    //     buttons: [{ // Array[Object] (optional). Buttons to place in the popup footer.
    //       text: 'Fechar',
    //       type: 'button-positive',
    //       onTap: function(e) {
    //         // e.preventDefault() will stop the popup from closing when tapped.
    //         // e.preventDefault();
    //       }
    //     }]
    //   });

    // }

    // BannerApi.openBanner('session', 2);
    // BannerApi.openBanner('daily', 2);

    //$scope.user = deviceStorage.get('user').Retorno;

  //      BannerApi.openBanner('daily', 2, 'popup_auto_login', {
  //     $scope: $scope,
  //     template: '<img src="https://oneproducao.blob.core.windows.net/imgs/Aplicativo%20PERSONALIZADO.gif" ng-click="vaiLink()" width="100%" style="vertical-align: middle;">',
  //     buttons: [
  //            {
  //              type: 'ion-close',
  //            },
  //          ]
  //   })
  //   $scope.vaiLink = function() {
  //     var url="https://api.whatsapp.com/send?phone=5531984181864&text=Ol%C3%A1%2C%20quero%20saber%20mais%20sobre%20as%20promo%C3%A7%C3%B5es%20da%20Black%20November%20One%20Beleza";
  //     $window.open(url, '_blank');
  //  }


    // BannerApi.openBanner('daily', 2, 'popup_auto_login', {
    //               template: '<img src="https://oneproducao.blob.core.windows.net/imgs/Aplicativo%20PERSONALIZADO.gif" ng-click="myPopup.close()" width="100%" style="vertical-align: middle;">',
    //               buttons: [
    //                      {
    //                        type: 'ion-close',
    //                      },
    //                    ]
    //             });

    $scope.calendarContent = [];
    

    $scope.mostrarEndereco = function (evento){
      AgendaApi.getInfoBasicaEndereco({ ID: evento.idCliente },guardaEndereco);

      function guardaEndereco(results){
        results.Retorno.Endereco!=null ? $scope.endereco.endereco = results.Retorno.Endereco: $scope.endereco.endereco ='' ;
        results.Retorno.Bairro!=null? $scope.endereco.bairro = results.Retorno.Bairro: $scope.endereco.bairro='' ;
        results.Retorno.ComplementoEndereco!=null? $scope.endereco.complementoEndereco = results.Retorno.ComplementoEndereco:$scope.endereco.complementoEndereco='';
        results.Retorno.Celular!=null? $scope.endereco.celular = results.Retorno.Celular:$scope.endereco.celular='';
        results.Retorno.NumeroEndereco!=null? $scope.endereco.numeroEndereco= results.Retorno.NumeroEndereco:$scope.endereco.numeroEndereco='' ;
       
       var msg= "Rua/Avenida: " + $scope.endereco.endereco + '<br>'+
      'Número: '+ $scope.endereco.numeroEndereco + '<br> '+ 
      'Complemento ' + $scope.endereco.complementoEndereco +'<br>'+
      'Bairro: ' + $scope.endereco.bairro +'<br>'+
      'Celular: (' + $scope.endereco.celular.substr(0,2) + ')' + $scope.endereco.celular.substr(2,5) + '-' +  $scope.endereco.celular.substr(7,4); 
       
      $ionicPopup.alert({

        title: 'Endereço do cliente',
        template: msg,
        });
        }      
    }

    var appendAgendamentos = function (results) {

      $scope.$broadcast('scroll.refreshComplete');

      $scope.showLoader = false;

      $scope.calendarContent = [];

      if (!results) return;

      for ( var a = 0 ; a < results.Retorno.ListaAgendas.length ; a++ ) {
        var agenda = results.Retorno.ListaAgendas[a];

        if ( !$scope.calendarContent[agenda.data] )
          $scope.calendarContent[agenda.data] = [];

        $scope.calendarContent[agenda.data].push(agenda);

      }

      $scope.$broadcast("updateCalendarContent", {calendarContent: $scope.calendarContent});

    };

    var _startDate;
    var _endDate;

   

    $scope.updateAgendamentos = function (startDate, endDate, showLoader) {

      $scope.showLoader = showLoader;
      
     AgendaColaboradorApi.DerrubarUsuario(function (result) {
        
        
        if (result.Successeded == false)
         {
          deviceStorage.remove('user');
          deviceStorage.remove('loginType');
	      	deviceStorage.remove('saloesUsuario');
          $rootScope.logged = false;
          $state.go('entrar', {entrar: 0});
         }

  
        
      });
     

      var requestData = {
          DataInicio: startDate.ddmmyyyy(),
          DataFinal: endDate.ddmmyyyy(),
          ColaboradorID: $scope.isManager ? $scope.manager.currentColaborador.ColaboradorID : deviceStorage.get('user').Retorno.ColaboradorID
      };
      AgendaColaboradorApi.getInformacoesAgendamentosProfissional(requestData, appendAgendamentos);
    };

    $scope.updateColaborador = function(colaborador) {
      if (!colaborador) return;
      $scope.manager.currentColaborador = colaborador.originalObject;
      $scope.updateAgendamentos( _startDate , _endDate , true );
    };

    $scope.refresh = function() {
      $scope.updateAgendamentos( _startDate , _endDate , true );
    };

    $scope.selectActiveDay = function(activeDay) { //console.log(activeDay);
      $scope.activeDay = activeDay;
      var today = new Date();
      $scope.mostraLancamento=false;
      var dataage = ( new Date(activeDay.month+'/'+activeDay.date+'/'+activeDay.year));
       dataage <= today ?mostraLancamento= true : mostraLancamento= false;
       $scope.mostraLancamento = mostraLancamento;
     

      var events = [];
      var clientesCodigo = [];

      if ( activeDay.content && activeDay.content.length ) {

        var first = angular.copy(activeDay.content[0]);
        first.horaFim = first.horaInicio;
        first.horaInicio = 'Início do dia';
        first.nomeCliente = '';
        first.servico = 'Horário livre';
        first.letraStatus = 'L';
        first.status = '';
        first.Observacao = '';
        events.push(first);

        for (var i = 0; i < activeDay.content.length - 1 ; i++) {

          var day = activeDay.content[i];
          var space = angular.copy(day);
          space.horaInicio = space.horaFim;
          space.horaFim = activeDay.content[i+1].horaInicio;
          space.servico = 'Horário livre';
          space.nomeCliente = '';
          space.letraStatus = 'L';
          space.status = '';
          space.Observacao = '';

          clientesCodigo.push(day.idCliente.toString());

          events.push(day);

          if ( space.horaInicio < space.horaFim )
            events.push(space);

        };

        var day = activeDay.content[i];
        events.push(day);

        var last = angular.copy(day);
        last.horaInicio = last.horaFim;
        last.horaFim = 'Fim do dia';
        last.nomeCliente = '';
        last.servico = 'Horário livre';
        last.letraStatus = 'L';
        last.status = '';
        last.Observacao = '';
        events.push(last);

      } else {
        // debugger;
        var first = {};//angular.copy(activeDay.content[0]);
        first.data = activeDay.date + '/' + activeDay.month + '/' + activeDay.year;
        first.horaFim = 'Fim do dia';
        first.horaInicio = 'Início do dia';
        first.nomeCliente = '';
        first.servico = 'Horário livre';
        first.letraStatus = 'L';
        first.status = '';
        first.Observacao = '';
        events.push(first);
      }

      $scope.events = events;


      // $scope.events.push({});

      $ionicScrollDelegate.resize();

      AgendaApi.ListarHorariosAgendadosDeClientesAA(
        {
          ClientesIds: clientesCodigo.join('#'),
          DataEscolhida: (new Date(activeDay.year, activeDay.month-1, activeDay.date)).ddmmyyyy()
        }, function (resposta) {

          if (!resposta) {
            $scope.events = [];
            return;
          }

          angular.forEach(resposta.Retorno, function(item, index){
            angular.forEach($scope.events, function(item2, index2){

              if(item.ClienteID === item2.idCliente){
                item2.marcacoes =  item.QuantidadeDeAgendamentos;
              }
            });

          });

        });

    };

    $ionicModal.fromTemplateUrl('templates/contributor/agenda/modal_deEspera.html', {
      scope: $scope,
      animation: 'slide-in-up'
    }).then(function(modal) {
      $scope.modalEspera = modal;
      // $scope.modalEspera.show();
    });

    $scope.openModalEspera = function() {
      $scope.modalEspera.show();
    };
    $scope.closeModalEspera = function() {
      $scope.modalEspera.hide();
    };

    $scope.DesmarcarDesbloquearEvento = function( evento ){
      $scope.openModalEspera();
      AgendaApi.cancelarAgendamentoAA({Id:evento,
        ColaboradorId: deviceStorage.get('user').Retorno.ColaboradorID
      },function(resposta){
        if(resposta.Successeded===true){
          $scope.closeModalEspera();
          $state.transitionTo($state.current, {},{reload:true});

        }
      });
    };

    $scope.selectActiveMonth = function( startDate , endDate ) { //console.log( startDate , endDate );

      _startDate = startDate;
      _endDate = endDate;

      $scope.updateAgendamentos( startDate , endDate , true );

    };

    //$scope.selectActiveMonth( new Date( 2012 , 0 , 1 ) , new Date( 2015 , 1 , 1 ) );

    $scope.selectServico = function( evento ) {
     
      $scope.util = {};
      $scope.util.permissoes = deviceStorage.get('permissoes');
      var checarSePodeSelecionarCliente = function(permissaoSomenteParaClientePresente, estaPresente){
        
            return ( !permissaoSomenteParaClientePresente || ((estaPresente||evento.letraStatus==='P') && permissaoSomenteParaClientePresente) );
      };
      if( checarSePodeSelecionarCliente ($scope.util.permissoes.PermitirLancamentosSomenteClientePresente, evento.EstaPresente) ){
      ColaboradorApi.client = {
        ClienteID : evento.idCliente,
        NomeCompleto : evento.nomeCliente
      };

      var requestData = {
        ClienteID : evento.idCliente
      };

      $ionicLoading.show();

      ColaboradorApi.consultarlistaregistroservicos( requestData , function(results) {

        $ionicLoading.hide();

        if ( results.Retorno.ListaRegistrosServicos.length ) {

          //caso o serviço atual já esteja cadastrado
          var found = false;

          ColaboradorApi.serviceList = results.Retorno.ListaRegistrosServicos;

          for (var i = 0; i < ColaboradorApi.serviceList.length; i++) {
            var service = ColaboradorApi.serviceList[i];

            if ( evento.idServico == service.ServicosID )
              found = true;

            if ( service.ColaboradorAuxiliarNome )
              service.auxiliar = {nome:service.ColaboradorAuxiliarNome};

            service.quimicas = [];

            var requestData = {
              RegistroServicosID : service.RegistroServicosID
            };

            ColaboradorApi.ConsultarListaRegistroQuimicas( requestData , function(results) {

              for (var s = 0; s < ColaboradorApi.serviceList.length; s++) {
                var service = ColaboradorApi.serviceList[s];

                for (var i = 0; i < results.Retorno.ListaRegistroQuimicas.length; i++) {
                  var quimica = results.Retorno.ListaRegistroQuimicas[i];

                  quimica.product = { Descricao : quimica.ProdutoNome };
                  quimica.parte = quimica.Partes;

                  if ( service.RegistroServicosID == quimica.RegistroServicosID ) {

                    if ( quimica.Partes || quimica.ProdutoID ) {
                      service.quimicas.push( quimica );
                    }

                    service.quimica_observacao = quimica.Observacao;

                  }

                }

              }

            });

            //ConsultarListaRegistroQuimicas

          }

          if ( found ) {

            $ionicLoading.show();

            return ColaboradorApi.findComiservs({
              'servicoid': service.ServicosID,
              'ClienteID': evento.idCliente
            }, function(results){

              $ionicLoading.hide();

              if ( results.Retorno.ListaComiservs.length ) {

                var Comiserv = results.Retorno.ListaComiservs[0];

                service.PrecoUnitarioVenda = Comiserv.ValorServico;
                service.DescontoMaximo = Comiserv.DescontoMaximo;
                service.SobrePrecoMaximo = Comiserv.SobrePrecoMaximo;
                service.ColaboradorAuxiliarID = Comiserv.ColaboradorAuxiliarID;
                service.LimiteQuantidadeOrcamento = Comiserv.LimiteQuantidadeOrcamento;
                // console.log(service,results.ListaComiservs[0].ValorServico);

                if ( Comiserv.ServicoAuxiliarID ) {
                  return $state.go('contributor.servicos-resumo');
                } else {
                }

              }

              if ( service.UsaQuimica ) {
                $state.go('contributor.servicos-quimica');
              } else {
                // ColaboradorApi.serviceList.push( service );
                $state.go('contributor.servicos-resumo');
              }

            });

            // return $state.go('contributor.servicos-resumo');

          }

        } else {

          ColaboradorApi.serviceList = [
          ];

        }

        service = {
          Descricao: evento.servico,
          GrupoID: evento.idGrupoServico,
          ID: evento.idServico,
          QuantidadeVendida: 1,
          UsaQuimica: evento.TemQuimica
        };

        //guardo o service para adicionar depois de selecionado auxiliar e quimica, quanto tiver
        ColaboradorApi.currentService = service;

        $ionicLoading.show({
          template: 'loading'
        });

        ColaboradorApi.findComiservs({
          'servicoid': service.ID,
          'ClienteID': evento.idCliente
        }, function(results){

          $ionicLoading.hide();

          if ( results.Retorno.ListaComiservs.length ) {

            var Comiserv = results.Retorno.ListaComiservs[0];

            service.PrecoUnitarioVenda = Comiserv.ValorServico;
            service.DescontoMaximo = Comiserv.DescontoMaximo;
            service.SobrePrecoMaximo = Comiserv.SobrePrecoMaximo;
            service.ColaboradorAuxiliarID = Comiserv.ColaboradorAuxiliarID;
            service.LimiteQuantidadeOrcamento = Comiserv.LimiteQuantidadeOrcamento;
            service.OrcamentoPacoteServico = Comiserv.OrcamentoPacoteServico;
            service.OrcamentoServico = Comiserv.OrcamentoServico;
            // console.log(service,results.ListaComiservs[0].ValorServico);

            if ( Comiserv.ServicoAuxiliarID ) {
              return $state.go('contributor.servicos-auxiliar');
            } else {
            }

          }

          if ( service.UsaQuimica ) {
            $state.go('contributor.servicos-quimica');
          } else {
            ColaboradorApi.serviceList.push( service );
            $state.go('contributor.servicos-resumo');
          }

        });
      // }

      });

     }
      else{

        Popup.alert('Esse cliente não está presente.');
      }

    };

    $scope.iniciarAtendimento = function( evento ){
      $ionicLoading.show();
      AgendaApi.clienteEmAtendimento({
        Id:evento,
        ColaboradorId: deviceStorage.get('user').Retorno.ColaboradorID
      },function(resposta){
        $ionicLoading.hide();
        if(resposta.Successeded===true){
          $state.transitionTo($state.current, {},{reload:true});
        }
      });
    };

    $ionicModal.fromTemplateUrl('templates/contributor/agenda/modalMostrarOutrasMarcacoesNoDia.html', {
      scope: $scope,
      animation: 'slide-in-up'
    }).then(function(modal) {
      $scope.modalOutrosAgendamentos = modal;
    });

    $scope.openModalOutrosAgendamentos = function() {
      $scope.modalOutrosAgendamentos.show();
    };
    $scope.closeModalOutrosAgendamentos = function() {
      $scope.modalOutrosAgendamentos.hide();
    };

    $scope.ObterMarcacoes = function(data, cliente){
        $scope.mostrarOutrosAgendamentos = false;
        AgendaApi.ListarHorariosAgendadosDoClienteAA({ClienteID:cliente, DataEscolhida:data}, function(evento){
        $scope.listaDeAgendamentosDoCliente  = evento.Retorno;
        $scope.mostrarOutrosAgendamentos = true;


        });
         $scope.modalOutrosAgendamentos.show();
    };

  }
])

.controller('contributor.AgendaBloquearHorarioCtrl', [ '$scope', '$state', 'deviceStorage', 'AgendaColaboradorApi', '$ionicScrollDelegate', 'ColaboradorApi', '$ionicLoading','AgendaApi','$stateParams','$ionicModal', '$ionicPopup','$ionicHistory',
  function($scope, $state, deviceStorage, AgendaColaboradorApi , $ionicScrollDelegate , ColaboradorApi , $ionicLoading, AgendaApi, $stateParams,$ionicModal, $ionicPopup,$ionicHistory ){
  $scope.util = {};
  $scope.util.permissoes = deviceStorage.get('permissoes');

  $scope.util.user = deviceStorage.get('user').Retorno;
  $scope.util.tituloModal = "";
  $scope.util.carregando = true;
  $scope.util.mostrarListHorarioInicio = true;
  $scope.util.model = {};
  $scope.util.model.listaDeHorarios = [];
  $scope.util.model.horarioInicio ="";
  $scope.util.model.horarioFim = "";
  $scope.util.model.data = $stateParams.data;

  $ionicModal.fromTemplateUrl('templates/contributor/agenda/modal_escolhaDeHorario.html', {
    scope: $scope,
    animation: 'slide-in-up'
  }).then(function(modal) {
    $scope.modal = modal;
  });

  AgendaApi.ListarHorariosDisponiveisParaBloqueioAA({
    DataAtual: $stateParams.data,
    HoraInicial: $stateParams.horaInicial === 'Início do dia'? -1 : $stateParams.horaInicial,
    HoraFinal: $stateParams.horaFinal === 'Fim do dia'? -1 : $stateParams.horaFinal,
    FilialID:  $scope.util.user.IdFilial,
    Colaborador:  $scope.util.user.ColaboradorID

  },function(resposta){
     $scope.util.model.listaDeHorarios = resposta.Retorno;
     $scope.util.carregando =  false;
  });

  $scope.openModal = function(horarioInicio) {
    // horarioInicio == 1
    // horarioFim == 2
    if(horarioInicio === 1){
      $scope.util.mostrarListHorarioInicio = true;
      $scope.util.tituloModal = "Horario início";
    }else{
      $scope.util.mostrarListHorarioInicio = false;
      $scope.util.tituloModal = "Horario fim";
    }
    $scope.modal.show();
  };
  $scope.closeModal = function() {
    $scope.modal.hide();
  };

  var alertPopup = "";
  $scope.enviarBloqueo = function(){
    if($scope.util.model.horarioInicio === ""){
       alertPopup = $ionicPopup.alert({
         title: 'Error',
         template: 'A hora inicial deve ser escolhida.'
       });
    }
    else if($scope.util.model.horarioFim === ""){
      alertPopup = $ionicPopup.alert({
         title: 'Error',
         template: 'A hora final deve ser escolhida.'
       });
    }
    else{

      if($scope.util.model.horarioInicio.Id < $scope.util.model.horarioFim.Id){

        AgendaApi.BloquearHorarioAA({
              horaInicio: $scope.util.model.horarioInicio.Hora,
              data: $scope.util.model.data,
              horaFim:$scope.util.model.horarioFim.Hora,
              FilialID:  $scope.util.user.IdFilial,
              cliForColsId:  $scope.util.user.ColaboradorID
            }, function(resposta){
                if(resposta.Successeded === true){
                  alertPopup = $ionicPopup.alert({
                  title: 'Sucesso',
                  template: 'O horário foi bloqueado com sucesso.'
                  });
                  $state.go("contributor.agenda");

                }
                else{
                  alertPopup = $ionicPopup.alert({
                    title: 'Error',
                    template: 'Ocorreu algum erro durante o processo. Por favor contate o suporte e informe o máximo de detalhes possível.'+ e.Message
                    });
                  }

            });

      }else{
         alertPopup = $ionicPopup.alert({
           title: 'Error',
           template: 'A hora inicial deve ser menor que a hora final.'
         });
        }
    }

  };


}])

.controller('contributor.AgendaMarcarCtrl', [ '$scope', '$state', 'deviceStorage', 'AgendaColaboradorApi', '$ionicScrollDelegate', 'ColaboradorApi', '$ionicLoading','$cordovaCalendar','AgendaApi','$ionicPopup','$stateParams','$http','APP_URL_NEW', '$filter',
  function($scope, $state, deviceStorage, AgendaColaboradorApi , $ionicScrollDelegate , ColaboradorApi , $ionicLoading, $cordovaCalendar, AgendaApi, $ionicPopup, $stateParams,$http, APP_URL_NEW, $filter ){
  var user = deviceStorage.get('user').Retorno;


  $scope.util = {};
  $scope.util.permissoes = deviceStorage.get('permissoes');
  $scope.util.parametros = {};
  $scope.util.parametros.data = $stateParams.data;
  //$scope.util.parametros.hora = $stateParams.hora;
  $scope.util.parametros.usuarioNome = user.NomeUsuario;
  $scope.util.parametros.usuarioID = user.ColaboradorID;
  $scope.util.parametros.ClienteAutoComplete = {};
  $scope.util.parametros.Cliente = {};


    $scope.instituicao = user.RazaoSocialFilial;
    // try {
    //   $cordovaCalendar.createCalendar({
    //     calendarName: 'One Beleza & Bem-estar',
    //     calendarColor: '#86b91a'
    //   }).then(function (result) {
    //     // alert('result: ' + result);
    //   }, function (err) {
    //     // alert('erro: ' + err);
    //     // error
    //   });
    // } catch(e) {
    //     // alert('catch: ' + e);
    // }
    // $cordovaCalendar.deleteCalendar('One Beleza & Bem-estar').then(function (result) {
    //   // success
    // }, function (err) {
    //   // error
    // });

    $scope.ag = {};

    $scope.mostrarGrupoServicos = false;
    $scope.mostrarServico       = false;
    $scope.mostrarProfissional  = false;
    $scope.mostrarData          = false;
    $scope.mostrarHora          = false;
    $scope.mostrarAgendar       = false;

    var appendGrupoServicos = function(results){
      $scope.grupoServicos        = results.Retorno;
    };
    AgendaApi.getGrupoServicosWithUser2({ ID: user.ClienteID },appendGrupoServicos);

    var appendServicos = function(results){
      $scope.servicos             = results.Retorno;
    };

    $scope.updateSelServico = function(selectedItem){
   
      $scope.mostrarServico       = true;
      $scope.mostrarProfissional  = false;
      $scope.mostrarData          = false;
      $scope.mostrarHora          = false;
      $scope.mostrarAgendar       = false;

      $scope.servicos             = null;

      var requestGrupoServico = {
        'grupo_id' : selectedItem,
        Disponivel_Mobilidade : true,
        'Colaborador_ID': $scope.util.parametros.usuarioID
      };

      AgendaApi.getServicosDoColaboradorSemMobilidade(requestGrupoServico, appendServicos);
    };

    var appendProfissionais = function(results){ //console.log(results);
      $scope.profissionais        = results.Retorno;
    };

    $scope.updateSelProfissional = function(selectedItem){ //console.log(selectedItem);
      $scope.mostrarProfissional  = true;
      $scope.mostrarData          = true;
      $scope.mostrarHora          = true;
      $scope.mostrarAgendar       = true;

      $scope.profissionais        = null;

      var requestProfissional = { 'servicoid' : selectedItem };
      AgendaApi.getProfissionais(requestProfissional, appendProfissionais);
      //$scope.ag.selProfissional = null;
    };

    // var appendDatas = function(results){
    //   $scope.datas            = results.Retorno;
    // };

    // $scope.updateSelData = function(selectedServico, selectedProfissional){
    //   $scope.mostrarData      = true;
    //   $scope.mostrarAgendar   = false;
    //   $scope.mostrarHora      = false;
    //   $scope.datas            = null;
    //   var requestData = {
    //       profissionalid: selectedProfissional.id,
    //       servicoid: selectedServico
    //   };
    //   AgendaApi.getDatas(requestData, appendDatas);
    // };

    var appendHoras = function(results){ //console.log(results.Retorno);
      $scope.horas          = results.Retorno;
      $scope.ag.selHora     = null;
    };

    $scope.updateSelHora = function(selectedData, selectedServico, selectedProfissional){

      $scope.mostrarProfissional  = true;
      $scope.mostrarData          = true;
      $scope.mostrarHora          = true;
      $scope.mostrarAgendar       = false;

      $scope.horas          = null;

      var requestData = {
          profissionalid: selectedProfissional,
          servicoid: selectedServico,
          data: selectedData
      };
      AgendaApi.getHoras(requestData, appendHoras);
    };

    // $scope.updateSelHora("13/07/2018","282",8916);

    $scope.scrollBottom = function () {
      $ionicScrollDelegate.scrollBottom();
    }

    $scope.closeSelHora = function() {
      $scope.mostrarAgendar = true;
    };

    var validate = function(data){
      return true;
    };

    var postAgendar = function(data) {

      $ionicLoading.hide();

      if ( data.Successeded ) {

        var startDate = Date.ddmmyyyy( $scope.util.parametros.data );
        startDate.sethhmm( $scope.util.parametros.data );

        var endDate = Date.ddmmyyyy( $scope.util.parametros.data );
        endDate.sethhmm( $scope.util.parametros.data );


        $ionicPopup.alert({title: $filter('translate')(data.Message) });
        $state.go('contributor.agenda');

      } else {


        $ionicPopup.alert({title: $filter('translate')(data.Message) });

      }

    };

    $scope.gravarAgendamento = function(result){
      
      $ionicLoading.show();

      if(validate(result)){
        var hora = result.selHora;//.split(" - ");
        var requestData = {
          data: $scope.util.parametros.data,
          horainicio: hora.HorarioInicio,
          horafim: hora.HorarioFinal,
          profissionalid: $scope.util.parametros.usuarioID,
          servicoid: result.selServico.ID,
          clienteID: $scope.util.parametros.Cliente.ClienteID,
          Observacao: result.observacao
        };
        AgendaApi.postAgendarAA(requestData, postAgendar);
      }
    };

    $scope.util.parametros.ClienteAutoComplete.URLREQUEST = function(parametroDigitado) {
      return $http({
          method: 'POST',
          headers: {
              'X-Token': deviceStorage.get('user').Token
          },
                url: APP_URL_NEW+'colaborador/PesquisarClienteAA',
          data: JSON.stringify({"PalavraPesquisaCliente":parametroDigitado, "QuantidadeMaximaDeRegistro": 0 })
      });
    };
    $scope.util.parametros.ClienteAutoComplete.ClienteEscolhido = function(selected) {
      // debugger;
    

      if (selected && selected.originalObject && selected.originalObject.ClienteID) {
        $scope.util.parametros.Cliente = selected.originalObject;
        $scope.mostrarGrupoServicos = true;
        $scope.mostrarServico       = false;
        $scope.mostrarProfissional  = false;
        $scope.mostrarData          = false;
        $scope.mostrarHora          = false;
        $scope.mostrarAgendar       = false;
        
      }
    };

    // $scope.util.parametros.ClienteAutoComplete.changeInputCliente = function(id) {
    //     $scope.util.parametros.Cliente = null;
    // };

}])
  