angular.module('app.controllers')
  .controller('contributor.PesquisaSatisfacaoCtrl',
    function ($scope, ColaboradorApi, deviceStorage, $ionicScrollDelegate, $ionicLoading, $timeout, $state, AgendaColaboradorApi, $filter, $stateParams, ManagerApi, $ionicModal) {
    // $scope.isManager = $state.is('manager.pesquisa-satisfacao');

    // if ($scope.isManager) {
    //   var requestData = {
    //     "empresa": deviceStorage.get('salao').EmpresasID
    //   };

    //   $scope.manager = {
    //     currentColaborador: deviceStorage.get('user').Retorno
    //   };

    //   AgendaColaboradorApi.getListaColaboradores(requestData, function (result) {
    //     $scope.colaboradores = $filter('orderBy')(result.Colaboradores, 'NomeUsuario');
    //   });
    // }

    $scope.isManager = $stateParams.ProfissionalId;
    $scope.profissionalId = $stateParams.ProfissionalId;
    $scope.colaborador = $stateParams.Campo;

    // $scope.currentColaborador.ColaboradorID

    // $scope.updateColaborador = function(colaborador) {
    //   if (!colaborador) return;
    //   $scope.manager.currentColaborador = colaborador.originalObject;
    //   updateContent();
    // };

    $scope.onScroll = function ($event) {
      var scrollView = $ionicScrollDelegate.$getByHandle('pesquisa-satisfacao').getScrollView();

      if (scrollView.__maxScrollTop == 0) {
        size = 0;
      } else {
        var size = ((1 - scrollView.__scheduledTop / scrollView.__maxScrollTop) / 3) * 100;
      }

      /*size > 0 && */$timeout(function () {
        $scope.scrollLimit = {
          height: Math.min(Math.max(size, 0), 30) + '%'
        };
      });

      // document.styleSheets[0].addRule(".pesquisa-satisfacao ion-content::after", 'height: ' + size + '% !important;');
      // $('.pesquisa-satisfacao style').innerHTML = '.pesquisa-satisfacao ion-content:after {height: ' + size + '% !important;}'
    }

    var filter = {
      notaminima: 1,
      notamaxima: 5,
      // DataInicio: (new Date(2018,7,1)),
      // DataFinal: (new Date(2018,8,1)),
    };

    function updateContent () {
      $ionicLoading.show();

      ( $scope.isManager ? ManagerApi.getMediaProfissionalGerente : ColaboradorApi.RetornaMediaProfissional)({
      // ManagerApi.getMediaProfissionalGerente({
        ColaboradorID: $scope.isManager ? $stateParams.ProfissionalId : deviceStorage.get('user').Retorno.ColaboradorID,
        TextoObservacao: $stateParams.Campo,
        comentarios: filter.comentarios,
        notaminima: filter.notaminima,
        notamaxima: filter.notamaxima,
        DataInicio: filter.DataInicio && filter.DataInicio.ddmmyyyy(),
        DataFinal: filter.DataFinal && filter.DataFinal.ddmmyyyy()
      }, function (mediaProfissional) {
        $ionicLoading.hide();
        $scope.$broadcast('scroll.refreshComplete');

        if (mediaProfissional && mediaProfissional.Successeded == true) {
          $scope.mediaProfissional = mediaProfissional.Retorno[0];

          $scope.items = 10;
          $scope.noMoreItemsAvailable = false;

          // for (var i = 0; i < 30; i++) {
          //   $scope.mediaProfissional.Comentarios.push({
          //     "ClienteComentario": "Bernardo Coutinho" + i,
          //     "DataComentario": "2018-05-" + parseInt(Math.random() * 20 + 10) + "T00:00:30",
          //     "NotaComentario": parseInt(Math.random() * 5 + 1),
          //     "TextoComentario": i + "Gostei do corte !"
          //   })
          // }

          $ionicScrollDelegate.resize()
            .then(function () {
              $scope.onScroll();
            });
        } else {
          $scope.mediaProfissional = false;
        }
      });
    }
    updateContent();

    $scope.loadMore = function() {
      $scope.items += 10;

      $scope.noMoreItemsAvailable = $scope.mediaProfissional && $scope.items >= $scope.mediaProfissional.Comentarios.length;

      $scope.$broadcast('scroll.infiniteScrollComplete');
    };

    $scope.doRefresh = function() {
      updateContent();
    };

    $scope.filterFunction = function (value, index, array) {
      return true;
      // console.log([value.DataComentario , filter.startDate, value.DataComentario >= new Date(filter.startDate)]);
      return true
        && (value.TextoComentario || !filter.commentsOnly)
        && value.NotaComentario >= filter.min
        && value.NotaComentario <= filter.max
        && (!filter.startDate || new Date(value.DataComentario) >= filter.startDate)
        // && (!filter.finishDate || value.DataComentario <= new Date(filter.finishDate))
    }

    $ionicModal.fromTemplateUrl('pesquisa-satisfacao/filter.html', {
      scope: $scope,
      animation: 'slide-in-up'
    }).then(function(modal) {
      $scope.filterModal = modal;
      // $scope.showFilterModal();
    });

    $scope.showFilterModal = function () {
      $scope.modalFilter = angular.copy(filter);
      $scope.filterModal.show();
    };

    $scope.closeModal = function () {
      $scope.filterModal.hide();
    };

    $scope.filtrar = function () {
      filter = angular.copy($scope.modalFilter);
      updateContent();
      $scope.filterModal.hide();
    };

    $scope.resetFilter = function () {
      $scope.modalFilter = {
        notaminima: 1,
        notamaxima: 5,
        // DataInicio: (new Date(2018,7,1)),
        // DataFinal: (new Date(2018,8,1)),
      };
    }

    // Cleanup the modal when we're done with it!
    $scope.$on('$destroy', function() {
      $scope.filterModal.remove();
    });

    // Execute action on hide modal
    $scope.$on('modal.hidden', function() {
      // Execute action
    });

    // Execute action on remove modal
    $scope.$on('modal.removed', function() {
      // Execute action
    });

    $scope.sameMonth = function (comment1, comment2) {
      return comment1.DataComentario.substring(0, 7) == comment2.DataComentario.substring(0, 7);
    }

  });

angular.module('app.statesProvider')
  .config(function ($stateProvider, $urlRouterProvider) {
    $stateProvider
      .state('contributor.pesquisa-satisfacao', {
        url: '/pesquisa-satisfacao',
        views: {
          'menuContent': {
            template: require('./template.html'),
            controller: 'contributor.PesquisaSatisfacaoCtrl'
          }
        },
        cache: false
      })
});
