var controllers = angular.module('app.controllers');

controllers.controller('contributor.ProdutosCtrl', [ '$scope', '$state', 'deviceStorage', 'ColaboradorApi', '$ionicScrollDelegate','Popup',
  function($scope, $state, deviceStorage, ColaboradorApi, $ionicScrollDelegate,Popup) {

    $scope.limit = 10;

    $scope.noMoreItemsAvailable = true;
    $scope.util = {};
    $scope.util.permissoes = deviceStorage.get('permissoes');
    $scope.loadMoreClients = function(){

      $scope.limit += 10;

      $scope.noMoreItemsAvailable = $scope.clients.length < $scope.limit;
      $scope.$broadcast('scroll.infiniteScrollComplete');
      $ionicScrollDelegate.resize();

    };

    var onFindClients = function(results) {

      if (!results) {
        $scope.clients = [];
        return;
      }

      $scope.limit = 10;
      $scope.clients = results.Retorno.ListaClientes;
      $scope.noMoreItemsAvailable = $scope.clients.length < $scope.limit;

      $ionicScrollDelegate.resize();
      $ionicScrollDelegate.scrollTop();

    };

    $scope.clearClients = function() {
      delete $scope.clients;
    };

    $scope.findClientsPresence = function(){
       delete $scope.clients;
       $scope.clients = null;

      requestData = {
        PalavraPesquisaCliente: '',
        EstaPresente:true,
      };
      ColaboradorApi.findClients(requestData, onFindClients);
    };
    $scope.findClients = function(clientName) { //console.log(clientName);

      var requestData;

      if (
        clientName.length >= 1 && !isNaN(clientName) || clientName.length >= 3
       ) {
        $scope.clients = null;
        requestData = {
          PalavraPesquisaCliente: clientName
        };
        ColaboradorApi.findClients(requestData, onFindClients);
      }

    };

    var onConsultarlistaregistroprodutos = function(results) {

      if ( results.Retorno.ListaRegistrosProdutos && results.Retorno.ListaRegistrosProdutos.length ) {

        ColaboradorApi.productList = results.Retorno.ListaRegistrosProdutos;

        $state.go('contributor.produtos-resumo');

      } else {
        $state.go('contributor.produtos-produto');
      }

    };

    $scope.selectClient = function(client) { //console.log(client);
      var checarSePodeSelecionarCliente = function(permissaoSomenteParaClientePresente, estaPresente){
            return ( !permissaoSomenteParaClientePresente || (estaPresente && permissaoSomenteParaClientePresente) );
      };
      if( checarSePodeSelecionarCliente ($scope.util.permissoes.PermitirLancamentosSomenteClientePresente, client.EstaPresente) ){
        ColaboradorApi.client = client;

        ColaboradorApi.productList = [];

        var requestData = {
          ClienteID : client.ClienteID
        };

        ColaboradorApi.consultarlistaregistroprodutos( requestData , onConsultarlistaregistroprodutos );

      }
      else{

        Popup.alert('Esse cliente não está presente.');
      }

    };

}
]);

controllers.controller('contributor.ProdutosProdutoCtrl', [ '$scope', '$state', 'deviceStorage', 'ColaboradorApi', '$cordovaBarcodeScanner',
  function($scope, $state, deviceStorage, ColaboradorApi , $cordovaBarcodeScanner ) {

  /**
  * selecionar produto
  */

  $scope.vFabricante = null;
  $scope.vLinha = null;
  $scope.closed = true;
  $scope.closedLinha = true;

  $scope.toggleListFabricante = function () {
    $scope.closed = !$scope.closed;
  };

  $scope.toggleListLinha = function () {
    $scope.closedLinha = !$scope.closedLinha;
  };

  var onFindFabricantes = function(results) { //console.log(results);
    $scope.fabricantes = results.Retorno;
  };

  $scope.findFabricantes = function() {

    var requestData = {
    };

    ColaboradorApi.findFabricantes(requestData, onFindFabricantes);

  };

  $scope.selectFabricante = function(fabricante) {

    $scope.findLinhas(fabricante);
    $scope.vFabricante = fabricante;
    $scope.products = null;
    $scope.vLinha = null;
    $scope.closed = true;

  };


  var onFindLinhas = function(results) { //console.log(results);
    $scope.linhas = results.Retorno;
  };

  $scope.findLinhas = function(fabricante) {

    var requestData = {
          FabricanteID: fabricante.FabricanteID
    };

    ColaboradorApi.findLinhas(requestData, onFindLinhas);

  };

  $scope.selectLinha = function(linha) { //console.log(product);

    $scope.findProducts($scope.vFabricante, linha);
    $scope.vLinha = linha;
    $scope.closedLinha = true;
  };

  var onFindProducts = function(results) {
    $scope.products = results.Retorno.ListaProdutos;
  };

  $scope.findProducts = function(fabricante, linha) {

    var requestData = {
      FabricanteID: fabricante.FabricanteID,
      LinhaID: linha.LinhaID,
      ClienteID: ColaboradorApi.client.ClienteID
    };

    ColaboradorApi.findProducts(requestData, onFindProducts);

  };

  $scope.selectProduct = function(product) { //console.log(product);

    //ColaboradorApi.productList.push(product);

    product.PrecoUnitarioVenda = product.Preco;

    for (var i = 0; i < ColaboradorApi.productList.length; i++) {
      if ( ColaboradorApi.productList[i].ProdutoID === product.ProdutoID ) {
        ColaboradorApi.productList[i].QuantidadeVendida++;
        break;
      }
    }

    if ( i == ColaboradorApi.productList.length ) {

      product.QuantidadeVendida = 1;

      ColaboradorApi.productList.push( product );

    }

    $state.go('contributor.produtos-resumo');

  };

  // ColaboradorApi.getprodutos( '0523362070004' , function(r){
  //   console.log(JSON.stringify(r));
  //   $scope.products = r.Retorno;
  // });

  $scope.findFabricantes();

  $scope.barcode = function() {
    cordova.plugins.barcodeScanner
      .scan(function (result) {
        barcodedata = result.text;
         alert( JSON.stringify(barcodeData) );
        ColaboradorApi.getprodutos(barcodedata , function(r){
          $scope.products = r.Retorno;
          alert( JSON.stringify(r.Retorno) );
        });
      })
  };

  if ( ColaboradorApi.client ) {
  } else {
    // $state.go('contributor.produtos-cliente');
  }




    $scope.modelPorDescricaoCodigo = {};
    $scope.buscarPorDescricaoCodigo = function(parametroDigitado){
      return ColaboradorApi.ConsultarProdutoPorDescricaoCodigo({
        ProdutoDescricao: parametroDigitado,
        ClienteID: ColaboradorApi.client.ClienteID
      });
    };
    $scope.modelProdutoSelecionado = function(selected){
        $scope.selectProduct(selected.originalObject);
    };




}
]);

controllers.controller('contributor.ProdutosResumoCtrl', [ '$scope', '$state', 'Popup', 'deviceStorage', 'ColaboradorApi', '$ionicLoading', 'PrintService',
  function($scope, $state, Popup, deviceStorage, ColaboradorApi, $ionicLoading, PrintService) {

    $scope.date = new Date;
    $scope.model = {};

  if ( ColaboradorApi.productList && ColaboradorApi.productList.length ) {
    $scope.model.TextoObservacao = ColaboradorApi.productList[0].Observacao;
  }

  $scope.removeProduct = function($index) { //console.log($index);

    if ( ColaboradorApi.productList[$index].RegistroProdutosID )
        ColaboradorApi.excluirProduto( ColaboradorApi.productList[$index] , function(){} );
      // ColaboradorApi.productList[$index].deleted = true;
    // else
      ColaboradorApi.productList.splice( $index , 1 );

    //$scope.productList = ColaboradorApi.productList;
    // console.log(ColaboradorApi.productList.length);

    if ( ColaboradorApi.productList.length === 0 )
      $state.go('contributor.produtos-cliente');
    else
      $scope.update();

  };

  $scope.back = function() {
    $state.go('contributor.produtos-produto');
  };

  $scope.update = function() {

    $scope.productList = ColaboradorApi.productList;
    $scope.total = 0;

    $scope.erros = 0;

    for (var i = 0; i < $scope.productList.length; i++) {
      var p = $scope.productList[i];

      if ( p.deleted ) continue;

      // if ( p.QuantidadeVendida < 1 )
      // p.QuantidadeVendida = 1;
      //console.log(p);

      if ( p.PrecoUnitarioVenda === undefined || !p.QuantidadeVendida )
        $scope.erros++;

      $scope.total += p.PrecoUnitarioVenda * p.QuantidadeVendida;

    }

  };

  var onRegistrarProduto = function(results) {

    if ( !results.Successeded ) {
      $ionicLoading.hide();

      var alertPopupProdutosCadastrados = Popup.alert(results.Message);

      return;
    }

    var i;

    // marca o produto como enviado
    for (i = 0; i < ColaboradorApi.productList.length; i++) {
      if ( results.Retorno && ColaboradorApi.productList[i].ProdutoID === results.Retorno.Registro.ProdutosID && !ColaboradorApi.productList[i].Enviado ) {
        ColaboradorApi.productList[i].Enviado = true;
        break;
      } else if ( ColaboradorApi.productList[i].deleted && !ColaboradorApi.productList[i].Enviado ) {
        ColaboradorApi.productList[i].Enviado = true;
        break;
      }
    }

    //verifica se algum produto ainda não foi enviado
    for ( i = 0; i < ColaboradorApi.productList.length; i++) {
      if ( !ColaboradorApi.productList[i].Enviado ) {
        break;
      }
    }

    //caso todos tenham sido enviado
    if ( i == ColaboradorApi.productList.length ) {

      $ionicLoading.hide();

      var alertPopupProdutosCadastrados = Popup.alert('APP_NEW_PRODUCT_SUCCESS');
      alertPopupProdutosCadastrados.then(function(res){
        $state.go('contributor.agenda');

      });

    }

  };

  $scope.registrarProduto = function(impressao, printer) { //console.log($scope.productList);

    $ionicLoading.show({});

    if (impressao) {
      PrintService.print('print', printer);
    }

    for (var i = 0; i < $scope.productList.length; i++) {
      var p = $scope.productList[i];

      p.Impressao = p.JaImprimiu || impressao;
      p.Observacao = $scope.model.TextoObservacao;

      if ( p.RegistroProdutosID ) {

        p.ProdutoID = p.ProdutosID;

        // if ( !p.deleted ) {

          ColaboradorApi.editarProduto( p , onRegistrarProduto);

        // } else {

        //   ColaboradorApi.excluirProduto( p , onRegistrarProduto );

        // }

      } else {

        p.ColaboradorAuxiliarID = $scope.user.IdUsuario;
        p.ClienteID = $scope.client.ClienteID;

        ColaboradorApi.registrarProduto( p , onRegistrarProduto);

      }

    }

  };

  // console.log(JSON.stringify(ColaboradorApi.client));
  // console.log(JSON.stringify(ColaboradorApi.productList));

  if ( !ColaboradorApi.productList || !ColaboradorApi.productList.length ) {
    ColaboradorApi.client = {"ClienteID":26251,"Codigo":"26251","NomeCompleto":"eric tonussi","Celular":"12312312312","Data":null,"ItemDestaque":false,"Informacoes":null,"Colaborador":false,"Email":null,"EstaPresente":false,"$$hashKey":"object:397"};
    ColaboradorApi.productList = [{"ProdutoID":1095,"GrupoID":21,"LinhasID":10,"FiliaisID":7437,"FabricantesID":77,"Descricao":"AMOSTRA SHAMPOO 20ml","CodigoFabricante":"","Preco":8,"Comissao":0,"CodigoBarra":"2600059010951","EstoqueMinimo":0,"Ativo":true,"PrecoVenda":8,"ComissaoVenda":0,"DescontoMaximo":6.4,"SobrePrecoMaximo":-1,"PrecoUnitarioVenda":8,"QuantidadeVendida":1}];
  }
  $scope.client = ColaboradorApi.client;

  if ( ColaboradorApi.productList && ColaboradorApi.productList.length ) { //console.log(ColaboradorApi.productList);
    $scope.update();
  } else {
    $state.go('contributor.produtos-produto');
  }

  // deviceStorage.get('user')

}
]);
