var controllers = angular.module('app.controllers');

controllers.controller('contributor.RelatoriosCtrl', [ '$scope', '$rootScope', '$state', '$ionicSlideBoxDelegate', '$ionicScrollDelegate', 'deviceStorage', 'RelatorioColaboradorApi',
  function($scope, $rootScope, $state, $ionicSlideBoxDelegate, $ionicScrollDelegate, deviceStorage, RelatorioColaboradorApi){
  }
]);

controllers.controller('contributor.RelatoriosFaturamentoCtrl', [ '$scope', '$rootScope', '$state', '$ionicSlideBoxDelegate', '$ionicScrollDelegate', 'deviceStorage', 'RelatorioColaboradorApi', '$window',
  function($scope, $rootScope, $state, $ionicSlideBoxDelegate, $ionicScrollDelegate, deviceStorage, RelatorioColaboradorApi , $window ){

    $scope.de = new Date();
    $scope.de.setDate(1); //primeiro dia do mes corrente
    // $scope.de.setYear(2012); //para DEBUG

    $scope.ate = new Date();

    $scope.hideBack = true;

    // $scope.predicate = '';

    $scope.go = function(to) {

      if ( !$scope.hideBack || to > 0 ) {
        $ionicSlideBoxDelegate.slide(to);
        // $ionicSlideBoxDelegate.enableSlide(false);
        $ionicScrollDelegate.scrollTop();
        $scope.hideBack = to === 0;
      } else {
        $window.history.back();
      }
    };

    $rootScope.$watch('$ionicView.loaded', function(e) {
      $ionicSlideBoxDelegate.enableSlide(false);
    });

    var onFaturamento = function(results){
        if ( results && results.Successeded && results.Retorno.length )
          $scope.faturamento = (results.Retorno[0].TotalFaturado);
        else
         $scope.faturamento = 0;
    };

    var onTotalAtendimentos = function(results){
        if ( results && results.Successeded && results.Retorno.length )
          $scope.totalAtendimentos = (results.Retorno[0].Total);
        else
         $scope.totalAtendimentos = 0;
    };

    var onAtendimentos = function(results){
        if ( results && results.Successeded && results.Retorno.length )
          $scope.atendimentos = (results.Retorno);
        else
         $scope.atendimentos = 0;
    };

    var onTotalServicos = function(results){
        if ( results && results.Successeded && results.Retorno.length )
          $scope.servicos.total = (results.Retorno[0].TotalFaturadoServicos);
        else
         $scope.servicos.total = 0;
    };

    var onServicos = function(results){
        if ( results && results.Successeded && results.Retorno.length )
          $scope.servicos.lista = (results.Retorno);
        else
         $scope.servicos.lista = [];
    };

    var onTotalProdutos = function(results){
        if ( results && results.Successeded && results.Retorno.length )
          $scope.produtos.total = (results.Retorno[0].TotalFaturadoProdutos);
        else
         $scope.produtos.total = 0;
    };

    var onProdutos = function(results){
        if ( results && results.Successeded && results.Retorno.length )
          $scope.produtos.lista = (results.Retorno);
        else
         $scope.produtos.lista = [];
    };

    $scope.getRelatorio = function( de , ate ) {

      $scope.visible      = true;

      $scope.faturamento  = null;

      $scope.totalAtendimentos = null;
      $scope.atendimentos = null;

      $scope.servicos     = {
          total : null,
          lista : null
      };
      $scope.produtos     = {
          total : null,
          lista : null
      };

      var requestData = {
         DataInicio: de.ddmmyyyy(),
         DataFinal: ate.ddmmyyyy(),
         FiliaisID: deviceStorage.get('user').Retorno.IdFilial,
         ColaboradorID: deviceStorage.get('user').Retorno.ColaboradorID
      };

      RelatorioColaboradorApi.rankingfaturamentoporfilial(requestData, onFaturamento);
      RelatorioColaboradorApi.RankingAtendimentosPorFilial(requestData, onTotalAtendimentos);
      RelatorioColaboradorApi.RankingAtendimentosPorClientePorFilial(requestData, onAtendimentos);

      RelatorioColaboradorApi.TotalFaturamentoServicosPorFilial(requestData, onTotalServicos);
      RelatorioColaboradorApi.DetalhamentoServicosFaturados(requestData, onServicos);

      RelatorioColaboradorApi.TotalFaturamentoProdutosPorFilial(requestData, onTotalProdutos);
      RelatorioColaboradorApi.DetalhamentoProdutosFaturados(requestData, onProdutos);

    };

    // $scope.getRelatorio($scope.de,$scope.ate);
  }
]);

controllers.controller('contributor.RelatoriosDetalhadoCtrl', [ '$scope', '$rootScope', '$state', '$ionicSlideBoxDelegate', '$ionicScrollDelegate', 'deviceStorage', 'RelatorioColaboradorApi', '$window',
  function($scope, $rootScope, $state, $ionicSlideBoxDelegate, $ionicScrollDelegate, deviceStorage, RelatorioColaboradorApi , $window ){

    $scope.de = new Date();
    $scope.de.setDate(1); //primeiro dia do mes corrente
    // $scope.de.setYear(2012); //para DEBUG

    $scope.ate = new Date();

    $scope.go = function(to) {
      $window.history.back();
    };

    var onPendentes = function(results){

        if ( results && results.Successeded && results.Retorno.length ) {

          // $scope.totalPendente = 0;
          // $scope.pendentes = results.Retorno;

          var totalProduto = 0;
          var totalServico = 0;

          var ficha = angular.copy(results.Retorno[0]);
          ficha.proServ = [results.Retorno[0]];

          if ( ficha.servico ) {
            totalServico += ficha.total;
          } else {
            totalProduto += ficha.total;
          }


          // var fichas = [ficha];
          var dia = {
            data: results.Retorno[0].data,
            fichas: [ficha]
          };

          var dias = [dia];

          for (var i = 1; i < results.Retorno.length ; i++ ) {
            var _ficha = results.Retorno[i];

            if ( _ficha.servico ) {
              totalServico += _ficha.total;
            } else {
              totalProduto += _ficha.total;
            }

            if ( dia.data != _ficha.data ) {
              dia = {
                data: _ficha.data,
                fichas: []
              };
              dias.push( dia );
              ficha = {};
            }

            if ( ficha.fichaId == _ficha.fichaId ) {
              ficha.proServ.push( _ficha );
              ficha.total += _ficha.total;
            } else {
              ficha = angular.copy(_ficha);
              ficha.proServ = [_ficha];
              dia.fichas.push(ficha);
            }

            // $scope.totalPendente += (results.Retorno[i].total);

          }

          $scope.dias = dias;
          $scope.totalProduto = totalProduto;
          $scope.totalServico = totalServico;

        } else {
          $scope.dias = [];
          $scope.totalProduto = 0;
          $scope.totalServico = 0;
        }
    };


    $scope.getRelatorio = function( de , ate ) {

      $scope.visible      = true;

      $scope.dias = null;
      $scope.totalProduto = null;
      $scope.totalServico = null;

      var requestData = {
         DataInicio: de.ddmmyyyy(),
         DataFinal: ate.ddmmyyyy(),
         ColaboradorID: deviceStorage.get('user').Retorno.ColaboradorID
      };

      RelatorioColaboradorApi.ColaboradorProdutividadeDetalhada(requestData, onPendentes);

    };

    // $scope.getRelatorio($scope.de,$scope.ate);

  }
]);

controllers.controller('contributor.RelatoriosComissoesCtrl', [ '$scope', '$rootScope', '$state', '$ionicSlideBoxDelegate', '$ionicScrollDelegate', 'deviceStorage', 'RelatorioColaboradorApi', '$window',
  function($scope, $rootScope, $state, $ionicSlideBoxDelegate, $ionicScrollDelegate, deviceStorage, RelatorioColaboradorApi , $window ){

    $scope.de = new Date();
    $scope.de.setDate(1); //primeiro dia do mes corrente
    // $scope.de.setYear(2012); //para DEBUG

    $scope.ate = new Date();

    $scope.hideBack = true;

    // $scope.predicate = '';

    $scope.go = function(to) {

      if ( !$scope.hideBack || to > 0 ) {
        $ionicSlideBoxDelegate.slide( to );
        // $ionicSlideBoxDelegate.enableSlide(false);
        $ionicScrollDelegate.scrollTop();
        $scope.hideBack = to === 0;
      } else {
        $window.history.back();
      }
    };

    $rootScope.$watch('$ionicView.loaded', function(e) {
      $ionicSlideBoxDelegate.enableSlide(false);
    });

    var onFormaPagamento = function(results){

        if (results && results.Successeded) {

          $scope.MostraPendentes = results.Retorno.MostraPendentes;
          $scope.MostraPreDatados = results.Retorno.MostraPreDatados;
          $scope.PagaPreAvista = results.Retorno.PagaPreAvista;
          $scope.TipoPagamentoComissao = results.Retorno.TipoPagamentoComissao;

        }
        /*else
         $scope.servicosProdutos = 0;*/
    };

    var onPendentes = function(results){

        if (results && results.Successeded) {

          $scope.totalPendente = 0;
          $scope.pendentes = results.Retorno;

          for (var i = results.Retorno.length - 1; i >= 0; i--) {
            $scope.totalPendente += (results.Retorno[i].comissao);
          }


        } else
         $scope.totalPendente = 0;
    };

    var onLiberadosData = function(results){

      if (results && results.Successeded) {

        for (var i = $scope.liberados.length - 1; i >= 0; i--) {
          var l = $scope.liberados[i];

          if ( results.Retorno.length && l.data == ($scope.TipoPagamentoComissao=='R' ? results.Retorno[0].pagamento : results.Retorno[0].data) ) {

            l.detalhes = results.Retorno;
            break;

          }

        }
      }
    };

    var onLiberados = function(results){

        if (results && results.Successeded) {

          $scope.totalLiberado = 0;
          $scope.liberados = results.Retorno;

          for (var i = results.Retorno.length - 1; i >= 0; i--) {

            $scope.totalLiberado += (results.Retorno[i].total);

            var parametros = {
              ColaboradorID: deviceStorage.get('user').Retorno.ColaboradorID,
              Data: results.Retorno[i].data,
              DataInicio: deviceStorage.get('DiaInicioDaComissao'),
              DataFinal: deviceStorage.get('DiaFinalDaComissao')

            };
            RelatorioColaboradorApi.ColaboradorComissoesDatasDetalhes(parametros, onLiberadosData );

          }

        } else {
          $scope.totalLiberado = 0;
          $scope.liberados = [];
        }
    };

    var onPreDatado = function(results){

        if (results && results.Successeded) {

          $scope.totalPreDatado = 0;
          $scope.preDatados = results.Retorno;

          for (var i = results.Retorno.length - 1; i >= 0; i--) {
            $scope.totalPreDatado += (results.Retorno[i].comissao);
          }

        } else {
          $scope.totalPreDatado = 0;
          $scope.preDatados = [];
        }
    };

    var onRepasses = function(results){

        if (results && results.Successeded) {

          $scope.totalRepasses = 0;
          $scope.repasses = results.Retorno;

          for (var i = results.Retorno.length - 1; i >= 0; i--) {
            $scope.totalRepasses += (results.Retorno[i].valor);
          }

        } else {
          $scope.totalRepasses = 0;
          $scope.repasses = [];
        }
    };

    var onColaboradorDebitoComoCliente = function(results){ console.log(results);

        if (results && results.Successeded) {

          $scope.totalDebitoComoCliente = 0;
          $scope.DebitoComoCliente = results.Retorno;

          for (var i = results.Retorno.length - 1; i >= 0; i--) {
            $scope.totalDebitoComoCliente += (results.Retorno[i].comissao);
          }

        } else {
          $scope.totalDebitoComoCliente = 0;
          $scope.DebitoComoCliente = [];
        }

    };

    var onColaboradorOutrasReceitas = function(results){ console.log(results);

        if (results && results.Successeded) {

          $scope.totalColaboradorOutrasReceitas = 0;
          $scope.ColaboradorOutrasReceitas = results.Retorno;

          for (var i = results.Retorno.length - 1; i >= 0; i--) {
            $scope.totalColaboradorOutrasReceitas += (results.Retorno[i].comissao);
          }

        } else {
          $scope.totalColaboradorOutrasReceitas = 0;
          $scope.ColaboradorOutrasReceitas = [];
        }

    };

    var onColaboradorComissoesRD = function(results){ console.log(results);

        if (results && results.Successeded) {
          $scope.totalColaboradorComissoesRD = results.Retorno[0].valor;
        } else {
          $scope.totalColaboradorComissoesRD = 0;
        }

    };

    $scope.getRelatorio = function( de , ate ) {

      $scope.visible      = true;

      $scope.totalPendente = null;
      $scope.pendentes = null;

      $scope.totalLiberado = null;
      $scope.liberados = null;

      $scope.totalPreDatado = null;
      $scope.preDatados = null;

      $scope.totalRepasses = null;
      $scope.repasses = null;

      $scope.totalDebitoComoCliente = null;
      $scope.DebitoComoCliente = null;

      $scope.totalColaboradorOutrasReceitas = null;
      $scope.ColaboradorOutrasReceitas = null;

      $scope.totalColaboradorComissoesRD = null;

      var requestData = {
         DataInicio: de.ddmmyyyy(),
         DataFinal: ate.ddmmyyyy(),
         // FiliaisID: deviceStorage.get('user').Retorno.IdFilial,
         ColaboradorID: deviceStorage.get('user').Retorno.ColaboradorID
         // ColaboradorID: 8916,
         // DataInicio:"26/02/2015",
         // DataFinal:"07/04/2015",
      };

      deviceStorage.put("DiaInicioDaComissao", de.ddmmyyyy());
      deviceStorage.put("DiaFinalDaComissao", ate.ddmmyyyy());

      RelatorioColaboradorApi.ColaboradorComissoesPendentes(requestData, onPendentes);
      RelatorioColaboradorApi.ColaboradorComissoesDatas(requestData, onLiberados);
      RelatorioColaboradorApi.ColaboradorComissoesPreDatado(requestData, onPreDatado);
      RelatorioColaboradorApi.ColaboradorComissoesRepasses(requestData, onRepasses);
      // RelatorioColaboradorApi.ColaboradorProdutividadeDetalhada(requestData, onPendentes);

      RelatorioColaboradorApi.ColaboradorDebitoComoCliente(requestData, onColaboradorDebitoComoCliente);
      RelatorioColaboradorApi.ColaboradorOutrasReceitas(requestData, onColaboradorOutrasReceitas);
      RelatorioColaboradorApi.ColaboradorComissoesRD(requestData, onColaboradorComissoesRD);

    };

    RelatorioColaboradorApi.ColaboradorFormaPagamento({ColaboradorID: deviceStorage.get('user').Retorno.ColaboradorID}, onFormaPagamento );

    // $scope.getRelatorio($scope.de,$scope.ate);

  }
]);
