var controllers = angular.module('app.controllers');

controllers.controller('contributor.ServicosCtrl', [ '$scope', '$state', 'deviceStorage', 'ColaboradorApi', '$ionicScrollDelegate','Popup',
  function($scope, $state, deviceStorage, ColaboradorApi, $ionicScrollDelegate, Popup) {

  delete ColaboradorApi.Produtos;

  $scope.limit = 10;

  $scope.noMoreItemsAvailable = true;
  $scope.util = {};
  $scope.util.permissoes = deviceStorage.get('permissoes');

  $scope.loadMoreClients = function(){

    $scope.limit += 10;

    $scope.noMoreItemsAvailable = $scope.clients.length < $scope.limit;
    $scope.$broadcast('scroll.infiniteScrollComplete');
    $ionicScrollDelegate.resize();

  };

  var onFindClients = function(results) {

    if (!results) {
      $scope.clients = [];
      return;
    }

    $scope.limit = 10;
    $scope.clients = results.Retorno.ListaClientes;
    $scope.noMoreItemsAvailable = $scope.clients.length < $scope.limit;

    $ionicScrollDelegate.resize();
    $ionicScrollDelegate.scrollTop();

  };

  $scope.clearClients = function() {
    delete $scope.clients;
  };
    $scope.findClientsPresence = function(){
      delete $scope.clients;
      $scope.clients = null;

      requestData = {
        PalavraPesquisaCliente: '',
        EstaPresente:true,
      };
      ColaboradorApi.findClients(requestData, onFindClients);
    };

  $scope.findClients = function(clientName) { //console.log(clientName);

    delete $scope.clients;

    var requestData;

    if (
      clientName.length >= 1 && !isNaN(clientName) || clientName.length >= 3
     ) {
      $scope.clients = null;
      requestData = {
        PalavraPesquisaCliente: clientName
      };
      ColaboradorApi.findClients(requestData, onFindClients);
    }

  };

  var onConsultarListaRegistroQuimicas = function(results) {

    for (var s = 0; s < ColaboradorApi.serviceList.length; s++) {
      var service = ColaboradorApi.serviceList[s];

      for (var i = 0; i < results.Retorno.ListaRegistroQuimicas.length; i++) {
        var quimica = results.Retorno.ListaRegistroQuimicas[i];

        quimica.product = { Descricao : quimica.ProdutoNome };
        quimica.parte = quimica.Partes;

        if ( service.RegistroServicosID == quimica.RegistroServicosID ) {

          if ( quimica.Partes || quimica.ProdutoID ) {
            service.quimicas.push( quimica );
          }

          service.quimica_observacao = quimica.Observacao;

        }

      }

    }

  };

  var onConsultarlistaregistroservicos = function(results) {

    if ( results.Retorno.ListaRegistrosServicos.length ) {

      ColaboradorApi.serviceList = results.Retorno.ListaRegistrosServicos;

      for (var i = 0; i < ColaboradorApi.serviceList.length; i++) {
        var service = ColaboradorApi.serviceList[i];

        if ( service.OrcamentoPacoteServico + service.OrcamentoServico ) {
          service.SobrePrecoMaximo = service.DescontoMaximo = service.PrecoUnitarioVenda;
          service.LimiteQuantidadeOrcamento = service.QuantidadeVendida;
        }

        if ( service.ColaboradorAuxiliarNome )
          service.auxiliar = {nome:service.ColaboradorAuxiliarNome};

        service.quimicas = [];

        var requestData = {
          RegistroServicosID : service.RegistroServicosID
        };

        ColaboradorApi.ConsultarListaRegistroQuimicas( requestData , onConsultarListaRegistroQuimicas );

        //ConsultarListaRegistroQuimicas

      }

      $state.go('contributor.servicos-resumo');

    } else {
      $state.go('contributor.servicos-servico');
    }

  };

  $scope.selectClient = function(client) { //console.log(client);
    var checarSePodeSelecionarCliente = function(permissaoSomenteParaClientePresente, estaPresente){
      return ( !permissaoSomenteParaClientePresente || (estaPresente && permissaoSomenteParaClientePresente) );
    };
    if( checarSePodeSelecionarCliente ($scope.util.permissoes.PermitirLancamentosSomenteClientePresente, client.EstaPresente) ){
      ColaboradorApi.client = client;

      ColaboradorApi.serviceList = [];

      var requestData = {
        ClienteID : client.ClienteID
      };

      ColaboradorApi.consultarlistaregistroservicos( requestData , onConsultarlistaregistroservicos );
    }
    else{

      Popup.alert('Esse cliente não está presente.');
    }
  };

}
]);

controllers.controller('contributor.ServicosServicoCtrl', [ '$scope', '$state', 'deviceStorage', 'ColaboradorApi', '$ionicPopup', '$ionicLoading', 'Popup',
  function($scope, $state, deviceStorage, ColaboradorApi, $ionicPopup, $ionicLoading, Popup) {

  $scope.ColaboradorApi = ColaboradorApi;
  $scope.grupoResults = {};
  var onFindGrupos = function(results) { //console.log(results);
    $scope.grupos = results.Retorno.ListaGruposServicos;
    $scope.grupos.forEach(function (grupo) {
        $scope.findServices(grupo);
    });
  };

  $scope.findGrupos = function() {

    var requestData = {
    };

    ColaboradorApi.findGroups(requestData, onFindGrupos);

  };

  var onFindServices = function(grupoID, results) { //console.log(results);
    $scope.grupoResults[grupoID] = results.Retorno.ListaServicos;
  };

  $scope.findServices = function(grupo) {

    var requestData = {
      "GservsID": grupo.GservsID,
      DisponivelMobilidade : false
    };

    ColaboradorApi.findServices(requestData, function (results) {
        onFindServices(grupo.GservsID, results);
    });

  };

  $scope.$on('$ionicView.beforeEnter', function (event, viewData) {
    viewData.enableBack = true;
  });

  $scope.toggleList = function (closed) {
    $scope.showCancel = $scope.showCancel || closed === false;
  };

  $scope.selectService = function(service) {

    var found = false;

    for (var i = 0; i < ColaboradorApi.serviceList.length; i++) {
      var p = ColaboradorApi.serviceList[i];

      if ( p.ID == service.ID || p.ServicosID == service.ID )
        found = true;

      // $scope.total += p.PrecoUnitarioVenda * p.QuantidadeVendida;

    }

    if ( found ) {

      $ionicPopup.show({
        title: 'Serviço já foi cadastrado. Deseja cadastrar novamente?',
        template: '',
          buttons: [
            {
              text: 'Não' ,
              type: 'button-calm',
              onTap: function(e) {

              }
            },
            {
              text: 'Sim',
              type: 'button-calm',
              onTap: function(e) {
                registraService();
              }
            }
          ]
      });

    } else {
      registraService();
    }

    function registraService() {

      //Forço um .clone() para poder selecionar o mesmo serviço várias vezes
      service = {
        Descricao: service.Descricao,
        GrupoID: service.GrupoID,
        ID: service.ID,
        QuantidadeVendida: 1,
        UsaQuimica: service.UsaQuimica
      };

      //guardo o service para adicionar depois de selecionado auxiliar e quimica, quanto tiver
      ColaboradorApi.currentService = service;

      $ionicLoading.show({
        template: 'loading'
      });

      ColaboradorApi.findComiservs({
        'servicoid' :service.ID,
        'ClienteID': ColaboradorApi.client.ClienteID
      }, function(results) {

        $ionicLoading.hide();

        if ( results.Retorno.ListaComiservs.length ) {

          var Comiserv = results.Retorno.ListaComiservs[0];

          service.PrecoUnitarioVenda = Comiserv.ValorServico;
          service.DescontoMaximo = Comiserv.DescontoMaximo;
          service.SobrePrecoMaximo = Comiserv.SobrePrecoMaximo;
          service.ColaboradorAuxiliarID = Comiserv.ColaboradorAuxiliarID;
          service.LimiteQuantidadeOrcamento = Comiserv.LimiteQuantidadeOrcamento;
          service.OrcamentoPacoteServico = Comiserv.OrcamentoPacoteServico;
          service.OrcamentoServico = Comiserv.OrcamentoServico;
          // service.LimiteQuantidadeOrcamento = 5;
          // service.OrcamentoPacoteServico = 6;
          // service.OrcamentoServico = 7;

          // console.log(service,results.ListaComiservs[0].ValorServico);

          if ( Comiserv.ServicoAuxiliarID ) {
            return $state.go('contributor.servicos-auxiliar');
          } else {
          }

        }

        if ( service.UsaQuimica ) {
          $state.go('contributor.servicos-quimica');
        } else {
          ColaboradorApi.serviceList.push( service );
          $state.go('contributor.servicos-resumo');
        }

      });

      /*var confirmPopup = $ionicPopup.show({
        title: 'Deseja selecionar um Auxiliar',
        template: '',
          buttons: [
              {
                text: 'Não' ,
                type: 'button-calm',
                onTap: function(e) {
                  if ( service.UsaQuimica ) {
                $state.go('contributor.servicos-quimica');
              } else {
                ColaboradorApi.serviceList.push( service );
                $state.go('contributor.servicos-resumo');
              }
              }
              },
              {
                text: 'Sim',
                type: 'button-calm',
                onTap: function(e) {
                  $state.go('contributor.servicos-auxiliar');
              }
            }
          ]
      });*/

    }

    //ColaboradorApi.client = "DEBUG";

  };

  $scope.findGrupos();

  if ( ColaboradorApi.client ) {
  } else {
    $state.go('contributor.servicos-cliente');
  }

  $scope.modelPorDescricaoCodigo = {};
  $scope.buscarPorDescricaoCodigo = function(parametroDigitado){
    var parametros = {
      Mobilidade: null,
      ServicoAtivo: true,
      ServicoDescricao: parametroDigitado
    };
    return ColaboradorApi.ConsultarServicoPorDescricao(parametros);
  };
  $scope.modelServicoSelecionado = function(selected){
      $scope.selectService(selected.originalObject);
  };


}
]);


controllers.controller('contributor.ServicosAuxiliarCtrl', [ '$scope', '$state', '$ionicPopup', 'deviceStorage', 'ColaboradorApi', '$ionicLoading', 'Popup',
  function($scope, $state, $ionicPopup, deviceStorage, ColaboradorApi, $ionicLoading, Popup) {


  var onFindAuxiliares = function(results) { //console.log(results);
    $ionicLoading.hide();
    $scope.auxiliares = results.Retorno;
  };

  $scope.findAuxiliares = function(servico) {

    $scope.id = servico.ColaboradorAuxiliarID;

    $ionicLoading.show({template:"Carregando auxiliares"});

    var requestData = {
      // "servicoid": servico.ID,
    };

    ColaboradorApi.findAuxiliaresTodos(requestData, onFindAuxiliares);

  };

  $scope.selectAuxiliar = function(auxiliar) {
    ColaboradorApi.currentService.auxiliar = auxiliar;
    if ( ColaboradorApi.currentService.UsaQuimica ) {
      $state.go('contributor.servicos-quimica');
    } else {
      ColaboradorApi.serviceList.push( ColaboradorApi.currentService );
      $state.go('contributor.servicos-resumo');
    }
  };

  $scope.curriculo = function(prof) {
    $scope.curriculoAtual = prof;
    var myPopup = $ionicPopup.show({
      cssClass: 'curriculo',
      templateUrl: 'curriculo.html',
      scope: $scope,
      buttons: [{
        type: 'button-positive',
        text: 'OK'
      }]
    });
  };

  // ColaboradorApi.currentService = {
  //  Descricao: "Alisamento",
  //  GrupoID: null,
  //  ID: "4",
  //  UsaQuimica: false
  // };

  if ( ColaboradorApi.currentService ) {
    $scope.findAuxiliares(ColaboradorApi.currentService);
  } else {
    $state.go('contributor.servicos-servico');
  }

}
]);

controllers.controller('contributor.ServicosQuimicaCtrl', [ '$scope', '$state', 'deviceStorage', 'ColaboradorApi', '$ionicModal',
  function($scope, $state, deviceStorage, ColaboradorApi, $ionicModal) {

  $scope.buscarPorDescricaoCodigo = function(parametroDigitado){
    return ColaboradorApi.ConsultarProdutoPorDescricaoCodigo({ProdutoDescricao: parametroDigitado});
  };
  $scope.modelProdutoSelecionado = function (selected) {
    if (!selected) return;

    // $scope.quimica.product = selected.originalObject;

    // $scope.quimicas.push({
    //   product: selected.originalObject,
    //   parte: 1
    // });
    // $scope.modal.hide();
    // $scope.$broadcast('angucomplete-alt:clearInput');
  };

  $scope.servicoAtual = ColaboradorApi.currentService;
  var onFindFabricantes = function(results) {console.log(results);
    $scope.fabricantes = results.Retorno;
  };

  $scope.findFabricantes = function() {
    var requestData = {
    };

    ColaboradorApi.findFabricantes(requestData, onFindFabricantes);
  };

  $scope.selectFabricante = function(fabricante) {
    $scope.findLinhas(fabricante);
  };

  var onFindLinhas = function(results) {console.log(results);
    $scope.linhas = results.Retorno;
  };

  $scope.findLinhas = function(fabricante) {
    var requestData = {
          FabricanteID: fabricante.FabricanteID
    };

    ColaboradorApi.findLinhas(requestData, onFindLinhas);
  };

  $scope.selectLinha = function(fabricante, linha) { //console.log(product);
    $scope.findProducts(fabricante, linha);
  };

  var onFindProducts = function(results) {
    $scope.products = results.Retorno.ListaProdutos;
  };

  $scope.findProducts = function(fabricante, linha) {
    var requestData = {
      FabricanteID: fabricante.FabricanteID,
      LinhaID: linha.LinhaID
    };

    ColaboradorApi.findProducts(requestData, onFindProducts);
  };

  $scope.findFabricantes();

  $ionicModal.fromTemplateUrl('templates/contributor/servicos/quimica-modal.html', {
    scope: $scope,
    animation: 'slide-in-up'
  }).then(function(modal) {
    $scope.modal = modal;
    // modal.show();
  });

  $scope.quimica = {};
  $scope.quimicas = [];
  $scope.quimica_observacao = "";

  $scope.addQuimica = function() {

    if ($scope.quimica.modelProdutoSelecionado) {
      $scope.quimica.product = $scope.quimica.modelProdutoSelecionado.originalObject;
      $scope.$broadcast('angucomplete-alt:clearInput');
    }

    $scope.quimicas.push($scope.quimica);
    $scope.quimica = {};

  };

  $scope.removeQuimica = function($index) { //console.log($index);

    $scope.quimicas.splice( $index , 1 );

  };

  $scope.registrarQuimica = function() { console.log($scope);

    ColaboradorApi.currentService.quimicas = $scope.quimicas;
    ColaboradorApi.currentService.quimica_observacao = $scope.quimica_observacao;
    ColaboradorApi.serviceList.push( ColaboradorApi.currentService );

    $scope.quimicas = [];

    $state.go('contributor.servicos-resumo');

  };

  /*DEBUG
  ColaboradorApi.currentService = {"Descricao":"ALONGAMENTO","GrupoID":"1","ID":"1","QuantidadeVendida":1,"UsaQuimica":true};
  /**/

  if ( ColaboradorApi.currentService ) {
    // $scope.findQuimicas( ColaboradorApi.currentService );
  } else {
    $state.go('contributor.servicos-servico');
  }

}
]);

controllers.controller('contributor.ServicosResumoCtrl', [ '$scope', '$state', '$ionicPopup', 'deviceStorage', 'ColaboradorApi', '$ionicLoading','$ionicModal', 'Popup', 'PreviaGastosApi', 'PrintService',
  function($scope, $state, $ionicPopup, deviceStorage, ColaboradorApi , $ionicLoading, $ionicModal, Popup, PreviaGastosApi, PrintService) {

  // var onRemoveQuimica = function( results ) {
  // }

  $scope.removeService = function($index) { //console.log($index);

    var service = ColaboradorApi.serviceList[$index];

    if ( service.RegistroServicosID ) {

      var confirmPopup = $ionicPopup.confirm({
        title: 'Remover Serviço',
        template: 'Tem certeza que deseja excluir e serviço seleconado?'
      });

      confirmPopup.then(function (res) {
        if (res) {
          ColaboradorApi.excluirServico( service , function () {} );
          ColaboradorApi.serviceList.splice( $index , 1 );
          $scope.update();

          if ( $scope.Produtos ) {
            for (var i = 0; i < $scope.Produtos.length; i++) {
              if ( $scope.Produtos[i].serviceId === service.ID ) {
                $scope.Produtos[i].checked = false;
              }
              // $scope.Produtos[i].checked = $scope.Produtos[i].serviceId === $scope.currentService.ID;
              // $scope.Produtos[i].disabled = $scope.Produtos[i].serviceId && ;
            }
          }

          if ( ColaboradorApi.serviceList.length === 0 )
            $state.go('contributor.servicos-cliente');
          else
            $scope.update();

        } else {
          // console.log('You are not sure');
        }
      });

      // for (var q = 0; q < service.quimicas.length; q++) {
      //   var quimica = service.quimicas[q];

      //   requestData = {
      //     RegistroQuimicasID : quimica.RegistroQuimicasID
      //   };

      //   ColaboradorApi.ExcluirQuimica(requestData, onRemoveQuimica );

      // }

      // ColaboradorApi.excluirServico( service , function(){} );

    } else {
      ColaboradorApi.serviceList.splice( $index , 1 );

      if ( $scope.Produtos ) {
        for (var i = 0; i < $scope.Produtos.length; i++) {
          if ( $scope.Produtos[i].serviceId === service.ID ) {
            $scope.Produtos[i].checked = false;
            delete $scope.Produtos[i].serviceId;
          }
          // $scope.Produtos[i].checked = $scope.Produtos[i].serviceId === $scope.currentService.ID;
          // $scope.Produtos[i].disabled = $scope.Produtos[i].serviceId && ;
        }
      }
    }

    if ( ColaboradorApi.serviceList.length === 0 )
      $state.go('contributor.servicos-cliente');
    else
      $scope.update();

  };

  $scope.back = function() {
    $state.go('contributor.servicos-servico');
  };

  $scope.update = function() {

    $scope.serviceList = ColaboradorApi.serviceList;
    $scope.total = 0;
    $scope.descontos = 0;

    $scope.erros = 0;

    for (var i = 0; i < $scope.serviceList.length; i++) {
      var p = $scope.serviceList[i];

      if(typeof $scope.model === 'undefined') $scope.model = {};

      $scope.model.TextoObservacao = p.TextoObservacao;

      if ( ( p.PrecoUnitarioVenda === undefined ) || !p.QuantidadeVendida ) {
        $scope.erros++;
      }

      $scope.total += p.PrecoUnitarioVenda * p.QuantidadeVendida;// - (p.descontoProdutos || 0);
      $scope.descontos += p.descontoProdutos || 0;

    }

  };

  var onRegistrarQuimica = function() {

  };

  var onRegistrarServico = function(results) {
    // console.log( results );

    if ( !results.Successeded ) {
      $ionicLoading.hide();

      var alertPopupProdutosCadastrados = Popup.alert(results.Message);

      return;
    }

    // marca o servico como enviado
    for (var i = 0; i < ColaboradorApi.serviceList.length; i++) {
      var service = ColaboradorApi.serviceList[i];

      if ( !service.ServicosID && service.ID )
        service.ServicosID = service.ID;

      if ( results.Retorno && !service.Enviado && service.ServicosID == results.Retorno.Registro.ServicosID ) {
        service.Enviado = true;

        //Serviço editado
        if ( service.RegistroServicosID ) {

        }
        //Novo serviço
        else {

          //Cadastro as quimicas do serviço
          if ( service.UsaQuimica ) {

            var requestData;

            //Não selecionou quimica, mas escreveu observaçao
            if ( service.quimicas.length === 0 && service.quimica_observacao ) {

              requestData = {
                RegistroServicosID : results.Retorno.Registro.RegistroServicosID,
                ProdutoID :  null,
                Partes : "",
                Observacao : service.quimica_observacao

              };

              ColaboradorApi.registrarQuimica(requestData, onRegistrarQuimica );

            }

            for (var q = 0; q < service.quimicas.length; q++) {
              var quimica = service.quimicas[q];

              requestData = {
                RegistroServicosID : results.Retorno.Registro.RegistroServicosID,
                ProdutoID : quimica.product && quimica.product.ProdutoID || null,
                Partes : quimica.parte,
                Observacao : service.quimica_observacao

              };

              ColaboradorApi.registrarQuimica(requestData, onRegistrarQuimica );

            }

          }

        }

        break;

      }
    }

    //verifica se algum servico ainda não foi enviado
    for ( i = 0; i < ColaboradorApi.serviceList.length; i++) {
      if ( !ColaboradorApi.serviceList[i].Enviado ) {
        break;
      }
    }

    //caso todos tenham sido enviado
    if ( i == ColaboradorApi.serviceList.length ) {

      $ionicLoading.hide();

      var alertPopupServicosCadastrados = Popup.alert('APP_NEW_SERVICE_SUCCESS');
      alertPopupServicosCadastrados.then(function(res){
        $state.go('contributor.agenda');
      });
    }

  };

  $scope.registrarServico = function(impressao, printer) {

    $ionicLoading.show({});

    if (impressao) {
      PrintService.print('print', printer);
    }

    for (var i = 0; i < $scope.serviceList.length; i++) {
      var p = angular.copy($scope.serviceList[i]);
      p.TextoObservacao = $scope.model.TextoObservacao;
      p.Impressao = p.Impressao = p.JaImprimiu || impressao;

      if ( p.descontoProdutos ) {
        p.PrecoUnitarioVenda -= p.descontoProdutos / p.QuantidadeVendida;
      }

      if ( p.RegistroServicosID ) {

        // p.RegistroProdutosID = p.RegistroProdutosId;
        // p.ProdutoID = p.ProdutosID;

        ColaboradorApi.editarServico( p , onRegistrarServico);

      } else {

        p.ServicoID = p.ID;
        p.ColaboradorAuxiliarID = p.auxiliar ? p.auxiliar.id : null;
        p.ClienteID = $scope.client.ClienteID;

        ColaboradorApi.registrarServico( p , onRegistrarServico);

      }

      /*var requestData = {
        ServicoID : p.ID,
        QuantidadeVendida : p.QuantidadeVendida,
        PrecoUnitarioVenda : p.PrecoUnitarioVenda,
        ColaboradorAuxiliarID : p.auxiliar ? p.auxiliar.id : null,
        ClienteID : $scope.client.ClienteID

      };

      // console.log(requestData);

      ColaboradorApi.registrarServico(requestData, onRegistrarServico);*/

    }

  };

  /*DEBUG
  if ( !ColaboradorApi.client ) {
    ColaboradorApi.client = {"ClienteID":25577,"Codigo":"25577","NomeCompleto":"teste","Celular":"33999999999","Data":null,"ItemDestaque":false,"Informacoes":null,"Colaborador":false,"Email":null,"EstaPresente":false,"$$hashKey":"object:36"};
    ColaboradorApi.serviceList = [{"Descricao":"Barbeiro","GrupoID":"19","ID":"273","QuantidadeVendida":2,"UsaQuimica":false,"PrecoUnitarioVenda":30,"DescontoMaximo":-1,"SobrePrecoMaximo":-1,"ColaboradorAuxiliarID":null,"LimiteQuantidadeOrcamento":0,"OrcamentoPacoteServico":0,"OrcamentoServico":0},{"Descricao":"Alongamento","GrupoID":"7","ID":"282","QuantidadeVendida":1,"UsaQuimica":false,"PrecoUnitarioVenda":50,"DescontoMaximo":-1,"SobrePrecoMaximo":-1,"ColaboradorAuxiliarID":null,"LimiteQuantidadeOrcamento":0,"OrcamentoPacoteServico":0,"OrcamentoServico":0,"auxiliar":{"profissao":null,"foto":"http:////onemidias.azurewebsites.net////Colaboradores/empresa1044/db6e93f1-158e-414b-8470-1e5b8b71afc7download.jpg","servicoid":null,"nome":"Ana Letícia Camargos Viana Lara","id":25756,"curriculo":null}}];
  }
  /**/

  $scope.client = ColaboradorApi.client;

  // console.log(JSON.stringify($scope.client));
  // console.log(JSON.stringify(ColaboradorApi.serviceList));

  $scope.update();

  if ( ColaboradorApi.serviceList && ColaboradorApi.serviceList.length ) { //console.log(ColaboradorApi.serviceList);
  } else {
    $state.go('contributor.servicos-servico');
  }

  // deviceStorage.get('user')

  $ionicModal.fromTemplateUrl('templates/contributor/servicos/_historicoCliente.html', {
    scope: $scope,
    animation: 'slide-in-up'
  }).then(function(modal) {
    $scope.modalHistorico = modal;
  });

  var processarHistorico = function (result) {
    var data = result.data;
    
    if (data.Successeded === true) {
      $scope.clienteHistorico.nome = data.Retorno.Nome;
      $scope.clienteHistorico.cpf = data.Retorno.Cpf;
      $scope.clienteHistorico.codigo = data.Retorno.Codigo;
      $scope.clienteHistorico.Fichas = data.Retorno.ListaHistoricoFichaAnotacoesAtendimento;

      //ListaHistoricoFichaAnotacoesAtendimento
    }
  };

  ColaboradorApi.ConsultarHistoricoFichaAnotacoesDoCliente($scope.client.ClienteID).then(processarHistorico);
  if(typeof $scope.model === 'undefined') $scope.model = {};
  $scope.clienteHistorico = {};
  $scope.clienteHistorico.Fichas = [];
  $scope.clienteHistorico.abrirHistorico = function(){
    $scope.modalHistorico.show();

  };

  $scope.clienteHistorico.fecharHistorico = function(){
    $scope.modalHistorico.hide();

  };

  if ( !ColaboradorApi.Produtos || ColaboradorApi.ProdutosId !== $scope.client.ClienteID ) {
    ColaboradorApi.ProdutosId = $scope.client.ClienteID;
    var requestData = {
      ClienteId : $scope.client.ClienteID
    };
    PreviaGastosApi.previaGastos(requestData, function (results) {
      $scope.Produtos = ColaboradorApi.Produtos = results.Produtos;
    });
  } else {
    $scope.Produtos = ColaboradorApi.Produtos;
  }

  $ionicModal.fromTemplateUrl('templates/contributor/servicos/_gasto-produtos.html', {
      scope: $scope,
      animation: 'slide-in-up'
    }).then(function(modal) {
      $scope.modalGastoProdutos = modal;
    });
  // $scope.modalGastoProdutos.hide();

  $scope.gastoProdutos = function (service) {
    $scope.currentService = service;
    if ( !$scope.currentService.ID && $scope.currentService.ClientesID ) {
      $scope.currentService.ID = $scope.currentService.ClientesID;
    }
    // debugger;
    for (var i = 0; i < $scope.Produtos.length; i++) {
      $scope.Produtos[i].checked = $scope.Produtos[i].serviceId === $scope.currentService.ID;
      $scope.Produtos[i].disabled = $scope.Produtos[i].serviceId && $scope.Produtos[i].serviceId !== $scope.currentService.ID;
    }
    $scope.updadeDescontoProdutos();
    $scope.modalGastoProdutos.show();
  };

  $scope.updadeDescontoProdutos = function () {
    var descontoProdutos = 0;
    for (var i = 0; i < $scope.Produtos.length; i++) {
      if ($scope.Produtos[i].checked) {
        descontoProdutos += $scope.Produtos[i].PrecoTotal;
      }
    }
    $scope.currentService.descontoProdutosTemp = descontoProdutos;
  };

  $scope.saveDescontoProdutos = function () {
    $scope.updadeDescontoProdutos();
    $scope.currentService.descontoProdutos = $scope.currentService.descontoProdutosTemp;

    // $scope.currentService.produtos = [];
    for (var i = 0; i < $scope.Produtos.length; i++) {
      if ($scope.Produtos[i].checked) {
        // $scope.currentService.produtos[$scope.Produtos[i]]
        $scope.Produtos[i].serviceId = $scope.currentService.ID;
      } else if (!$scope.Produtos[i].disabled) {
        delete $scope.Produtos[i].serviceId;
      }
    }

    $scope.modalGastoProdutos.hide()
      .then(function () {
        delete $scope.currentService.descontoProdutosTemp;
      })
    $scope.update();
  };

}
]);
