var controllers = angular.module('app.controllers');

controllers.controller('ConvidarCtrl', [ '$scope', '$rootScope' , '$stateParams' , '$state', 'deviceStorage', 'AuthApi', 'Popup', 'SaloesApi', '$ionicLoading',
  function($scope, $rootScope , $stateParams , $state, deviceStorage , AuthApi , Popup , SaloesApi , $ionicLoading ) {

    $scope.salao = SaloesApi.markersCache[$stateParams.empresasID];
    if ( $scope.salao ) {
      deviceStorage.put('markerCache',$scope.salao);
    } else {
      $scope.salao = deviceStorage.get('markerCache');
    }

    $scope.salao.servicos = [
      { titulo: 'Escova', descricao: 'Corte masculino, Corte fêminino, escova, etc..'},
      { titulo: 'Unha - pé e mão', descricao: ''},
      { titulo: 'Corte', descricao: ''},
      { titulo: 'Depilação / Estética', descricao: ''},
      { titulo: 'Mechas', descricao: ''},
      // { titulo: 'Estética', descricao: ''},
      { titulo: 'Outros', descricao: ''},
    ];

    var requestData = {
      // UsuarioId : $rootScope.UsuarioId,
      EmpresaId : $stateParams.empresasID,
      // NomeEmpresa: empresa.name,
      // Endereco: empresa.vicinity,
      // Longitude: location.F,
      // Latitude: location.A
    };


    AuthApi.statusempresanaocliente(requestData, function(r) {

      if ( !r.Convite ) {
        Popup.alert('Lorem ipsum In quis ea anim tempor aute.');
        $state.go('mapa');
      }

      $scope.hasEmail = r.Email;

      var msg;

      if ( !r.Email ) {
        msg = 'Este salão ainda não faz parte da rede One. Informe-nos o e-mail dele e receba <strong>' + parseInt(r.PontosEmail).toLocaleString() + ' pontos</strong> assim que você receber a confirmação dele. <br>Se essa empresa aderir ao ONE, após a sua indicação, você receberá um bônus extra de <strong>' + r.PontosAdesao + ' pontos.</strong><br>Estes pontos, furamente, serão convertidos em prêmios.';
      } else {
        msg = 'Este salão ainda não faz parte da rede One. Ganhe <strong>' + parseInt(r.PontosAgendamento).toLocaleString() + ' pontos</strong> assim que você receber a confirmação dele.<br>Estes pontos, furamente, serão convertidos em prêmios.';
      }

      /*$ionicPopup.alert({
        cssClass: 'convide',
        title: 'Ganhe prêmios!',
        template: msg,
    });*/

    });

    $scope.sendMensagem = function() {

      var empresa = $scope.salao;
      var location = empresa.geometry.location;

      var servicos = [];
      for (var i = 0; i < empresa.servicos.length; i++) {
        var s = empresa.servicos[i];
        if ( s.checked ) {
          servicos.push(s.titulo);
        }
      }

      if ( empresa.outros ) {
        servicos.push( empresa.outros );
      }

      //return alert(servicos.join(', '));

      var requestData = {
        UsuarioId : $rootScope.UsuarioId,
        EmpresaId : $stateParams.empresasID,
        Mensagem : servicos.join(', '),
        NomeEmpresa: empresa.name,
        Email: empresa.email,
        Endereco: empresa.vicinity,
        Longitude: location.lng(),
        Latitude: location.lat()
      };

      $ionicLoading.show();
      AuthApi.convidarsalao(requestData, function(r) {

        $ionicLoading.hide();

        Popup.alert(r.Message).then(function(res) {
          $state.go('mapa');
        });

      });

    };
    $scope.any = function() {
      for (var i = 0; i < $scope.salao.servicos.length; i++) {
        var s = $scope.salao.servicos[i];
        if ( s.checked ) return true;
      }
        return false;
    };

}]);
