var controllers = angular.module('app.controllers');

controllers.controller('manager.ColaboradoresCtrl', [ '$scope', '$state', 'deviceStorage',
  function($scope, $state, deviceStorage) {

  }
]);

controllers.controller('manager.colaboradores.FaturamentoCtrl', [ '$scope', '$state', 'deviceStorage', 'manager.ColaboradoresApi', '$ionicScrollDelegate',
  function($scope, $state, deviceStorage, ColaboradoresApi , $ionicScrollDelegate ) {

    $scope.colors = [
      "#115fa6",
      "#30ae0a",
      "#ff8809",
      "#ffd13e",
      '#800000',
      '#F25454',
      '#4D4D4D',
      '#5DA5DA',
      '#F17CB0',
      '#60BD68',
      '#005',
    ];

    $scope.de = new Date();
    $scope.de.setDate(1); //primeiro dia do mes corrente
    // $scope.de.setYear(2013); //DEBUG
    $scope.ate = new Date();

    $scope.loading = false;

    $scope.config = {
      labels: false,
      title: false,
      legend: {
        display: false,
        position: 'left'

      },
      innerRadius: 0,
      colors: $scope.colors
    };

    var onProdutos = function(results) {

      $scope.loading = false;

      var data = [];
      var total = 0;

      $scope.data = {
        data: data
      };

      if ( results && results.Retorno.length ) {

        var length = Math.min( results.Retorno.length , 10 );

        for (var i = 0; i < length; i++) {
          var produto = results.Retorno[i];

          data.push({
            x: produto.NomeCompleto,
            y: [produto.TotalFaturado]
          });

          total += produto.TotalFaturado;

        }

        if ( results.Retorno.length > 10 ) {

          var outros = 0;

          for (; i < results.Retorno.length; i++) {
            outros += results.Retorno[i].TotalFaturado;
          }

          total += outros;

          data.push({
            x: "APP_REPORTS_OTHERS",
            y: [outros]
          });

        }

        $scope.total = total;

        // $location.hash("chart");
        // $ionicScrollDelegate.anchorScroll(true);
        $ionicScrollDelegate.scrollTo(0, 185, true);

      }

    };

    $scope.getTopProdutos = function(DataInicio,DataFinal) {

      $scope.reset();
      $scope.loading = true;

      var requestData = {
         DataInicio: DataInicio.ddmmyyyy(),
         DataFinal: DataFinal.ddmmyyyy()
      };

      ColaboradoresApi.getRankingfaturamento(requestData, onProdutos);

    };

    $scope.reset = function(argument) {
      $scope.data = null;
      $scope.total = null;
    };

    // $scope.getTopProdutos( $scope.de , $scope.ate );

  }
]);

controllers.controller('manager.colaboradores.LucratividadeCtrl', [ '$scope', '$state', 'deviceStorage', 'manager.ColaboradoresApi', '$ionicScrollDelegate',
  function($scope, $state, deviceStorage, ColaboradoresApi , $ionicScrollDelegate ) {

    $scope.colors = [
      "#115fa6",
      "#30ae0a",
      "#ff8809",
      "#ffd13e",
      '#800000',
      '#F25454',
      '#4D4D4D',
      '#5DA5DA',
      '#F17CB0',
      '#60BD68',
      '#005',
    ];

    $scope.de = new Date();
    $scope.de.setDate(1); //primeiro dia do mes corrente
    // $scope.de.setYear(2013); //DEBUG
    $scope.ate = new Date();

    $scope.loading = false;

    $scope.config = {
      labels: false,
      title: false,
      legend: {
        display: false,
        position: 'left'

      },
      innerRadius: 0,
      colors: $scope.colors
    };

    var onProdutos = function(results) {

      $scope.loading = false;

      var data = [];
      var total = 0;

      $scope.data = {
        data: data
      };

      if ( results && results.Retorno.length ) {

        var length = Math.min( results.Retorno.length , 10 );

        for (var i = 0; i < length; i++) {
          var produto = results.Retorno[i];

          data.push({
            x: produto.NomeCompleto,
            y: [produto.Lucratividade]
          });

          total += produto.Lucratividade;

        }

        if ( results.Retorno.length > 10 ) {

          var outros = 0;

          for (; i < results.Retorno.length; i++) {
            outros += results.Retorno[i].Lucratividade;
          }

          total += outros;

          data.push({
            x: "APP_REPORTS_OTHERS",
            y: [outros]
          });

        }

        $scope.data = {
          data: data
        };

        $scope.total = total;

        // $location.hash("chart");
        // $ionicScrollDelegate.anchorScroll(true);
        $ionicScrollDelegate.scrollTo(0, 185, true);

      }

    };

    $scope.getTopProdutos = function(DataInicio,DataFinal) {

      $scope.reset();
      $scope.loading = true;

      var requestData = {
         DataInicio: DataInicio.ddmmyyyy(),
         DataFinal: DataFinal.ddmmyyyy()
      };

      ColaboradoresApi.getRankinglucratividade(requestData, onProdutos);

    };

    $scope.reset = function(argument) {
      $scope.data = null;
      $scope.total = null;
    };

    // $scope.getTopProdutos( $scope.de , $scope.ate );

  }
]);

controllers.controller('manager.colaboradores.LucratividadeGeralCtrl', [ '$scope', '$state', 'deviceStorage', 'manager.ColaboradoresApi', '$ionicScrollDelegate',
  function($scope, $state, deviceStorage, ColaboradoresApi, $ionicScrollDelegate) {

    $scope.visible = false;
    $scope.de = new Date();
    $scope.de.setDate(1); //primeiro dia do mes corrente
    // $scope.de.setYear(2013); //DEBUG
    $scope.ate = new Date();

    var onProfissionais = function(results) {

      $scope.loading = false;

      $scope.lucratividade = [];

      if ( results && results.Retorno.length ) {
        $scope.visible = true;
        $scope.lucratividade = results.Retorno;
      }

    };

    $scope.getProfissionais = function(DataInicio,DataFinal) {

      $scope.visible = false;
      $scope.loading = true;
      $scope.lucratividade = null;

      var requestData = {
         DataInicio: DataInicio.ddmmyyyy(),
         DataFinal: DataFinal.ddmmyyyy()
      };

      ColaboradoresApi.getLucratividadeProfissionais(requestData, onProfissionais);

    };

    $scope.reset = function(argument) {
      $scope.lucratividade = null;
    };

    // $scope.getProfissionais( $scope.de , $scope.ate );

  }
]);
