angular.module('app.controllers')
  .controller('manager.PesquisaSatisfacaoCtrl', function ($scope, ManagerApi, $ionicLoading) {
    $ionicLoading.show();

    ManagerApi
      .getMediasAvaliacoes()
      .then(function (result) {
        $ionicLoading.hide();
        $scope.colaboradores = result.Retorno;
      });

    $scope.sortBy = function (propertyName) {
      $scope.reverse = ($scope.propertyName === propertyName) ? !$scope.reverse : false;
      $scope.propertyName = propertyName;
    };

    $scope.sortBy('Campo');

  });

angular.module('app.statesProvider')
  .config(function ($stateProvider, $urlRouterProvider) {
    $stateProvider
      .state('manager.pesquisa-satisfacao', {
        url: '/pesquisa-satisfacao',
        views: {
          'menuContent': {
            template: require('./template.html'),
            controller: 'manager.PesquisaSatisfacaoCtrl'
          }
        },
        cache: true
      })
      .state('manager.pesquisa-satisfacao-colaborador', {
        url: '/pesquisa-satisfacao-colaborador/:ProfissionalId/:Campo',
        views: {
          'menuContent': {
            template: require('../../contributor/pesquisa-satisfacao/template.html'),
            // template: 'sdfsdf',
            controller: 'contributor.PesquisaSatisfacaoCtrl'
          }
        },
        cache: true
      })
});
