var controllers = angular.module('app.controllers');

controllers.controller('manager.ProdutosCtrl', [ '$scope', '$state', 'deviceStorage', 'manager.ReceitasApi', '$ionicScrollDelegate',
  function($scope, $state, deviceStorage, ReceitasApi , $ionicScrollDelegate ) {

    $scope.colors = [
      "#115fa6",
      "#30ae0a",
      "#ff8809",
      "#ffd13e",
      '#800000',
      '#F25454',
      '#4D4D4D',
      '#5DA5DA',
      '#F17CB0',
      '#60BD68',
      '#005',
    ];

    $scope.de = new Date();
    $scope.de.setDate(1); //primeiro dia do mes corrente
    // $scope.de.setYear(2013); //DEBUG
    $scope.ate = new Date();

    $scope.loading = false;

    $scope.config = {
      labels: false,
      title: false,
      legend: {
        display: false,
        position: 'left'

      },
      innerRadius: 0,
      colors: $scope.colors
    };

  var onProdutos = function(results) { //return;

      $scope.loading = false;

      var data = [];
      var total = 0;

      $scope.data = {
        data: data
      };

      if ( results && results.Retorno.length ) {

        var length = Math.min( results.Retorno.length , 10 );

        for (var i = 0; i < length; i++) {
        var produto = results.Retorno[i];

          data.push({
          x: produto.Descricao,
          y: [produto.RankingProdutos]
          });

        total += produto.RankingProdutos;

        }

        if ( results.Retorno.length > 10 ) {

          var outros = 0;

          for (; i < results.Retorno.length; i++) {
            outros += results.Retorno[i].RankingProdutos;
          }

          total += outros;

          data.push({
            x: "APP_REPORTS_OTHERS",
            y: [outros]
          });

        }

        $scope.total = total;

        // $location.hash("chart");
        // $ionicScrollDelegate.anchorScroll(true);
        $ionicScrollDelegate.scrollTo(0, 185, true);
        // console.log(document.querySelector('#chart').offsetTop );

      }

    };

    $scope.getTopProdutos = function(DataInicio,DataFinal) {

      $scope.reset();
      $scope.loading = true;

      var requestData = {
         DataInicio: DataInicio.ddmmyyyy(),
         DataFinal: DataFinal.ddmmyyyy()
      };

      ReceitasApi.getTopprodutos(requestData, onProdutos);

    };

    $scope.reset = function(argument) {
      $scope.data = null;
      $scope.total = null;
    };

    // $scope.getTopProdutos( $scope.de , $scope.ate );

  }
]);
