var controllers = angular.module('app.controllers');

controllers.controller('manager.ReceitasCtrl', [ '$scope', '$state', 'deviceStorage',
  function($scope, $state, deviceStorage) {

  }
]);

controllers.controller('manager.receitas.ApuradasCtrl', [ '$scope', '$state', 'deviceStorage', 'manager.ReceitasApi',
  function($scope, $state, deviceStorage, ReceitasApi) {

    $scope.user = deviceStorage.get('user').Retorno;

    // $scope.servicosProdutos = null;
    // $scope.servicos = null;
    // $scope.produtos = null;
    // $scope.atendimentos = null;
    // $scope.ticketMedio = null;

    $scope.de = new Date();
    $scope.de.setDate(1); //primeiro dia do mes corrente
    $scope.ate = new Date();

    // var onServicosProdutos = function(results){
    //     if (results.Successeded) {
    //       $scope.servicosProdutos = (results.Retorno[0].TotalFaturado);
    //       if ( $scope.atendimentos )
    //         $scope.ticketMedio = $scope.servicosProdutos / $scope.atendimentos;
    //     }
    //     else
    //       $scope.servicosProdutos = 0;

    // };

    var onServicos = function(results){
        if (results && results.Successeded)
          $scope.servicos = (results.Retorno[0].TotalServicos);
        else
          $scope.servicos = 0;
    };

    var onProdutos = function(results){
        if (results && results.Successeded)
          $scope.produtos = (results.Retorno[0].TotalProdutos);
        else
          $scope.produtos = 0;
    };

    var onAtendimentos = function(results){
        if (results && results.Successeded) {
          $scope.atendimentos = (results.Retorno[0].TotalAtendimentos);
          if ( $scope.servicosProdutos )
            $scope.ticketMedio = $scope.servicosProdutos / $scope.atendimentos;
        }
        else
          $scope.atendimentos = 0;
    };

    $scope.getReceitas = function(DataInicio,DataFinal) {

      $scope.reset();

      var requestData = {
         DataInicio: DataInicio.ddmmyyyy(),
         DataFinal: DataFinal.ddmmyyyy()
      };

      // ReceitasApi.getTotalReceitaServicosProdutosPorFilial(requestData, onServicosProdutos);
      ReceitasApi.getTotalReceitaProdutosPorFilial(requestData, onProdutos);
      ReceitasApi.getTotalReceitaServicosPorFilial(requestData, onServicos);
      ReceitasApi.getTotalAtendimentosPorFilial(requestData, onAtendimentos);

      $scope.visible = true;

    };

    $scope.reset = function() {

      $scope.visible = false;

      $scope.servicosProdutos = null;
      $scope.servicos = null;
      $scope.produtos = null;
      $scope.atendimentos = null;
      $scope.ticketMedio = null;

    };

    // $scope.getReceitas( $scope.de , $scope.ate );

  }
]);

controllers.controller('manager.receitas.ClientesCtrl', [ '$scope', '$state', 'deviceStorage', 'manager.ReceitasApi',
  function($scope, $state, deviceStorage, ReceitasApi) {

    var de = new Date();
    de.setDate(1); //primeiro dia do mes corrente
    var ate = new Date();

    $scope.data = {
      de : de,
      ate: ate
    };

    $scope.reset = function() {
      delete $scope.produtos;
      delete $scope.servicos;
      delete $scope.servicosProdutos;
    };

    $scope.reset();

    var onTopclientesprodutos = function(results){
      $scope.produtos = results ? (results.Retorno) : [];
    };

    var onTopclientesservicos = function(results){
      $scope.servicos = results ? (results.Retorno) : [];
    };

    var onTopClientesServicosProdutos = function(results){
      $scope.servicosProdutos = results ? (results.Retorno) : [];
    };

    function getReceitas(tipo, callback) {

      var requestData = {
        DataInicio: $scope.data.de.ddmmyyyy(),
        DataFinal: $scope.data.ate.ddmmyyyy()
      };

      ReceitasApi.getTopclientes(tipo, requestData, callback);

    }

    $scope.getProdutos = function(check) {
      if ( !check || !$scope.produtos ) {
        $scope.produtos = null;
        getReceitas( "topclientesprodutos" , onTopclientesprodutos );
      }
    };

    $scope.getServicos = function(check) {
      if ( !check || !$scope.servicos ) {
        $scope.servicos = null;
        getReceitas( "topclientesservicos" , onTopclientesservicos );
      }
    };

    $scope.getServicosProdutos = function(check) {
      if ( !check || !$scope.servicosProdutos ) {
        $scope.servicosProdutos = null;
        getReceitas( "TopClientesServicosProdutos" , onTopClientesServicosProdutos );
      }
    };

    // $scope.getProdutos();
    // $scope.getServicos();

  }
]);

controllers.controller('manager.receitas.EstimadasCtrl', [ '$scope', '$state', 'deviceStorage', 'manager.ReceitasApi',
  function($scope, $state, deviceStorage, ReceitasApi) {

    $scope.data = {
      de : new Date(),
      ate: new Date()
    };

    $scope.data.de.setDate(1); //primeiro dia do mes corrente

    $scope.reset = function() {

      $scope.visible = false;

      delete $scope.produtos;

    };

    //$scope.reset();

    var onTopclientesprodutos = function(results){
      if (results && results.Successeded) {
        $scope.produtos = (results.Retorno[0].ReceitaEstimadaAgenda);
      } else {
        $scope.produtos = 0;
      }
    };

    $scope.getReceitaEstimada = function() {

      $scope.reset();

      $scope.visible = true;

      var requestData = {
        DataInicio: $scope.data.de.ddmmyyyy(),
        DataFinal: $scope.data.ate.ddmmyyyy()
      };

      ReceitasApi.getReceitaEstimada(requestData, onTopclientesprodutos);

    };

    // $scope.getReceitaEstimada();

  }
]);
