var controllers = angular.module('app.controllers');

controllers.controller('MapCtrl', ['$rootScope', '$scope', '$state', 'deviceStorage', 'UserApi', 'SaloesApi', '$timeout' , '$ionicPopup', 'DEALER', '$translate', 'translations',
  function($rootScope, $scope, $state, deviceStorage, UserApi, SaloesApi , $timeout , $ionicPopup , DEALER , $translate, translations) {

    var me = this;

    $scope.salao = deviceStorage.get('salao');

    var map = null;
    var searchResults = [];

    var item = null;
    var marker = null;
    var markers = [];
    var markers2 = [];
    markersCache = SaloesApi.markersCache;

    var addressPoints = [];

    $scope.notOne = false;

    $scope.util = {};
    $scope.util.mostrarBarraInferior = true;

    // deviceStorage.put('saloes',null);

    // me.translations = {};
    // $rootScope.$on('$translateChangeSuccess', function () {
    //   translate();
    // });

    // translate();

    // function translate () {
    //   $translate(['APP_MAP_INVITE_TITLE', 'APP_MAP_INVITE_DESCRIPTION', 'APP_MAP_INVITE_ACTION', 'APP_MAP_SCHEDULE', 'APP_MAP_FIND_ON', 'APP_CLOSE'])
    //     .then(function (translations) {
    //       me.translations = translations;
    //     })
    //     .catch(function (error) {
    //     })
    // }

    me.translations = translations;

    // Leaflet map cluster
    var markerCluster = new L.MarkerClusterGroup({
      showCoverageOnHover: false,
      disableClusteringAtZoom: 16,
      spiderfyDistanceMultiplier: 2,
    });

    function addressPointsGoogle(r) { //console.log(r.results);

      for(var i = 0; i < r.length; i++) {

        var item = r[i];

        if ( markersCache[item.id] ) continue;

        markersCache[item.id] = item;

        var popupContent =  '<div class="popup">' +
                              '<div class="marker-info" style="width: 100%;margin: 5px 0px;padding: 0 2px;">'+
                                '<h2>' + item.name + '</h2>' +
                                '<small>' + item.vicinity + '</small> ' +
                              '</div>' +
                              '<hr>' +
                              '<div class="marker-info" style="width: 100%;margin: 5px 0px;padding: 0 2px;">'+
                                '<h2>' + me.translations.APP_MAP_INVITE_TITLE + '</h2>' +
                                me.translations.APP_MAP_INVITE_DESCRIPTION +
                              '</div>'+
                              '<div class="clear"></div>'+
                              '<hr>'+
                              '<a href="#/entrar/'+item.id+'" class="button button-block button-positive button-convidar">' + me.translations.APP_MAP_INVITE_ACTION + '</a>'+
                            '</div>';

        var marker = L.marker(new L.LatLng( item.geometry.location.lat() , item.geometry.location.lng() ), {
          icon: L.icon({
            // 'marker-size': 'small',
            // 'marker-symbol': 'commercial',
            // 'marker-color': '999'
            iconUrl: 'https://onebelezamobile.azurewebsites.net/img/marker.png',
            // iconRetinaUrl: 'img/marker@2x.png',
            iconSize: [20, 20],
            iconAnchor: [20, 20],
            popupAnchor: [-10, -10],
            // shadowUrl: 'my-icon-shadow.png',
            // shadowRetinaUrl: 'my-icon-shadow@2x.png',
            // shadowSize: [68, 95],
            // shadowAnchor: [22, 94]
          })
        });

        item.markerId = i;

        markers2.push(marker);

        marker.bindPopup(popupContent,{
          closeButton: false,
          minWidth: 320
        });

      }

      markerCluster.addLayers(markers2);

      // if ( r.next_page_token ) {
      //   setTimeout( function(argument) {
      //     SaloesApi.getAdressPointsGoogle( [] , r.next_page_token , addressPointsGoogle );
      //   } , 1500 );
      // }

    }

    $scope.focusPointMaps = function( addressPoint ){

      // var latlng = L.latLng(addressPoint.Latitude, addressPoint.Logintude);
      // map.setView(latlng,19);

      // setTimeout( function(){ markers[addressPoint.markerId].openPopup(); } , 500 );

      // $scope.searchResults = null;

      SaloesApi.getDetails( addressPoint.placeid , function(r) {

        var latlng = L.latLng(r.geometry.location.lat(), r.geometry.location.lng());
        map.setView(latlng,19);

        // setTimeout( function(){ markers[addressPoint.markerId].openPopup(); } , 500 );

      } );

      $scope.searchResults = null;
      $scope.searchResultsMaps = null;

    };

    var stopSearch;

    $scope.focusPoint = function( addressPoint ){

      $state.go('entrar',{empresasID:addressPoint.EmpresasID});

      stopSearch = true;

      var latlng = L.latLng(addressPoint.Latitude, addressPoint.Logintude);
      map.setView(latlng,19);

      setTimeout( function(){ markers[addressPoint.markerId].openPopup(); } , 500 );

      $scope.searchResults = null;
      $scope.searchResultsMaps = null;

    };

    $scope.searchPlace = function(search, searchKey){

      var coords = map.containerPointToLatLng(L.point(window.screen.width/2, window.screen.height/2));

      // if( searchKey && searchKey.length >= 2){

      //   SaloesApi.autocomplete( [coords.lat,coords.lng] , searchKey , function(r) {
      //     searchResults = [];
      //     for (var i = 0; i < r.length; i++) {
      //       var p = r[i];
      //       searchResults.push( {
      //         Descricao : p.description,
      //         //Descricao : p.terms[0].value + ", " + p.terms[1].value,
      //         placeid: p.place_id
      //       });
      //     }
      //     $scope.searchResultsMaps = searchResults;
      //   } );
      // }

      $scope.searchResults = null;
      $scope.searchResultsMaps = null;

        if ( searchKey && searchKey.length >= 2) {

          stopSearch = false;

            searchResults = [];
            if ( addressPoints )  for( var j = 0; j < addressPoints.length; j++){
                var com = addressPoints[j].Descricao.toLowerCase().indexOf(searchKey.toLowerCase());
                if(com >= 0){
                  searchResults.push(addressPoints[j]);
                }
            }
            $scope.searchResults = searchResults;

            // if ( $scope.notOne ) {
              SaloesApi.autocomplete( [coords.lat,coords.lng] , searchKey , function(r) {

                var searchResultsMaps = [];
                for (var i = 0; i < r.length; i++) {
                  var p = r[i];
                  searchResultsMaps.push( {
                    Descricao : p.description,
                    //Descricao : p.terms[0].value + ", " + p.terms[1].value,
                    placeid: p.place_id
                  });
                }
                $timeout( function(){
                  if ( stopSearch ) return;

                  $scope.searchResultsMaps = searchResultsMaps;
                } , 1000 );
              } );
            // }

        } else {
            $scope.searchResults = null;
            $scope.searchResultsMaps = null;
        }
    };

    var mapaclick = function(){
      alert('mapaclick');
    };

    var setMarkers = function(addressPointsRetorno){
        if(addressPoints !== null){

            addressPoints = addressPointsRetorno.Retorno;

            for(var i = 0; i < addressPoints.length; i++) {
                item = addressPoints[i];                
                //var map = 'http://maps.google.com/maps?daddr='+item.Latitude+','+item.Logintude+'&amp;ll='
                // var localizacao = '<p class="address">Localização: <span style="font-size:12px">'+item.Latitude+','+item.Logintude+'</span></p>';
                var localizacao = '<i style="font-size:30px;" class="icon ion-map"></i>';
                var popupContent =  "";//'<a class="popup" href="#/entrar/'+item.EmpresasID+'">';
                popupContent += '<div class="sobre"> <div class="item-body">\
                  <object height="117px" data="'+item.LogoMarca+'" type="image/png" style="text-align: center; width: 100%; object-fit: contain; display: block;">\
                    <img height="117px" src="https://onemidias.azurewebsites.net/6faeef6ecad3c29a3a629280e6855hfac3f5d5a86aff3ca12020c923adc6c14/semlogo.png">\
                  </object>\
                  <p class="title"> '+item.Descricao+'</p>';
                // popupContent+'<p class="description">'+item.Descricao+' '+item.Descricao+' '+item.Descricao+' '+item.Descricao+'</p>';
                if (item.DescricaoDetalhada && item.DescricaoDetalhada.length > 0){
                  popupContent += '<p>'+item.DescricaoDetalhada.substring(0, 100)+'</p>'
                }
                popupContent+='<p class="address">'+item.TipoEndereco+' '+item.Endereco + ( item.Numero ? ', ' + item.Numero : '') + '</p> <p class="address">'+item.Bairro+' </p> </div></div>';


                popupContent += '<div class="clear"></div><span id="mapalocalizacao" data-nomeestabelecimento='+item.Descricao+' data-log='+item.Logintude+' data-lat='+item.Latitude+'>' + me.translations.APP_MAP_FIND_ON + ' '+ localizacao+ '</span><hr>';
                popupContent += '<a class="popup" href="#/entrar/'+item.EmpresasID+'">';
                popupContent += '<button type="button" class="button button-block button-positive button-convidar">' + me.translations.APP_MAP_SCHEDULE + '</button></a>';

                                    //http://mmtools.com.br/onebeleza/images/18631655.logo.png
                // marker = L.marker(new L.LatLng(item.Latitude, item.Logintude), {
                //   icon: L.mapbox.marker.icon({
                //     //'marker-symbol': 'commercial',
                //     'marker-color': '86b91a'
                //   })
                // });

                var marker = L.marker(new L.LatLng(item.Latitude, item.Logintude), {
                  icon: L.icon({
                    // 'marker-size': 'small',
                    'marker-symbol': 'commercial',
                    // 'marker-color': '999'
                    iconUrl: 'https://onebelezamobile.azurewebsites.net/img/' + (DEALER.marker || DEALER.slug) + '.png',
                    // iconUrl: 'img/one.png',
                    iconRetinaUrl: 'https://onebelezamobile.azurewebsites.net/img/' + (DEALER.marker || DEALER.slug) + '@2x.png',
                    iconSize: [30, 70],
                    iconAnchor: [30, 35],
                    popupAnchor: [-15, -35],
                    // shadowUrl: 'my-icon-shadow.png',
                    // shadowRetinaUrl: 'my-icon-shadow@2x.png',
                    // shadowSize: [68, 95],
                    // shadowAnchor: [22, 94]
                  })
                });



                marker.bindPopup(popupContent,{
                  closeButton: true,
                  minWidth: 300
                });




                markers.push(marker);

                item.markerId = i;

            }
            //markerCluster.addLayers(markers);
        }
    };

    var runOnDeviceReady = function(callback) {
      //if (navigator.userAgent.match(/(iPhone|iPod|iPad|Android|BlackBerry)/)) {
      if (typeof cordova !== 'undefined') {
          document.addEventListener("deviceready", callback, false);
      }
      else {
          callback();
      }
    };

    var panToGpsLocation = function(isFirstUpdate) {
      navigator.geolocation.getCurrentPosition(
          function (geoposition) {

              map.panTo(L.latLng(geoposition.coords.latitude, geoposition.coords.longitude));

              if ( isFirstUpdate ) {

                L.marker(new L.LatLng(geoposition.coords.latitude, geoposition.coords.longitude), {
                  icon: L.mapbox.marker.icon({
                    'marker-symbol': 'circle',
                    'marker-color': 'ff0000'
                  })
                }).addTo(map);

              }

          },
          function (error) {
              console.log('Unable to get location: ' + error.message);
          }
      );
    };

    var init = function() {

        L.mapbox.accessToken = 'pk.eyJ1IjoibXBvc3NhcyIsImEiOiJjanh1cG0wMTQxN3NxM3BueW56ajZkcHJsIn0.Oacv61XGtosbluu-JwvdIA';
        map = L.mapbox.map('map', 'mapbox.streets', {
          center: [-19.9178713, -43.9603116], // Belo Horizonte
          zoom: 18,
          //minZoom: 13,
          zoomControl: false,
          attributionControl: false,
          reuseTiles: true
        });

        map.on('moveend', function(e) {

          if ($scope.notOne) {

            var coords = map.containerPointToLatLng(L.point(window.screen.width/2, window.screen.height/2));

            //SaloesApi.getAdressPointsGoogle( [coords.lat,coords.lng] , '' , addressPointsGoogle );

          }

        });
        map.on('popupopen', function(e) {
            $scope.util.mostrarBarraInferior = false;
            $scope.$apply();
            var px = map.project(e.popup._latlng);
            px.x -=15;
             // find the pixel location on the map where the popup anchor is
            px.y -= e.popup._container.clientHeight/2; // find the height of the popup container, divide by 2, subtract from the Y axis of marker location
            px.y -=20;
            map.panTo(map.unproject(px),{animate: true}); // pan to new center

            document.getElementById("mapalocalizacao") && document.getElementById("mapalocalizacao").addEventListener("click", function(e) {

                var infos = document.getElementById("mapalocalizacao").dataset;
                var localizacao_maps = infos.lat+','+infos.log;
                var nome_estabelecimento = infos.nomeestabelecimento;
                if(ionic.Platform.isIOS()){
                  window.open('maps://?q=' + localizacao_maps, '_system');
                } else {
                  var label = encodeURI(nome_estabelecimento.toString());
                  window.open('geo:0,0?q=' + localizacao_maps + '(' + label + ')', '_system');
                }
            });



        });

        map.on('popupclose', function(e){
          $scope.util.mostrarBarraInferior = true;
          $scope.$apply();
        });

        // Pan map to current geolocation
        runOnDeviceReady(panToGpsLocation.bind(this, true));

        map.addLayer(markerCluster);

        SaloesApi.getAdressPoints(setMarkers, function () {
          $state.go('entrar');
        });

    };
    init();

    // $scope
    // --------------------------------------------------------------------------------
    $scope.centerOnMe = function() {
      panToGpsLocation(false);
    };

    /*$scope.setNotOne = function(v) {

      $scope.notOne = v;

      if ($scope.notOne) {

        markerCluster.addLayers(markers2);

        var coords = map.containerPointToLatLng(L.point(window.screen.width/2, window.screen.height/2));

        SaloesApi.getAdressPointsGoogle( [coords.lat,coords.lng] , '' , addressPointsGoogle );

      } else {
        markerCluster.removeLayers(markers2);
      }

    };*/

    //$scope.setNotOne(true);

    $scope.sobre = function(salao) { //console.log(salao);

    $ionicPopup.show({
      templateUrl: 'templates/sobre.html',
      title : 'Sobre',
      cssClass: 'sobre-popup',
      buttons: [{ // Array[Object] (optional). Buttons to place in the popup footer.
        text: me.translations.APP_CLOSE,
        type: 'button-positive',
        onTap: function(e) {
          // e.preventDefault() will stop the popup from closing when tapped.
          // e.preventDefault();
        }
      }]
    });
  };

}]);
