var controllers = angular.module('app.controllers');

controllers.controller('PesquisaSaloesCtrl', [ '$scope', '$rootScope' , '$state', 'deviceStorage', 'AuthApi','SaloesApi', '$ionicLoading', 'Popup', 'DEALER',
  function($scope, $rootScope , $state, deviceStorage , AuthApi ,SaloesApi, $ionicLoading, Popup, DEALER) {


    $scope.autenticaSalao = function(salaoEscolhido){
      
         authenticate(salaoEscolhido.originalObject);
    } 

    $scope.autenticaSalaoProximo = function(salaoEscolhido){
        var array = $scope.listaSaloes;
       for(var i=0; i<array.length;i++){
         if(array[i].EmpresasID===salaoEscolhido.id){
            authenticate(array[i]);
          }
        }
        
    } 

    

    var authenticate = function(salao) {

      if (DEALER.filiais) {
        salao = deviceStorage.get('saloes').Retorno.find(function (currentSalao) {
          return currentSalao.EmpresasID == salao.EmpresasID;
        });
      }

      var requestData = deviceStorage.get('login');
      requestData.empresa = salao.EmpresasID;

      $ionicLoading.show();

      AuthApi.authenticate(requestData, function (r) {

        if ( r.Successeded ) {
          $ionicLoading.hide();
          authenticate(r);

          if ($rootScope.isAnonimous()) {
            deviceStorage.put('firstTime', true);
          }
        }else {
          AuthApi.registrarusuarioempresa({
            UsuarioId: deviceStorage.get('user').UsuarioId,
            EmpresaId: salao.EmpresasID
          }, function () {
            AuthApi.authenticate(requestData, function(r) {

              $ionicLoading.hide();

              if ( r.Successeded ) {
                authenticate(r);
              } else {
                Popup.alert(r.Message);
              }

            })
          });
        
      }
      
      function authenticate(r, requestData) {
       
        deviceStorage.put('permissoes', r.Retorno);

          deviceStorage.put('salao',salao);
         deviceStorage.put('user', r)
         
          .then(function () {
            try {
              // evita sobrescrever chave de push caso o usuário logue com senha alternativa
              var isAlternativePassword = r.Retorno.usouSenhaAlternativa;
    
              if (!isAlternativePassword) {
                AuthApi.RegistrarDispositivo({
                  Chave: Chave, //registrationId do aparelho
                  Dispositivo: Dispositivo //pode ser "Google", "Apple", ou "Windows"
                }, function (argument) {
                  // alert(JSON.stringify(argument) );
                  // version_data += JSON.stringify(argument);
                });
              }
    
            } catch (e) {/*console.log(e);*/}
          })
    
        AuthApi.getusuarioid(requestData, function(r) {
          deviceStorage.put('UsuarioId', r.UsuarioId);
        });
    
        $rootScope.user = r.Retorno;
    
        if ( $rootScope.user.Colaborador && $rootScope.user.usouSenhaAlternativa) {
          deviceStorage.put('loginType', 'contributor.dashboard');
          $state.go('contributor.dashboard');
        } else if ( $rootScope.user.Cliente + $rootScope.user.Colaborador + $rootScope.user.Gerente > 1 ) {
          $state.go('logintype');
        } else if ( $rootScope.user.Colaborador ) {
          deviceStorage.put('loginType', 'contributor.dashboard');
          $state.go('contributor.dashboard');
        } else if ( $rootScope.user.Gerente ) {
          deviceStorage.put('loginType', 'manager.dashboard');
          $state.go('manager.dashboard');
        } else {
          deviceStorage.put('loginType', 'client.dashboard');
          $state.go('client.dashboard');
        }
      }

      });

    };
  
 
     var coord =function coordenadas(results){

     navigator.geolocation.getCurrentPosition(
      
        function (geoposition) {
          var geoposition = geoposition
          saloes(results,geoposition);             
   
           },
           function (error) {
               Popup.alert('Permita que o App use seu gps:' );
               $scope.listaSaloes = results.Retorno
           }
       );
      
    }
   

    var saloes =  function(results,geoposition){
       
        var latitude = geoposition.coords.latitude;
     
        var longitude = geoposition.coords.longitude;
       
        $scope.listaSaloes = results.Retorno;
       // console.log($scope.listaSaloes);
       
        var listaDistancia = results.Retorno.map(function(item){
                                     
          return {id:item.EmpresasID,
            nome:item.Descricao,  
           distancia: Math.hypot(item.Latitude-latitude, item.Logintude-longitude)
          }
        })
        
        listaDistancia.sort(function(a, b) {
          if(isFinite(a.distancia-b.distancia)){
            return a.distancia - b.distancia;
          }
          else {
            return isFinite(a.distancia) ? -1 : 1;
          }
        });
        //console.log(listaDistancia);
       $scope.saloesProximos = listaDistancia.slice(0, 10);
       Popup.alert('Escolha um salão próximo a você ou procure um na barra de pesquisa.' );
    
   }

    var init = function(){
     
       SaloesApi.getAdressPoints(coord);
    }
    
     init();

     


}

]);