var controllers = angular.module('app.controllers');

controllers.controller('SaloesCtrl', [ '$scope', '$rootScope' , '$state', 'deviceStorage', 'AuthApi', '$ionicLoading', 'Popup', 'DEALER',
  function($scope, $rootScope , $state, deviceStorage , AuthApi , $ionicLoading, Popup, DEALER) {
    $ionicLoading.hide();

    // debugger;

    $scope.shouldShowDelete = false;

    $scope.showDelete = function() {
      $scope.shouldShowDelete = !$scope.shouldShowDelete;
    }

    // if (($rootScope.saloes.length === 0) && DEALER.name == 'One') {
    //   $state.go('mapa');
    // }
    // else{
    //   $state.go('saloes');
    // }

    if (DEALER.filiais) {
      $scope.saloes = DEALER.filiais;
    } else {
      $scope.saloes = deviceStorage.get('saloesUsuario');
    }

    $scope.empresasID = "0";
    $scope.user = deviceStorage.get('user').Retorno;
    if($scope.empresasID === "0" && deviceStorage.get('salao') !== null){
      $scope.empresasID = deviceStorage.get('salao').EmpresasID;
    }
    if ( $scope.empresasID && deviceStorage.get('saloes') ) {
      // $scope.
      var saloes = ( deviceStorage.get('saloes') ).Retorno;
      for ( var s in saloes ) {
        var salao = saloes[s];
        if ( salao.EmpresasID == $scope.empresasID ) {
          $scope.salao = salao;
          $scope.savedSalao = salao;
          break;
        }
      }
    } else if ( $scope.savedSalao ) {
      $scope.salao = $scope.savedSalao;
    }

    $scope.desvincular = function(salao) {

      var requestData = {
        UsuarioId : $rootScope.UsuarioId,
        EmpresaId : salao.EmpresasID
      };

      var index = $scope.saloes.indexOf(salao);
      if (index > -1) {
        $scope.saloes.splice(index, 1);
      }

      AuthApi.desvincularusuarioempresa(requestData, function(r) {

      });

    };

    $scope.authenticate = function(salao) {

      if (DEALER.filiais) {
        salao = deviceStorage.get('saloes').Retorno.find(function (currentSalao) {
          return currentSalao.EmpresasID == salao.EmpresasID;
        });
      }

      var requestData = deviceStorage.get('login');
      requestData.empresa = salao.EmpresasID;

      $ionicLoading.show();

      AuthApi.authenticate(requestData, function (r) {

        if ( r.Successeded ) {
          $ionicLoading.hide();
          authenticate(r);

          if ($rootScope.isAnonimous()) {
            deviceStorage.put('firstTime', true);
          }
        }else {
          AuthApi.registrarusuarioempresa({
            UsuarioId: deviceStorage.get('user').UsuarioId,
            EmpresaId: salao.EmpresasID
          }, function () {
            AuthApi.authenticate(requestData, function(r) {

              $ionicLoading.hide();

              if ( r.Successeded ) {
                authenticate(r);
              } else {
                Popup.alert(r.Message);
              }

            })
          });
        
      }
      
      function authenticate(r, requestData) {
       
        deviceStorage.put('permissoes', r.Retorno);

          deviceStorage.put('salao',salao);
         deviceStorage.put('user', r)
         
          .then(function () {
            try {
              // evita sobrescrever chave de push caso o usuário logue com senha alternativa
              var isAlternativePassword = r.Retorno.usouSenhaAlternativa;
    
              if (!isAlternativePassword) {
                AuthApi.RegistrarDispositivo({
                  Chave: Chave, //registrationId do aparelho
                  Dispositivo: Dispositivo //pode ser "Google", "Apple", ou "Windows"
                }, function (argument) {
                  // alert(JSON.stringify(argument) );
                  // version_data += JSON.stringify(argument);
                });
              }
    
            } catch (e) {/*console.log(e);*/}
          })
    
        AuthApi.getusuarioid(requestData, function(r) {
          deviceStorage.put('UsuarioId', r.UsuarioId);
        });
    
        $rootScope.user = r.Retorno;
    
        if ( $rootScope.user.Colaborador && $rootScope.user.usouSenhaAlternativa) {
          deviceStorage.put('loginType', 'contributor.dashboard');
          $state.go('contributor.dashboard');
        } else if ( $rootScope.user.Cliente + $rootScope.user.Colaborador + $rootScope.user.Gerente > 1 ) {
          $state.go('logintype');
        } else if ( $rootScope.user.Colaborador ) {
          deviceStorage.put('loginType', 'contributor.dashboard');
          $state.go('contributor.dashboard');
        } else if ( $rootScope.user.Gerente ) {
          deviceStorage.put('loginType', 'manager.dashboard');
          $state.go('manager.dashboard');
        } else {
          deviceStorage.put('loginType', 'client.dashboard');
          $state.go('client.dashboard');
        }
      }

      });

    };

    $scope.setLoginType = function( loginType ) {
      if ( $rootScope.user.Cliente + $rootScope.user.Colaborador + $rootScope.user.Gerente > 1 ) {
        $state.go('logintype');
      } else if ( $rootScope.user.Colaborador ) {
        deviceStorage.put('loginType', 'contributor.dashboard');
        $state.go('contributor.dashboard');
      } else if ( $rootScope.user.Gerente ) {
        deviceStorage.put('loginType', 'manager.dashboard');
        $state.go('manager.dashboard');
      } else {
        deviceStorage.put('loginType', 'client.dashboard');
        $state.go('client.dashboard');
      }
    };

}]);
