angular.module('app.filters', [])

.filter('reverse', function() {
  return function(input, uppercase) {

    var days = [
      'Domingo',
      'Segunda-feira',
      'Terça-feira',
      'Quarta-feira',
      'Quinta-feira',
      'Sexta-feira',
      'Sábado'
    ];
    var data = new Date( input.replace( /(\d{2})\/(\d{2})\/(\d{4})/, "$3-$2-$1T12:00:00") );

    return days[data.getDay()];
  };
})

.filter('string2date', function() {
  return function(input) {

    var data = Date.ddmmyyyy(input);

    return data;
  };
})

.filter('time2date', function() {
  return function(input) {

    var data = Date.hhmm(input);

    return data;
  };
})

.filter('date2string', function() {
  return function(input) {

    return input.ddmmyyyy();
  };
})

.filter('date2time', function() {
  return function(input) {

    return input.hhmm();
  };
})

.filter('hhmmss2hhmm', function() {
  return function(input) {
    if (/\d{2}:\d{2}:\d{2}/.test(input)) {
      return input.slice(0, -3);
    }
    return input;
  };
});
