var services = angular.module('app.services');

services.service('AgendaApi', [ '$http', '$q', '$cacheFactory', 'deviceStorage', 'APP_URL', 'APP_URL_NEW',
  function ($http, $q, $cacheFactory, deviceStorage, APP_URL, APP_URL_NEW) {

  this.previousEvents = function(requestData, callback) {
    var request = $http({
      method: 'POST',
      headers: { 'X-Token': deviceStorage.get('user').Token},
      url: APP_URL_NEW+'agendas/previousevents',
      data: JSON.stringify(requestData)
    }).success(callback).error(callback);
  };

  this.HistoricoServicos = function(requestData, callback) {
    var request = $http({
      method: 'POST',
      headers: { 'X-Token': deviceStorage.get('user').Token},
      url: APP_URL_NEW+'cliente/historicoservicos',
      data: JSON.stringify(requestData)
    }).success(callback).error(callback);
  };

  this.HistoricoProdutos = function(requestData, callback) {
    var request = $http({
      method: 'POST',
      headers: { 'X-Token': deviceStorage.get('user').Token},
      url: APP_URL_NEW+'cliente/HistoricoProdutos',
      data: JSON.stringify(requestData)
    }).success(callback).error(callback);
  };

  this.nextEvents = function(requestData, callback) {
    var request = $http({
      method: 'POST',
      headers: { 'X-Token': deviceStorage.get('user').Token},
      url: APP_URL_NEW+'agendas/nextevents',
      data: JSON.stringify(requestData)
    }).success(callback).error(callback);
  };

  this.getGrupoServicos = function(requestData,callback){
    //console.info(deviceStorage.get('user').Token);
    var request = $http({
      method: 'POST',
      headers: { 'X-Token': deviceStorage.get('user').Token},
      url: APP_URL_NEW+'agendas/consultargservsnovo',
      data: JSON.stringify(requestData)
    }).success(callback).error(callback);
  };

  this.getServicos = function(requestData, callback){
    var request = $http({
      method: 'POST',
      headers: { 'X-Token': deviceStorage.get('user').Token},
      url: APP_URL_NEW+'agendas/consultarservicosnovo',
      data: JSON.stringify(requestData)
    }).success(callback).error(callback);
  };

  this.getProfissionais = function(requestData, callback){
    var request = $http({
      method: 'POST',
      headers: { 'X-Token': deviceStorage.get('user').Token},
      url: APP_URL_NEW+'agendas/consultarprofissionaisnovo',
      data: JSON.stringify(requestData)
    }).success(function(data, status){
      //console.info(data);
      //console.info(status);
      callback(data);
    }).error(callback);
  };

  this.getDatas = function(requestData, callback){
    var request = $http({
      method: 'POST',
      headers: { 'X-Token': deviceStorage.get('user').Token},
      url: APP_URL_NEW+'agendas/datadisponiveisnovo',
      data: JSON.stringify(requestData)
    }).success(callback).error(callback);
  };

  this.getHoras = function(requestData, callback){
    var request = $http({
      method: 'POST',
      headers: { 'X-Token': deviceStorage.get('user').Token},
      url: APP_URL_NEW+'agendas/horariosdisponiveis',
      data: JSON.stringify(requestData)
    }).success(callback).error(callback);
  };

  this.getHorasNovo = function(requestData, callback){
    var request = $http({
      method: 'POST',
      headers: { 'X-Token': deviceStorage.get('user').Token},
      url: APP_URL_NEW+'agendas/horariosdisponiveisnovo',
      data: JSON.stringify(requestData)
    }).success(callback).error(callback);
  };

  this.postAgendar = function(requestData, callback){
    var request = $http({
      method: 'POST',
      headers: { 'X-Token': deviceStorage.get('user').Token},
      url: APP_URL_NEW+'agendas/salvaragendamento',
      data: JSON.stringify(requestData)
    }).success(callback).error(callback);
  };

  this.editarAgenda = function(requestData, callback){
    var request = $http({
      method: 'POST',
      headers: { 'X-Token': deviceStorage.get('user').Token},
      url: APP_URL_NEW+'agendas/editaragendamento',
      data: JSON.stringify(requestData)
    }).success(callback).error(callback);
  };

  this.clienteEmAtendimento = function(requestData, callback){
    var request = $http({
      method: 'POST',
      headers: { 'X-Token': deviceStorage.get('user').Token},
      url: APP_URL_NEW+'agendas/ClienteEmAtendimento',
      data: JSON.stringify(requestData)
    }).success(callback).error(callback);
  };

  this.cancelarAgendamento = function(requestData, callback){
    var request = $http({
      method: 'POST',
      headers: { 'X-Token': deviceStorage.get('user').Token},
      url: APP_URL_NEW+'agendas/cancelaragendamento',
      data: JSON.stringify(requestData)
    }).success(callback).error(callback);
  };

  this.periodosDisponiveis = function(requestData, callback){
    var request = $http({
      method: 'POST',
      headers: { 'X-Token': deviceStorage.get('user').Token},
      url: APP_URL_NEW+'agendas/PeriodosDisponiveis',
      data: JSON.stringify(requestData)
    }).success(callback).error(callback);
  };

  this.ListarHorariosAgendadosDeClientesAA = function(requestData, callback){
    var request = $http({
      method: 'POST',
      headers: { 'X-Token': deviceStorage.get('user').Token},
      url: APP_URL_NEW+'agendas/ObterAgendamentosDeClientesAA',
      data: JSON.stringify(requestData)
    }).success(callback).error(callback);
  };

  this.ListarHorariosAgendadosDoClienteAA = function(requestData, callback){
    var request = $http({
      method: 'POST',
      headers: { 'X-Token': deviceStorage.get('user').Token},
      url: APP_URL_NEW+'agendas/ObterAgendamentosDoClienteAA',
      data: JSON.stringify(requestData)
    }).success(callback).error(callback);
  };

  this.cancelarAgendamentoAA = function(requestData, callback){
    var request = $http({
      method: 'POST',
      headers: { 'X-Token': deviceStorage.get('user').Token},
      url: APP_URL_NEW+'agendas/desbloquearDesmarcarHorarioAA',
      data: JSON.stringify(requestData)
    }).success(callback).error(callback);
  };

  this.ListarHorariosDisponiveisParaBloqueioAA = function(requestData, callback){
    var request = $http({
      method: 'POST',
      headers: { 'X-Token': deviceStorage.get('user').Token},
      url: APP_URL_NEW+'agendas/listarHorariosDisponiveisParaBloqueioAA',
      data: JSON.stringify(requestData)
    }).success(callback).error(callback);
  };

  this.BloquearHorarioAA = function(requestData, callback){
    var request = $http({
      method: 'POST',
      headers: { 'X-Token': deviceStorage.get('user').Token},
      url: APP_URL_NEW+'agendas/BloquearHorarioAA',
      data: JSON.stringify(requestData)
    }).success(callback).error(callback);
  };

  this.getGrupoServicosWithUser2 = function(requestData,callback){
    //console.info(deviceStorage.get('user').Token);
    var request = $http({
      method: 'GET',
      headers: { 'X-Token': deviceStorage.get('user').Token},
      url: APP_URL_NEW+'gservs/ListaDeGrupoDeServicosDoColaborador/'+requestData.ID,
    }).success(callback).error(callback);
  };

  this.getInfoBasicaEndereco = function(requestData,callback){
    //console.info(deviceStorage.get('user').Token);
    var request = $http({
      method: 'GET',
      headers: { 'X-Token': deviceStorage.get('user').Token},
      url: APP_URL_NEW+'cliente/InfoBasicaEndereco?clienteId='+requestData.ID,
    }).success(callback).error(callback);
  };

  this.alterarBasicaEndereco = function(requestData, callback){
    var request = $http({
      method: 'POST',
      headers: { 'X-Token': deviceStorage.get('user').Token},
      url: APP_URL_NEW+'cliente/AlterarBasicaEndereco',
      data: JSON.stringify(requestData)
    }).success(callback).error(callback);
  };
  

  this.getServicosDoColaboradorSemMobilidade = function(requestData, callback){
    var request = $http({
      method: 'POST',
      headers: { 'X-Token': deviceStorage.get('user').Token},
      url: APP_URL_NEW+'servicos/ListarServicosDoColaboradorSemMobilidade',
      data: JSON.stringify(requestData)
    }).success(callback).error(callback);
  };

  this.postAgendarAA = function(requestData, callback){
    var request = $http({
      method: 'POST',
      headers: { 'X-Token': deviceStorage.get('user').Token},
      url: APP_URL_NEW+'agendas/salvaragendamentoAA',
      data: JSON.stringify(requestData)
    }).success(callback).error(callback);
  };

}]);
