var services = angular.module('app.services');

services.service('AuthApi', [ '$http', '$q', '$cacheFactory', 'deviceStorage',  'APP_URL', 'APP_URL_NEW', 'DEALER',
  function ($http, $q, $cacheFactory, deviceStorage, APP_URL, APP_URL_NEW, DEALER) {

  this.authenticateSemEmpresa = function(requestData, callback, callbackError) {
    var request = $http({
      method: 'POST',
      url: APP_URL_NEW+'Security/AuthenticateMobilidadeSemEmpresa',
      data: JSON.stringify(requestData)
    }).success(callback).error(callback).catch(callbackError);
  };

  this.authenticate = function(requestData, callback) {

    var url;
    if (requestData.senha) {
      // url = APP_URL + 'Security/AuthenticateMobilidade';
      url = APP_URL_NEW + 'Security/AuthenticateMobilidade';
    } else {
      delete requestData.email;
      url = APP_URL_NEW + 'Security/AuthenticateMobilidadeFacebook';
    }

    var request = $http({
      method: 'POST',
      url: url,
      data: JSON.stringify(requestData)
    }).success(callback).error(callback);
  };

  this.authenticateAutoAtendimento = function(requestData, callback) {
    var request = $http({
      method: 'POST',
      url: APP_URL_NEW+'Security/AuthenticateMobilidade',
      data: JSON.stringify(requestData)
    }).success(callback).error(callback);
  };

  this.getusuarioid = function(requestData, callback) {
    var request = $http({
      method: 'POST',
      url: APP_URL_NEW+'account/getusuarioid',
      data: JSON.stringify(requestData)
    }).success(callback).error(callback);
  };

  this.convidarsalao = function(requestData, callback) {
    var request = $http({
      method: 'POST',
      url: APP_URL_NEW+'invites/convidarsalao',
      headers: { 'X-Token': deviceStorage.get('user').Token},
      data: JSON.stringify(requestData)
    }).success(callback).error(callback);
  };

  this.statusempresanaocliente = function(requestData, callback) {
    var request = $http({
      method: 'POST',
      url: APP_URL_NEW+'empresas/statusempresanaocliente',
      data: JSON.stringify(requestData)
    }).success(callback).error(callback);
  };

  this.registrarusuarioempresa = function(requestData, callback) {
    var request = $http({
      method: 'POST',
      url: APP_URL_NEW+'account/registrarusuarioempresa',
      data: JSON.stringify(requestData)
    }).success(callback).error(callback);
  };

  this.desvincularusuarioempresa = function(requestData, callback) {
    var request = $http({
      method: 'POST',
      url: APP_URL_NEW+'account/desvincularusuarioempresa',
      data: JSON.stringify(requestData)
    }).success(callback).error(callback);
  };

  this.RegistrarDispositivo = function(requestData, callback) {
    requestData.App = DEALER.id; //0 -> One, 1 -> Totvs
    var request = $http({
      method: 'POST',
      url: APP_URL_NEW+'account/registrardispositivo',
      headers: { 'X-Token': deviceStorage.get('user').Token},
      data: JSON.stringify(requestData)
    }).success(callback).error(callback);
  };

  this.postCreateUser = function(requestData, callback) {
    requestData.App = DEALER.id; //0 -> One, 1 -> Totvs
    var request = $http({
      method: 'POST',
      url: APP_URL_NEW+'account/cadastrarnovousuario',
      data: JSON.stringify(requestData)
    }).success(callback).error(callback);
  };

  this.postForgotPassword = function(requestData, callback) {
    var request = $http({
      method: 'POST',
      url: APP_URL_NEW+'Security/EnviaCodigoRecuperacaoSenha',
      data: JSON.stringify(requestData)
      }).success(callback).error(callback);
  };

  this.postPushPassword = function(requestData, callback) {
    var request = $http({
      method: 'POST',
      url: APP_URL_NEW+'Security/EnviaCodigoRecuperacaoPush',
      data: JSON.stringify(requestData)
    }).success(callback).error(callback);
  };

  this.postVerificaCodigo = function(requestData, callback) {
    var request = $http({
      method: 'POST',
      url: APP_URL_NEW+'Security/VerificaCodigoRecuperacaoSenha',
      data: JSON.stringify(requestData)
    }).success(callback).error(callback);
  };

  this.postAlteraSenha = function(requestData, callback) {
    var request = $http({
      method: 'POST',
      url: APP_URL_NEW+'Security/ResetarSenha',
      data: JSON.stringify(requestData)
    }).success(callback).error(callback);
  };

  
  this.validarColaboradorAtivo = function (callback) {
    var request = $http({
      method: 'GET',
      url: APP_URL_NEW + 'security/ValidarColaboradorAtivo',
      headers: { 'X-Token': deviceStorage.get('user').Token},
      // data: JSON.stringify(requestData)
    }).success(callback).error(callback);
  };

  this.validarEmpresaAtiva = function (callback) {
    var request = $http({
      method: 'GET',
      url: APP_URL_NEW + 'security/ValidarEmpresaAtiva',
      headers: { 'X-Token': deviceStorage.get('user').Token},
      // data: JSON.stringify(requestData)
    }).success(callback).error(callback);
  };

}]);
