var services = angular.module('app.services');

services.service('ColaboradorApi', [ '$http', '$q', '$cacheFactory', 'deviceStorage', 'APP_URL', 'APP_URL_NEW',
  function ($http, $q, $cacheFactory, deviceStorage, APP_URL, APP_URL_NEW) {

    this.client = null;
    this.productList = [];
    this.serviceList = [];
    this.currentService = null;

  this.findClients = function( requestData , callback ) { //console.log(requestData);
    var request = $http({
      method: 'POST',
      headers: { 'X-Token': deviceStorage.get('user').Token},
      url: APP_URL_NEW+'colaborador/PesquisarCliente',
      data: JSON.stringify(requestData)
    }).success(callback).error(callback);
  };

  this.getprodutos = function(requestData, callback) {
    var request = $http({
      method: 'GET',
      headers: { 'X-Token': deviceStorage.get('user').Token},
      url: APP_URL_NEW+'produto/getprodutos/' + requestData,
    }).success(callback).error(callback);
  };

  this.consultarlistaregistroprodutos = function(requestData, callback) {
    var request = $http({
      method: 'POST',
      headers: { 'X-Token': deviceStorage.get('user').Token},
      url: APP_URL_NEW+'colaborador/consultarlistaregistroprodutos',
      data: JSON.stringify(requestData)
    }).success(callback).error(callback);
  };

  this.findFabricantes = function(requestData, callback) {
    var request = $http({
      method: 'GET',
      headers: { 'X-Token': deviceStorage.get('user').Token},
      url: APP_URL_NEW+'fabricante',
      data: JSON.stringify(requestData)
    }).success(callback).error(callback);
  };

  this.findLinhas = function(requestData, callback) {
    var request = $http({
      method: 'POST',
      headers: { 'X-Token': deviceStorage.get('user').Token},
      url: APP_URL_NEW+'linha',
      data: JSON.stringify(requestData)
    }).success(callback).error(callback);
  };

  this.findProducts = function(requestData, callback) {
    var request = $http({
      method: 'POST',
      headers: { 'X-Token': deviceStorage.get('user').Token},
      url: APP_URL_NEW+'colaborador/ConsultarProduto',
      data: JSON.stringify(requestData)
    }).success(callback).error(callback);
  };

  this.registrarProduto = function(requestData, callback) {
    var request = $http({
      method: 'POST',
      headers: { 'X-Token': deviceStorage.get('user').Token},
      url: APP_URL_NEW+'colaborador/RegistrarProduto',
      data: JSON.stringify(requestData)
    }).success(callback).error(callback);
  };

  this.excluirProduto = function(requestData, callback) {
    var request = $http({
      method: 'POST',
      headers: { 'X-Token': deviceStorage.get('user').Token},
      url: APP_URL_NEW+'colaborador/ExcluirProduto',
      data: JSON.stringify(requestData)
    }).success(callback).error(callback);
  };

  this.editarProduto = function(requestData, callback) {
    var request = $http({
      method: 'POST',
      headers: { 'X-Token': deviceStorage.get('user').Token},
      url: APP_URL_NEW+'colaborador/EditarProduto',
      data: JSON.stringify(requestData)
    }).success(callback).error(callback);
  };

  this.findGroups = function(requestData, callback) {
    var request = $http({
      method: 'POST',
      headers: { 'X-Token': deviceStorage.get('user').Token},
      url: APP_URL_NEW+'colaborador/listargruposservicos',
      data: JSON.stringify(requestData)
    }).success(callback).error(callback);
  };

  this.consultarlistaregistroservicos = function(requestData, callback) {
    var request = $http({
      method: 'POST',
      headers: { 'X-Token': deviceStorage.get('user').Token},
      url: APP_URL_NEW+'colaborador/consultarlistaregistroservicos',
      data: JSON.stringify(requestData)
    }).success(callback).error(callback);
  };

  this.findServices = function(requestData, callback) {
    var request = $http({
      method: 'POST',
      headers: { 'X-Token': deviceStorage.get('user').Token},
      url: APP_URL_NEW+'colaborador/listarservicos',
      data: JSON.stringify(requestData)
    }).success(callback).error(callback);
  };

  this.findComiservs = function(requestData, callback) {
    var request = $http({
      method: 'POST',
      headers: { 'X-Token': deviceStorage.get('user').Token},
      url: APP_URL_NEW+'colaborador/consultarcomiservs',
      data: JSON.stringify(requestData)
    }).success(callback).error(callback);
  };

  // this.findProfissionais = function(requestData, callback) {
  //   var request = $http({
  //     method: 'POST',
  //     headers: { 'X-Token': deviceStorage.get('user').Token},
  //     url: APP_URL_NEW+'profissionais/post',
  //     data: JSON.stringify(requestData)
  //   }).success(callback).error(callback);
  // };

  // this.findProfissionaisTodos = function(requestData, callback) {
  //   var request = $http({
  //     method: 'POST',
  //     headers: { 'X-Token': deviceStorage.get('user').Token},
  //     url: APP_URL_NEW +'colaborador/todosprofissionais',
  //     data: JSON.stringify(requestData)
  //   }).success(callback).error(callback);
  // };

  this.findAuxiliaresTodos = function(requestData, callback) {
    var request = $http({
      method: 'POST',
      headers: { 'X-Token': deviceStorage.get('user').Token},
      url: APP_URL_NEW +'colaborador/TodosAuxiliares',
      data: JSON.stringify(requestData)
    }).success(callback).error(callback);
  };

  this.registrarServico = function(requestData, callback) {
    var request = $http({
      method: 'POST',
      headers: { 'X-Token': deviceStorage.get('user').Token},
      url: APP_URL_NEW+'colaborador/RegistrarServico',
      data: JSON.stringify(requestData)
    }).success(callback).error(callback);
  };

  this.excluirServico = function(requestData, callback) {
    var request = $http({
      method: 'POST',
      headers: { 'X-Token': deviceStorage.get('user').Token},
      url: APP_URL_NEW+'colaborador/ExcluirServico',
      data: JSON.stringify(requestData)
    }).success(callback).error(callback);
  };

  this.editarServico = function(requestData, callback) {
    var request = $http({
      method: 'POST',
      headers: { 'X-Token': deviceStorage.get('user').Token},
      url: APP_URL_NEW+'colaborador/EditarServico',
      data: JSON.stringify(requestData)
    }).success(callback).error(callback);
  };

  this.registrarQuimica = function(requestData, callback) {
    var request = $http({
      method: 'POST',
      headers: { 'X-Token': deviceStorage.get('user').Token},
      url: APP_URL_NEW+'colaborador/RegistrarQuimica',
      data: JSON.stringify(requestData)
    }).success(callback).error(callback);
  };

  this.ConsultarListaRegistroQuimicas = function(requestData, callback) {
    var request = $http({
      method: 'POST',
      headers: { 'X-Token': deviceStorage.get('user').Token},
      url: APP_URL_NEW+'colaborador/ConsultarListaRegistroQuimicas',
      data: JSON.stringify(requestData)
    }).success(callback).error(callback);
  };

  // this.ExcluirQuimica = function(requestData, callback) {
  //   var request = $http({
  //     method: 'POST',
  //     headers: { 'X-Token': deviceStorage.get('user').Token},
  //     url: APP_URL+'colaborador/ExcluirQuimica',
  //     data: JSON.stringify(requestData)
  //   }).success(callback).error(callback);
  // };

  this.ConsultarHistoricoFichaAnotacoesDoCliente = function(codigoCliente, callback) {
    return $http({
      method: 'GET',
      headers: { 'X-Token': deviceStorage.get('user').Token},
      url: APP_URL_NEW+'colaborador/ConsultarHistoricoFichaAnotacoesDoClienteV2/'+codigoCliente
    });//.success(callback).error(callback);

  };


  this.ConsultarProdutoPorDescricaoCodigo = function(requestData) {
    return $http({
      method: 'POST',
      headers: { 'X-Token': deviceStorage.get('user').Token},
      url: APP_URL_NEW+'colaborador/ConsultarProdutoPorDescricaoCodigo/',
      data: JSON.stringify(requestData)
    });
  };

  this.ConsultarServicoPorDescricao = function(requestData){
    return $http({
      method: 'POST',
      headers: { 'X-Token': deviceStorage.get('user').Token},
      url: APP_URL_NEW+'colaborador/ConsultarServicoPorDescricao/',
      data: JSON.stringify(requestData)
    });
  };

  this.NomeAutoComplete = function(parametroDigitado, callback) {
    $http({
      method: 'GET',
      headers: {
        'X-Token': deviceStorage.get('user').Token
      },
      url: APP_URL + 'colaborador/ConsultarListaDeClientes/'+parametroDigitado
    }).success(callback).error(callback);
  };

  this.RetornaMediaProfissional = function(requestData, callback) {
    $http({
      method: 'POST',
      headers: {
        'X-Token': deviceStorage.get('user').Token
      },
      url: APP_URL_NEW + 'colaborador/RetornaMediaProfissional',
      // url: 'http://onebetaservice-api.azurewebsites.net/api/Colaborador/RetornaMediaProfissional',
      data: JSON.stringify(requestData)
    }).success(callback).error(callback);
  };

}]);
