// Note: because 'requires' is not specified below the module is being 'extended'
// angular.module(name[, requires], configFn);
var services = angular.module('app.services');

services.service('deviceStorage', ['$window', '$localForage', function($window, $localForage) {
  var vm = this;

  this.init = function () {

    if (vm.initPromisse) return vm.initPromisse;

    return vm.initPromisse = $localForage.getItem('session')
      .then(function(data) {
        vm.session = data || {};

        // if (data) {
          for (var key in data) {
            $window.localStorage.setItem(key, JSON.stringify(data[key]));
          }
        // }

        return data;
      });
  }


  this.put = function(key, value) {
    return this.init()
      .then(function () {
        $window.localStorage.setItem(key, JSON.stringify(value));

        vm.session[key] = value;
        $localForage.setItem('session', vm.session);
      });
  };

  this.remove = function(key) {
    this.init()
      .then(function () {
        $window.localStorage.removeItem(key);

        delete vm.session[key];
        $localForage.setItem('session', vm.session);
      });
  };

  this.get = function(key) {
    var valueStr = $window.localStorage.getItem(key);
    return (valueStr !== 'undefined')? JSON.parse(valueStr) : null;
  };

  this.sessionPut = function(key, value) {
    $window.sessionStorage.setItem(key, JSON.stringify(value));
  };

  this.sessionRemove = function(key) {
    $window.sessionStorage.removeItem(key);
  };

  this.sessionGet = function(key) {
    var valueStr = $window.sessionStorage.getItem(key);
    return (valueStr !== 'undefined')? JSON.parse(valueStr) : null;
  };


  this.clearLocalStorage = function() {
    $window.localStorage.clear();
  };

  this.clearSessionStorage = function() {
    $window.sessionStorage.clear();
  };

}]);
