var services = angular.module('app.services');

services.service('SaloesApi', [ '$http', '$q', '$cacheFactory', 'deviceStorage', 'APP_URL_NEW',
  function ($http, $q, $cacheFactory, deviceStorage, APP_URL_NEW  ) {

  var me = this;

  this.markersCache = [];

  this.getAdressPoints = function(callback, error) {
    if (!me.saloes) {
      var request = $http({
        method: 'GET',
        url: APP_URL_NEW+'empresas/gets',
      }).success(function(data, status){

        if (!data) {
          return error && error(data);
        }

        deviceStorage.put('saloes', data);
        me.saloes = data;

        for ( var s in data.Retorno ) {
          me.markersCache[data.Retorno[s].GoogleId] = data.Retorno[s];
        }

        callback && callback(data);
      }).error(error || callback);
    } else {
      callback(deviceStorage.get('saloes'));
    }
  };

  this.getSaloes = function(callback,error) {
    var request = $http({
      method: 'GET',
      url: APP_URL_NEW+ 'empresas/gets',
      
    }).success(callback).error(callback);
  };

  function loadScript( url , callback ) {
    var oHead = document.getElementsByTagName('HEAD').item(0);
    var oScript= document.createElement("script");
    oScript.onload = oScript.onreadystatechange = function (e) {
        // console.log(e);
    };
    // oScript.async = "async";
    oScript.defer = "defer";
    oScript.type = "text/javascript";
    oScript.src = url;
    oHead.appendChild( oScript);
  }

  this.getAdressPointsGoogle = function( location , pagetoken , callback ) {

    // Nao utilizar o servico Places - Nearby Search
    // https://developers.google.com/places/web-service/usage-and-billing

    /*var service = new google.maps.places.PlacesService(document.createElement('div'));

    service.nearbySearch({
        location  : new google.maps.LatLng( location[0] , location[1] ),
        // bounds : new google.maps.LatLngBounds(),
        // radius : 500,
        rankBy: google.maps.places.RankBy.DISTANCE,
        types : ['beauty_salon'],
        // keyword  : 'salão de beleza',
        pagetoken : pagetoken,
        // key: 'AIzaSyDJ78GI2EVNpsTAxd3gYZThE4V_IKzWzAU'
        key: 'AIzaSyCKQmK2bgnaTm7VYLNNaq09Ltuyg0g7lug'
        // key : 'AIzaSyAZ6FkgdVWJWtR6DRXFGvNo6KsKxMbFSzs',
        // key : 'AIzaSyDk4G4aT7XOwDt5fOhHIERk5Ji5RKBQwj0',
        // key: 'AIzaSyDk4G4aT7XOwDt5fOhHIERk5Ji5RKBQwj0'
      }, callback);*/

    /*var request = $http({
      method: 'GET',
      url: 'place/nearbysearch/json',//location=-33.8670522,151.1957362&radius=500&types=food&name=cruise&key=AIzaSyAZ6FkgdVWJWtR6DRXFGvNo6KsKxMbFSzs
      params: ({
        location  : location.join(),
        // radius : 5000,
        rankby: 'distance',
        types : 'beauty_salon',
        // keyword  : 'salão de beleza',
        pagetoken : pagetoken,
        // key : 'AIzaSyAZ6FkgdVWJWtR6DRXFGvNo6KsKxMbFSzs',
        key : 'AIzaSyDk4G4aT7XOwDt5fOhHIERk5Ji5RKBQwj0',
      })
    }).success(callback).error(callback);*/

  };

  this.autocomplete = function( location , input , callback ) {

    var service = new google.maps.places.AutocompleteService();
    service.getQueryPredictions({ input: input }, callback);

    /*var request = $http({
      method: 'GET',
      url: 'https://maps.googleapis.com/maps/api/place/autocomplete/json',
      params: ({
        // callback: '?',
        // location  : location.join(),
        input : input,
        // type: 'geocode',
        // key : 'AIzaSyAZ6FkgdVWJWtR6DRXFGvNo6KsKxMbFSzs',
        key : 'AIzaSyDk4G4aT7XOwDt5fOhHIERk5Ji5RKBQwj0',
      })
    }).success(callback).error(callback);*/

  };

  this.getDetails = function( placeid , callback ) {

    // Nao utilizar sem especificar os campos
    // https://developers.google.com/places/web-service/usage-and-billing

    /*var service = new google.maps.places.PlacesService(document.createElement('div'));
    service.getDetails({
        placeId  : placeid,
        key : 'AIzaSyDJ78GI2EVNpsTAxd3gYZThE4V_IKzWzAU',
      }, callback);*/ 

    /*var request = $http({
      method: 'GET',
      url: 'place/details/json',
      params: ({
        placeid  : placeid,
        // key : 'AIzaSyAZ6FkgdVWJWtR6DRXFGvNo6KsKxMbFSzs',
        key : 'AIzaSyDk4G4aT7XOwDt5fOhHIERk5Ji5RKBQwj0',
      })
    }).success(callback).error(callback);*/
  };

}]);
