var statesProvider = angular.module('app.statesProvider');

statesProvider.config(function($stateProvider, $urlRouterProvider) {

  $stateProvider

    .state('client', {
      url: "/client",
      abstract: true,
      templateUrl: "templates/client/menu.html",
      controllers: 'AppCtrl'
    })

    .state('client.dashboard', {
      url: "/dashboard",
      views: {
        'menuContent' :{
          // templateUrl: "templates/client/dashboard.html",
          controller: 'DashboardCtrl'
        }
      },
      cache: false
    })

   

    .state('client.agenda', {
      url: "/agenda",
      views: {
        'menuContent' :{
          templateUrl: "templates/client/agenda.html",
          controller: 'AgendaCtrl'
        }
      },
      cache: false
    })

    .state('client.agendar-servico', {
      url: "/agendar-servico",
      views: {
        'menuContent' :{
          templateUrl: "templates/client/agendar-servico.html",
          controller: 'AgendarCtrl'
        }
      },
      cache: false
    })

    .state('client.editar-agendamento', {
      url: "/editar-agendamento",
      views: {
        'menuContent' :{
          templateUrl: "templates/client/editar-agendamento.html",
          controller: 'EditarAgendaCtrl',
          includes: 'agendamento'
        }
      },
      cache: false
    })

    .state('client.historico', {
      url: "/historico",
      views: {
        'menuContent' :{
          templateUrl: "templates/client/historico.html",
          // controller: 'HistoricoCtrl'
        }
      },
      cache: false
    })

    .state('client.historico-agendamentos', {
      url: "/historico/agendamentos",
      views: {
        'menuContent' :{
          templateUrl: "templates/client/historico/agendamentos.html",
          controller: 'HistoricoCtrl'
        }
      },
      cache: false
    })

    .state('client.historico-servicos', {
      url: "/historico/servicos",
      views: {
        'menuContent' :{
          templateUrl: "templates/client/historico/servicos.html",
          controller: 'HistoricoServicosCtrl'
        }
      },
      cache: false
    })

    .state('client.historico-produtos', {
      url: "/historico/produtos",
      views: {
        'menuContent' :{
          templateUrl: "templates/client/historico/produtos.html",
          controller: 'HistoricoProdutosCtrl'
        }
      },
      cache: false
    })

    .state('client.previa', {
      url: "/previa",
      views: {
        'menuContent' :{
          templateUrl: "templates/client/previa.html",
          controller: 'PreviaGastosCtrl'
        }
      },
      cache: false
    })

    .state('client.previa-servicos', {
      url: "/previa/servicos",
      views: {
        'menuContent' :{
          templateUrl: "templates/client/previa/servicos.html",
          controller: 'PreviaGastosCtrl',
        }
      },
      cache: false
    })

    .state('client.previa-produtos', {
      url: "/previa/produtos",
      views: {
        'menuContent' :{
          templateUrl: "templates/client/previa/produtos.html",
          controller: 'PreviaGastosCtrl',
        }
      },
      cache: false
    })

    .state('client.pontos-fidelidade', {
      url: "/pontos-fidelidade",
      views: {
        'menuContent' :{
          templateUrl: "templates/client/pontos-fidelidade.html",
          controller: 'PontosFidelidadeCtrl'
        }
      },
      cache: false
    })

    .state('client.perfil', {
      url: "/perfil",
      views: {
        'menuContent' :{
          templateUrl: "templates/client/perfil.html",
          controller: 'PerfilCtrl'
        }
      },
      cache: false
    })

    .state('client.sobre', {
      url: "/sobre",
      views: {
        'menuContent' :{
          templateUrl: "templates/client/sobre.html",
          controller: function( $scope , $ionicPopup ) {



            // $scope.sobre = function() {
            //   $ionicPopup.show({
            //     templateUrl: 'templates/sobre.html',
            //     title : 'Sobre',
            //     cssClass: 'sobre-popup',
            //     buttons: [{ // Array[Object] (optional). Buttons to place in the popup footer.
            //       text: 'Fechar',
            //       type: 'button-positive',
            //       onTap: function(e) {
            //         // e.preventDefault() will stop the popup from closing when tapped.
            //         // e.preventDefault();
            //       }
            //     }]/*,
            //     scope : {
            //       salao : $scope.salao
            //     }*/
            //   });
            // };
          }
        }
      },
      cache: false
    });

});
