var statesProvider = angular.module('app.statesProvider');

statesProvider.config(function($stateProvider, $urlRouterProvider) {

  $stateProvider

    .state('contributor', {
      url: '/contributor',
      abstract: true,
      templateUrl: 'templates/contributor/menu.html',
      controller: 'contributor.ContributorCtrl'
    })

    .state('contributor.dashboard', {
      url: '/dashboard',
      views: {
        'menuContent': {
          // templateUrl: 'templates/contributor/dashboard.html',
          controller: 'contributor.DashboardCtrl'
        }
      },
      cache: false
    })

    .state('contributor.agenda', {
      url: '/agenda',
      views: {
        'menuContent': {
          templateUrl: 'templates/contributor/agenda.html',
          controller: 'contributor.AgendaCtrl'
        }
      },
      cache: false
    })

    .state('contributor.editar-agendamento', {
      url: '/editar-agendamento',
      views: {
        'menuContent': {
          templateUrl: 'templates/contributor/agenda/editar-agendamento.html',
          controller: 'contributor.EditarAgendaCtrl'
          // controller: function ($scope, $stateParams) {
          //   $scope.event = $stateParams;
          // }
        }
      },
      params: {
          event: null
      },
      cache: false
    })

    .state('contributor.produtos-cliente', {
      url: '/produtos-cliente',
      views: {
        'menuContent': {
          templateUrl: 'templates/contributor/produtos/cliente.html',
          controller: 'contributor.ProdutosCtrl'
        }
      },
      cache: false
    })

    .state('contributor.produtos-produto', {
      url: '/produtos-produto',
      views: {
        'menuContent': {
          templateUrl: 'templates/contributor/produtos/produto.html',
          controller: 'contributor.ProdutosProdutoCtrl'
        }
      },
      cache: false
    })

    .state('contributor.produtos-resumo', {
      url: '/produtos-resumo',
      views: {
        'menuContent': {
          templateUrl: 'templates/contributor/produtos/resumo.html',
          controller: 'contributor.ProdutosResumoCtrl'
        }
      },
      cache: false
    })

    .state('contributor.servicos-cliente', {
      url: '/servicos-cliente',
      views: {
        'menuContent': {
          templateUrl: 'templates/contributor/servicos/cliente.html',
          controller: 'contributor.ServicosCtrl'
        }
      },
      cache: false
    })

    .state('contributor.servicos-servico', {
      url: '/servicos-servico',
      views: {
        'menuContent': {
          templateUrl: 'templates/contributor/servicos/servico.html',
          controller: 'contributor.ServicosServicoCtrl'
        }
      },
      cache: false
    })

    .state('contributor.servicos-auxiliar', {
      url: '/servicos-auxiliar',
      views: {
        'menuContent': {
          templateUrl: 'templates/contributor/servicos/auxiliar.html',
          controller: 'contributor.ServicosAuxiliarCtrl'
        }
      },
      cache: false
    })

    .state('contributor.servicos-quimica', {
      url: '/servicos-quimica',
      views: {
        'menuContent': {
          templateUrl: 'templates/contributor/servicos/quimica.html',
          controller: 'contributor.ServicosQuimicaCtrl'
        }
      },
      cache: false
    })

    .state('contributor.servicos-resumo', {
      url: '/servicos-resumo',
      views: {
        'menuContent': {
          templateUrl: 'templates/contributor/servicos/resumo.html',
          controller: 'contributor.ServicosResumoCtrl'
        }
      },
      cache: false
    })

    .state('contributor.relatorios', {
      url: '/relatorios',
      // abstract: true, //template: '<ui-view/>',
      views: {
        'menuContent': {
          templateUrl: 'templates/contributor/relatorios.html',
          controller: 'contributor.RelatoriosCtrl'
        }
      },
      cache: false
    })

    .state('contributor.relatorios-faturamento', {
      url: '/faturamento',
      views: {
        'menuContent': {
          templateUrl: 'templates/contributor/relatorios/faturamento.html',
          controller: 'contributor.RelatoriosFaturamentoCtrl'
        }
      },
      cache: false
    })

    .state('contributor.relatorios-detalhado', {
      url: '/detalhado',
      views: {
        'menuContent': {
          templateUrl: 'templates/contributor/relatorios/detalhado.html',
          controller: 'contributor.RelatoriosDetalhadoCtrl'
        }
      },
      cache: false
    })

    .state('contributor.relatorios-comissoes', {
      url: '/comissoes',
      views: {
        'menuContent': {
          templateUrl: 'templates/contributor/relatorios/comissoes.html',
          controller: 'contributor.RelatoriosComissoesCtrl'
        }
      },
      cache: false
    })

    .state('contributor.perfil', {
      url: '/perfil',
      views: {
        'menuContent' :{
          templateUrl: 'templates/client/perfil.html',
          controller: 'PerfilCtrl'
        }
      },
      cache: false
    })

    .state('contributor.historico-anotacoes-do-cliente', {
      url: '/historicoDeAnotacoesDoCliente',
      views: {
        'menuContent' :{
          // templateUrl: 'templates/contributor/historico/anotacoes/historico.html',
          template: '<ion-nav-view></ion-nav-view>',
          controller: 'contributor.historico.fichaAnotacoesClienteViewCtrl'
        }
      },
      cache: false
    })
    .state('contributor.historico-anotacoes-do-cliente.cliente', {
      url: '/cliente',
      // views: {
      //   'historico-anotacoes' :{
          templateUrl: 'templates/contributor/historico/anotacoes/cliente.html',
          controller: 'contributor.historico.fichaAnotacoesClienteView.clienteCtrl',
      //   }
      // },
      // cache: false
    })
    .state('contributor.historico-anotacoes-do-cliente.anotacoes', {
      url: '/anotacoes/:ClienteID',
      resolve: {
        cliente: function ($stateParams, ColaboradorApi, $ionicLoading) {
          $ionicLoading.show();
          return ColaboradorApi.ConsultarHistoricoFichaAnotacoesDoCliente($stateParams.ClienteID)
            .then(function (result) {
              $ionicLoading.hide();
              return result.data.Retorno;
            })
        }
      },
      // views: {
      //   'menuContent' :{
          templateUrl: 'templates/contributor/historico/anotacoes/anotacoes.html',
          // templateUrl: 'templates/contributor/servicos/servico.html',
          controller: 'contributor.historico.fichaAnotacoesClienteView.anotacoesCtrl',
      //   }
      // },
      cache: false
    })

    .state('contributor.agenda-marcar-servico', {
      url: '/agendaMarcarServico?data&hora',
      params: {
          // here we define default value for foo
          // we also set squash to false, to force injecting
          // even the default value into url
          data: {},
          hora: {},
          // this param is not part of url
          // it could be passed with $state.go or ui-sref
          hiddenParam: 'YES',
        },
      views: {
        'menuContent' :{
          templateUrl: 'templates/contributor/agenda/agendar-servico.html',
          controller: 'contributor.AgendaMarcarCtrl'
        }
      },
      cache: false
    })

    .state('contributor.agenda-bloquear-horario', {
      url: '/agendaBloquearHorario?data&horaInicial&horaFinal',

      params: {
          // here we define default value for foo
          // we also set squash to false, to force injecting
          // even the default value into url
          data: {},
          horaInicial: {},
          horaFinal: {},
          // this param is not part of url
          // it could be passed with $state.go or ui-sref
          hiddenParam: 'YES',
        },
      views: {
        'menuContent' :{
          templateUrl: 'templates/contributor/agenda/bloquearHorario.html',
          controller: 'contributor.AgendaBloquearHorarioCtrl'
        }
      },
      cache: false
    })
    ;
});
