var statesProvider = angular.module('app.statesProvider');

statesProvider.config(function($stateProvider, $urlRouterProvider) {

  $stateProvider

    .state('manager', {
      url: "/manager",
      abstract: true,
      templateUrl: "templates/manager/menu.html",
      controller: 'manager.AppCtrl',
      cache: false
    })

    .state('manager.dashboard', {
      url: "/dashboard",
      views: {
        'menuContent' :{
          templateUrl: "templates/manager/dashboard.html",
          controller: 'manager.DashboarCtrl'
        }
      },
      cache: false
    })

    .state('manager.agenda', {
      url: '/agenda',
      views: {
        'menuContent': {
          templateUrl: 'templates/contributor/agenda.html',
          controller: 'contributor.AgendaCtrl'
        }
      },
      cache: false
    })

    .state('manager.receitas', {
      url: "/receitas",
      views: {
        'menuContent' :{
          templateUrl: "templates/manager/receitas.html",
          controller: 'manager.ReceitasCtrl'
        }
      },
      cache: false
    })

    .state('manager.receitas-apuradas', {
      url: "/receitas/apuradas",
      views: {
        'menuContent' :{
          templateUrl: "templates/manager/receitas/apuradas.html",
          controller: 'manager.receitas.ApuradasCtrl'
        }
      },
      cache: false
    })

    .state('manager.receitas-clientes', {
      url: "/receitas/clientes",
      views: {
        'menuContent' :{
          templateUrl: "templates/manager/receitas/clientes.html",
          controller: 'manager.receitas.ClientesCtrl'
        }
      },
      cache: false
    })

    .state('manager.receitas-estimadas', {
      url: "/receitas/estimadas",
      views: {
        'menuContent' :{
          templateUrl: "templates/manager/receitas/estimadas.html",
          controller: 'manager.receitas.EstimadasCtrl'
        }
      },
      cache: false
    })

    .state('manager.servicos', {
      url: "/servicos",
      views: {
        'menuContent' :{
          templateUrl: "templates/manager/servicos.html",
          controller: 'manager.ServicosCtrl'
        }
      },
      cache: false
    })

    .state('manager.produtos', {
      url: "/produtos",
      views: {
        'menuContent' :{
          templateUrl: "templates/manager/produtos.html",
          controller: 'manager.ProdutosCtrl'
        }
      },
      cache: false
    })

    .state('manager.colaboradores', {
      url: "/colaboradores",
      views: {
        'menuContent' :{
          templateUrl: "templates/manager/colaboradores.html",
          controller: 'manager.ColaboradoresCtrl'
        }
      },
      cache: false
    })

    .state('manager.colaboradores-faturamento', {
      url: "/colaboradores/faturamento",
      views: {
        'menuContent' :{
          templateUrl: "templates/manager/colaboradores/faturamento.html",
          controller: 'manager.colaboradores.FaturamentoCtrl'
        }
      },
      cache: false
    })

    .state('manager.colaboradores-lucratividade', {
      url: "/colaboradores/lucratividade",
      views: {
        'menuContent' :{
          templateUrl: "templates/manager/colaboradores/lucratividade.html",
          controller: 'manager.colaboradores.LucratividadeCtrl'
        }
      },
      cache: false
    })

    .state('manager.colaboradores-lucratividade-geral', {
      url: "/colaboradores/lucratividade-geral",
      views: {
        'menuContent' :{
          templateUrl: "templates/manager/colaboradores/lucratividade-geral.html",
          controller: 'manager.colaboradores.LucratividadeGeralCtrl'
        }
      },
      cache: false
    })

    .state('manager.perfil', {
      url: "/perfil",
      views: {
        'menuContent' :{
          templateUrl: "templates/client/perfil.html",
          controller: 'PerfilCtrl'
        }
      },
      cache: false
    })

    ;

});
